package com.nerthus.proisys.bundles;

import java.util.*;
import javax.swing.*;
import com.nerthus.proisys.pps.kernel.*;
import com.nerthus.appkit.*;
import com.nerthus.appkit.table.*;
import com.nerthus.proisys.pps.*;
/**
 * Werkzeug zum Auslastungsabgleich.
 * 
 * @author: R.Bohlig
 */
 
public class Auslastung extends com.nerthus.proisys.pps.NEController
implements NEDialogDelegate {
	static int hp = 30;
	static int wp = 5;

	private QAController myQAContr = null;
	private ListController myListContr = null;

	private JFrame myAPanel = null;

	private NETableBrowser myABrowser;
	private NETableBrowser myAMatBrowser;
		
	private NEComboBox myMorW;
	private NEComboBox myAArt;
	
	private NECheckBox myAOptAusl;
	private NECheckBox myAOptAuslSchicht;
	private NECheckBox myAOptSchicht;

	private NEButton myAListButton;
	
	private NETextField myAQPZABez;
	private NETextField myAZPZABez;
	private NENumberTextField myAQPZA;
	private NENumberTextField myAZPZA;
	private NEScrollBar myAQPZASlider;
	private NEScrollBar myAZPZASlider;
	private NENumberTextField myAQSchicht;
	private NENumberTextField myAZSchicht;
	private NENumberTextField myAQZAh;
	private NENumberTextField myAZZAh;
	private NEScrollBar myAQSchichtPM;
	private NEScrollBar myAZSchichtPM;
	private NENumberTextField myAQMaschA;
	private NENumberTextField myAZMaschA;
	private NENumberTextField myAQMaeA;
	private NENumberTextField myAZMaeA;
	private NENumberTextField myAQFraA;
	private NENumberTextField myAZFraA;
	private NENumberTextField myAQMM;
	private NENumberTextField myAZMM;
	private NENumberTextField myAQQA;
	private NENumberTextField myAZQA;
	private NENumberTextField myAQmsA;
	private NENumberTextField myAZmsA;
	private NENumberTextField myAQOut;
	private NENumberTextField myAZOut;
	private JLabel myOEPBez;
	private JLabel myOELBez;
	private NENumberTextField myALHB;
	private NENumberTextField myALMB;
	private NENumberTextField myALRWB;
	private NENumberTextField myALIRW;
	private NENumberTextField myALRW;
	private NENumberTextField myALVP;
	private NENumberTextField myALSB;
	private NENumberTextField myALIB;
	private NENumberTextField myALAB;
	private NENumberTextField myALIn;
	private NENumberTextField myALOut;
	
	private NEButton myAVPButton;
	private NEButton myAVUndoButton;	
	private NENumberTextField myBelast;
	private NENumberTextField myEntlast;
	private NENumberTextField myVMenge;
	private NENumberTextField myVProzent;
	private NEScrollBar myVPSlider;

	// private int currentRow, currentZCol, currentACol, maxRow, maxCol;

	private int aart;			/* 0 Masch, 1 Mae, 2 Fra */
	private int listmod;		/* 0 Ausl, 1 Ausl/Schicht, 2 Schicht */
	private boolean  WorM;		/* YES = Monat */
	private int currentAOE;
	private OrganisationsEinheit currentOEP;
	private int anzahlOEP;
	private int currentAPZA;
	private int currentZPZA;
	private int currentAMat;
	private double currentVProzent;
	private double currentVMenge;
	private double correctVMenge;
	

	class AMatData {
	  	public ProduktionsElement pe = null;
	  	public LagerElement le = null;
	};

	private Vector theAMatList = null;
	private AMatData currentAMD = null;

	private double undoVP[] = new double[maxPZA];
	private int undoZPZA;
	private int undoAPZA;
	private LagerElement undoLE;
	private boolean UNDO;

/**
 * Auslastung constructor comment.
 * @param resfile java.lang.String
 */
public Auslastung(String resfile) {
	super(resfile);

}
/**
 * Auslastung constructor comment.
 * @param resfile java.lang.String
 * @param resfile com.nerthus.proisys.NEMainController
 */
public Auslastung(String resfile, NEMainController mc) {
	super(resfile, mc);

}
public void amatbrowserClick(NEDialogElement sender)
{
	int index;
	
	if(sender == myAMatBrowser) {
		index = myAMatBrowser.selectedRow();
		if(theAMatList.size() > 0) {
			currentAMD = (AMatData) theAMatList.elementAt(index);
			currentAMat = index;
			myAMatBrowser.selectRows(currentAMat, currentAMat);
		} else { 
			currentAMD = null;
			currentAMat = -1;
		}

	}
	this.loadQMat();
	this.loadQParameter();
	this.loadZMat();
	this.loadZParameter();
	
}
public void browserClick(NEDialogElement sender)
{
	int index;
	if(sender == myABrowser) {
		index = myABrowser.selectedRow();
		if(index != currentAOE) {
			currentOEP = myUModell.getOEByIndex(index);
			myOEPBez.setText((currentOEP.oeschl() + " " + currentOEP.bezeichnung()));
		}
		
		index = myABrowser.selectedColumn();
		
		if(index != -1) {
			if(index == 0) { index = 1; }
			if(WorM) {
				currentAPZA = maxWeek + index;
				currentZPZA = maxWeek + index - 1;
			}
			else {
				currentAPZA = index;
				currentZPZA = index - 1;
			}
		}

		this.changePZA();
	
		this.loadAMatBrowser(); 
	
		if(theAMatList.size() > 0) {
			currentAMD = (AMatData) theAMatList.elementAt(0);
			currentAMat = 0;
			myAMatBrowser.selectRows(currentAMat, currentAMat);
		} else { 
			currentAMD = null;
			currentAMat = -1;
		}
		this.loadQMat();
		this.loadQParameter();
		this.loadZMat();
		this.loadZParameter();

	}

}
public void changeAArt(NEDialogElement sender)
{
	
	String mode = myAArt.getSelectedItem();
	if(mode.equals("Maschinen")) {
		aart = 0;
		this.loadBrowser();
		return;
	}
	if(mode.equals("Mnner")) {
		aart = 1;
		this.loadBrowser();
		return;
	}
	if(mode.equals("Frauen")) {
		aart = 2;
		this.loadBrowser();
		return;
	}
	return;
}
public void changeALParameter(NEDialogElement sender)
{
	double x, y, z, w;
	if(sender == myALHB) {
		if(currentAMD != null) {
			x = myALHB.doubleValue();
			if(x >= 0) {
				z = currentAMD.le.vorprod(currentZPZA);
				w = currentAMD.le.rw_best(currentZPZA);
				z = (z > w) ? z : w;
				if(x < w) { x = w; }
				y = currentAMD.le.minbest(currentZPZA);
				if(x < y) {
					x = currentAMD.le.minbest(currentZPZA);
				}
				currentAMD.le.setMaxbest(x, currentZPZA);
			}
			else {
				currentAMD.le.setMaxbest((-1), currentZPZA);
				myALHB.setStringValue("unendl.");
			}
			mainController.update(false);
		} else { myALHB.setStringValue(""); }
		return;
	}
	
	if(sender == myALMB) {
		if(currentAMD != null) {
			x = myALMB.doubleValue();
			if(x >= 0) {
		 	//	z = currentAMD.le.vorprod:currentZPZA);
		 	//   w = currentAMD.le.rw_best:currentZPZA);
		 	//   z = (z > w) ? z : w;
			 //   if(x > w) { x = w; }
				y = currentAMD.le.maxbest(currentZPZA);
				if(y >= 0) {
					if(x > y) {
						x = currentAMD.le.maxbest(currentZPZA);
					}
				}
				currentAMD.le.setMinbest(x, currentZPZA);
				mainController.update(false);
			} else {
				myALMB.setDoubleValue(currentAMD.le.minbest(currentZPZA));
			}
		} else { myALMB.setStringValue(""); }
		return;
	}
	
	if(sender == myALRW) {
		if(currentAMD != null) {
			x = myALRW.doubleValue();
			if(x >= 0) {
				currentAMD.le.setReichw(x, currentZPZA);
				mainController.update(false);
			} else {
				myALRW.setDoubleValue(currentAMD.le.reichw(currentZPZA));
			}
		} else { myALRW.setStringValue(""); }
		return;
	}
	
	if(sender == myALVP) {
		if(currentAMD != null) {
			x = myALVP.doubleValue();
			y = currentAMD.le.maxbest(currentZPZA);
			z = currentAMD.le.minbest(currentZPZA);
			if(x >= 0) {
				if((x > y) && (y >= 0)) { x = y; }
				if(x < z) { x = z; }
				currentAMD.le.setVorprod(x, currentZPZA);
				mainController.update(false);
				return;
			}
			myALVP.setDoubleValue(currentAMD.le.vorprod(currentZPZA)); 
		} else { myALVP.setStringValue(""); }
		return;
	}
	
}
public void changeAMM(NEDialogElement sender)
{
 	double x;
 	if(sender == myAQMM) {
		if(currentAMD != null) {
			x = myAQMM.doubleValue();
			if(x >= 0) {
				currentAMD.pe.setMinmeng(x, currentAPZA);
				mainController.update(false);
			}
			else {
				myAQMM.setDoubleValue(currentAMD.pe.minmeng(currentAPZA));
			}
		}
		else {
			myAQMM.setStringValue("");
		}
		return;
 	}
 	if(sender == myAZMM) {
	 	if(currentAMat >= 0) {
			x = myAZMM.doubleValue();
			if(x >= 0) {
				currentAMD.pe.setMinmeng(x, currentZPZA);
				mainController.update(false);
			}
			else {
				myAZMM.setDoubleValue(currentAMD.pe.minmeng(currentZPZA));
			}
		}
		else {
			myAZMM.setStringValue("");
		}
		return;
 	}

}
public void changeAnzeige(NEDialogElement sender)
{
	if(myAOptAusl.isSelected()) {
		listmod = 0;
		this.loadBrowser();
		return;
	}
	if(myAOptAuslSchicht.isSelected()) {
		listmod = 1;
		this.loadBrowser();
		return;
	}
	if(myAOptSchicht.isSelected()) {
		listmod = 2;
		this.loadBrowser();
		return;
	}
	
	return;
}
public void changeAPZA(NEDialogElement sender)
{
	int a, b, d;

	if(currentOEP != null) {

		if((sender == myAQPZA) || (sender == myAQPZASlider)) {
			if(sender == myAQPZASlider) {

				a = myAQPZASlider.intValue() - 1;
				if(a == currentAPZA) { return; }
				currentAPZA = a;
				if(currentAPZA <= currentZPZA) {
					currentZPZA = currentAPZA -1;
					myAZPZASlider.setIntValue(currentZPZA+1);
					myAZPZA.setIntValue(currentZPZA+1);
					myAZPZABez.setStringValue(myKalender.pzabez(currentZPZA));
					this.loadZMat();
					this.loadZParameter();
				}
				myAQPZA.setIntValue(currentAPZA + 1);
			
			} else {
			
				a = myAQPZA.intValue();
				if((a-1) == currentAPZA) { return; }
				b = myAQPZASlider.minValue();
				d = myAQPZASlider.maxValue();
				if((a < b) || (a > d)) {
					myAQPZA.setIntValue(currentAPZA + 1);
					return;
				}
				currentAPZA = a - 1;
				if(currentAPZA <= currentZPZA) {
					currentZPZA = currentAPZA -1;
					myAZPZA.setIntValue(currentZPZA+1);
					myAZPZASlider.setIntValue(currentZPZA+1);
					myAZPZABez.setStringValue(myKalender.pzabez(currentZPZA));
					this.loadZMat();
					this.loadZParameter();
				}
				myAQPZASlider.setIntValue(currentAPZA+1);			
			}		
			myAQPZABez.setStringValue(myKalender.pzabez(currentAPZA));
			this.loadAMatBrowser();
			if(theAMatList.size() > 0) {
				currentAMD = (AMatData) theAMatList.elementAt(0);
				currentAMat = 0;
				myAMatBrowser.selectRows(currentAMat, currentAMat);
			} else { 
				currentAMD = null;
				currentAMat = -1;
			}
			this.loadQMat();
			this.loadQParameter();
		
		}
		if((sender == myAZPZA) || (sender == myAZPZASlider)) {
			if(sender == myAZPZA) {
				a = myAZPZA.intValue();
				b = myAZPZASlider.minValue();
				d = myAZPZASlider.maxValue();
				if((a < b) || (a > d)) {
					myAZPZA.setIntValue(currentZPZA+1);
					return;
				}
				if((a-1) >= currentAPZA) {
					currentZPZA = currentAPZA - 1;
					myAZPZA.setIntValue(currentZPZA+1);
				}
				else {
					currentZPZA = a - 1;
				}
				myAZPZASlider.setIntValue(currentZPZA+1);
			} else {
				a = myAZPZASlider.intValue();
				if((a-1) >= currentAPZA) {
					currentZPZA = currentAPZA - 1;
					myAZPZASlider.setIntValue(currentZPZA+1);
				}
				else {
					currentZPZA = a - 1;
				}
				myAZPZA.setIntValue(currentZPZA+1);
			}	
			myAZPZABez.setStringValue(myKalender.pzabez(currentZPZA));
			this.loadZMat();
			this.loadZParameter();
		}
	} else {
		currentAPZA = -1;
		currentZPZA = -1;
		this.changePZA();
	}
	return;

}
public void changeAQA(NEDialogElement sender)
{
	double x;
	if(currentAMD == null) {
		myAQQA.setStringValue("");
		myAZQA.setStringValue("");
		return;
	}
		
	int midx = currentAMD.pe.matidx();
	
	if(sender == myAQQA) {
		if(myUModell.sourcecount(midx) > 1) {
			x = myAQQA.doubleValue();
			// Aufruf QA-Dialog
			myQAContr.openQAPanel((x/100), currentAPZA, currentAMD.pe);
			mainController.update(false);
		} else {
			myAQQA.setDoubleValue(currentAMD.pe.quantl(currentAPZA)*100);
		}
		return;
	}
	if(sender == myAZQA) {
		if(myUModell.sourcecount(midx) > 1) {
			x = myAZQA.doubleValue();
			// Aufruf QA-Dialog
			myQAContr.openQAPanel((x/100), currentZPZA, currentAMD.pe);
			mainController.update(false);
		} else {
			myAZQA.setDoubleValue(currentAMD.pe.quantl(currentZPZA)*100);
		}
		return;
	}
}
public void changeAQSchichtig(NEDialogElement sender)
{
	double x;
	int b = 1;

	if(currentOEP == null) { myAQSchicht.setStringValue(""); return; }

	if(sender == myAQSchicht) {	
		b = myAQSchicht.intValue();
		if(b <= 0) { 
			b = 1; 
			myAQSchicht.setIntValue(b);
		}
		if(b >= 4) { 
			b = 3;
			myAQSchicht.setIntValue(b);
		}
		myAQSchichtPM.setIntValue(b);
	}
	if(sender == myAQSchichtPM) {
	
		b = myAQSchichtPM.intValue();
		myAQSchicht.setIntValue(b);
	}
	currentOEP.setSchicht(b, currentAPZA); 
	
	mainController.update(false);
}
public void changeAQZAh(NEDialogElement sender)
{
	int a, b;
	double x;
	if(currentOEP == null) { myAQZAh.setStringValue(""); return; }
	a = currentOEP.schicht(currentAPZA);
	b = myAQZAh.intValue();
	if(WorM) {
		switch(a) {
			case 1:
				if(b > 192) {
					b = 192;
					myAQZAh.setIntValue(b);
				}
				if(b < 0) {
					b = 0;
					myAQZAh.setIntValue(b);
				}
				break;
			case 2:
				if(b > 192) {
					b = 192;
					myAQZAh.setIntValue(b);
				}
				if(b < 0) {
					b = 0;
					myAQZAh.setIntValue(b);
				}
				break;
			case 3:
				if(b > 192) {
					b = 192;
					myAQZAh.setIntValue(b);
				}
				if(b < 0) {
					b = 0;
					myAQZAh.setIntValue(b);
				}
				break;
		}
	}
	else {
		switch(a) {
			case 1:
				if(b > 128) {
					b = 128;
					myAQZAh.setIntValue(b);
				}
				if(b < 0) {
					b = 0;
					myAQZAh.setIntValue(b);
				}
				break;
			case 2:
				if(b > 88) {
					b = 88;
					myAQZAh.setIntValue(b);
				}
				if(b < 0) {
					b = 0;
					myAQZAh.setIntValue(b);
				}
				break;
			case 3:
				if(b > 48) {
					b = 48;
					myAQZAh.setIntValue(b);
				}
				if(b < 0) {
					b = 0;
					myAQZAh.setIntValue(b);
				}
				break;
		}
	}
	if(b == currentOEP.zah(currentAPZA)) { return; }
	currentOEP.setZah(b, currentAPZA);
/*
	x = currentOEP.auslmasch(currentAPZA);
	if(x >= 0) { myAQMaschA.setDoubleValue(x); }
	else { myAQMaschA.setStringValue("unendl."); }
	x = currentOEP.auslmae(currentAPZA);
	if(x >= 0) { myAQMaeA.setDoubleValue(x); }
	else { myAQMaeA.setStringValue("unendl."); }
	x = currentOEP.auslfra(currentAPZA);
	if(x >= 0) { myAQFraA.setDoubleValue(x); }
	else { myAQFraA.setStringValue("unendl."); }
	if(currentAMD != null) {
		x = currentOEP.iMsAusl(currentAMD.pe, currentAPZA);
		if(x < 0) { myAQmsA.setStringValue("unendl."); }
		else { myAQmsA.setDoubleValue(x); }
		if(correctVMenge > 0) {
			x = currentOEP.iMsAMat(currentAMD.pe, correctVMenge, currentAPZA);
			if(x >= 0) { myBelast.setDoubleValue(x); }
			else { myBelast.setStringValue("unendl."); }
		}
	} else {
		myBelast.setStringValue("");
		myEntlast.setStringValue("");
		myAQmsA.setStringValue("");
	}
*/				
	mainController.update(false);
}
public void changeAWMMode(NEDialogElement sender)
{	
	String mode = myMorW.getSelectedItem();
	WorM = mode.equals("Monate");
	if(WorM) {
		UNDO = NO;
	//	[myXSlider setEnabled:YES];
	
		myAQPZASlider.setMinMaxValue((maxWeek+2), maxPZA);
		myAZPZASlider.setMinMaxValue((maxWeek+1), (maxPZA-1));
	}
	else {
		UNDO = NO;
		myAQPZASlider.setMinMaxValue(2, maxWeek);
		myAZPZASlider.setMinMaxValue(1, (maxWeek-1));
	}


	currentAPZA = -1;
	currentZPZA = -1;

	currentAMD = null;
	currentAMat = -1;
	currentAOE = -1;
	currentOEP = null;
			
	myOEPBez.setText("");
	
	this.loadBrowser();
	this.loadAMatBrowser();
	this.changePZA();
	this.loadQMat();
	this.loadQParameter();
	this.loadZMat();
	this.loadZParameter();
	
	return;
}
public void changeAZSchichtig(NEDialogElement sender)
{
	double x;
	int b = 1;

	if(currentOEP == null) { myAZSchicht.setStringValue(""); return; }

	if(sender == myAZSchicht) {	
		b = myAZSchicht.intValue();
		if(b <= 0) { 
			b = 1; 
			myAZSchicht.setIntValue(b);
		}
		if(b >= 4) { 
			b = 3;
			myAZSchicht.setIntValue(b);
		}
		myAZSchichtPM.setIntValue(b);
	}
	if(sender == myAZSchichtPM) {
	
		b = myAZSchichtPM.intValue();
		myAZSchicht.setIntValue(b);
	}
	currentOEP.setSchicht(b, currentZPZA); 
	
	mainController.update(false);
}
public void changeAZZAh(NEDialogElement sender)
{
	int a, b;
	double x;
	if(currentOEP == null) { myAZZAh.setStringValue(""); return; }
	a = currentOEP.schicht(currentZPZA);
	b = myAZZAh.intValue();
	if(WorM) {
		switch(a) {
			case 1:
				if(b > 192) {
					b = 192;
					myAZZAh.setIntValue(b);
				}
				if(b < 0) {
					b = 0;
					myAZZAh.setIntValue(b);
				}
				break;
			case 2:
				if(b > 192) {
					b = 192;
					myAZZAh.setIntValue(b);
				}
				if(b < 0) {
					b = 0;
					myAZZAh.setIntValue(b);
				}
				break;
			case 3:
				if(b > 192) {
					b = 192;
					myAZZAh.setIntValue(b);
				}
				if(b < 0) {
					b = 0;
					myAZZAh.setIntValue(b);
				}
				break;
		}
	}
	else {
		switch(a) {
			case 1:
				if(b > 128) {
					b = 128;
					myAZZAh.setIntValue(b);
				}
				if(b < 0) {
					b = 0;
					myAZZAh.setIntValue(b);
				}
				break;
			case 2:
				if(b > 88) {
					b = 88;
					myAZZAh.setIntValue(b);
				}
				if(b < 0) {
					b = 0;
					myAZZAh.setIntValue(b);
				}
				break;
			case 3:
				if(b > 48) {
					b = 48;
					myAZZAh.setIntValue(b);
				}
				if(b < 0) {
					b = 0;
					myAZZAh.setIntValue(b);
				}
				break;
		}
	}
	if(b == currentOEP.zah(currentZPZA)) { return; }
	currentOEP.setZah(b, currentZPZA);
/*
	x = currentOEP.auslmasch(currentZPZA);
	if(x >= 0) { myAZMaschA.setDoubleValue(x); }
	else { myAZMaschA.setStringValue("unendl."); }
	x = currentOEP.auslmae(currentZPZA);
	if(x >= 0) { myAZMaeA.setDoubleValue(x); }
	else { myAZMaeA.setStringValue("unendl."); }
	x = currentOEP.auslfra(currentZPZA);
	if(x >= 0) { myAZFraA.setDoubleValue(x); }
	else { myAZFraA.setStringValue("unendl."); }
	if(currentAMD != null) {
		x = currentOEP.iMsAusl(currentAMD.pe, currentZPZA);
		if(x < 0) { myAZmsA.setStringValue("unendl."); }
		else { myAZmsA.setDoubleValue(x); }
		if(correctVMenge > 0) {
			x = currentOEP.iMsAMat(currentAMD.pe, correctVMenge, currentZPZA);
			if(x >= 0) { myBelast.setDoubleValue(x); }
			else { myBelast.setStringValue("unendl."); }
		}
	} else {
		myBelast.setStringValue("");
		myEntlast.setStringValue("");
		myAZmsA.setStringValue("");
	}
		
*/		
	mainController.update(false);
}
public void changePZA()
{

	if(currentAPZA != -1) {
		myAQPZASlider.setIntValue(currentAPZA + 1);
		myAQPZA.setIntValue(currentAPZA + 1);
		myAQPZABez.setStringValue(myKalender.pzabez(currentAPZA));
	} else {		
		myAQPZA.setStringValue("");
		myAQPZABez.setStringValue("");
	}
		
	if(currentZPZA != -1) {
		myAZPZASlider.setIntValue(currentZPZA + 1);
		myAZPZA.setIntValue(currentZPZA + 1);
		myAZPZABez.setStringValue(myKalender.pzabez(currentZPZA));
	} else {	
		myAZPZA.setStringValue("");
		myAZPZABez.setStringValue("");
	}

}
public void changeVMenge(NEDialogElement sender)
{
	double x, y;
	if(currentAMD == null) { myVMenge.setStringValue(""); return; }
	x = myVMenge.doubleValue();
	if((x > correctVMenge) || (x < 0)) {
		x = correctVMenge;
		myVMenge.setDoubleValue(correctVMenge);
	}
	myVProzent.setDoubleValue((x/correctVMenge)*100);
	myVPSlider.setDoubleValue((x/correctVMenge)*100);
 	y = currentOEP.iMsAMat(currentAMD.pe, x, currentZPZA);
	if(y >= 0) { myBelast.setDoubleValue(y); }
	else { myBelast.setStringValue("unendl."); }
	y = currentOEP.iMsAMat(currentAMD.pe, x, currentAPZA);
	if(y >= 0) { myEntlast.setDoubleValue(y); }
	else { myEntlast.setStringValue("unendl."); }
	currentVMenge = x;
	return;
}
public void changeVProzent(NEDialogElement sender)
{
	int a;
	double x, y;
	if(currentAMD == null) { myVProzent.setStringValue(""); return; }
	if(sender == myVPSlider) {
		a = myVPSlider.intValue();
		myVProzent.setIntValue(a);
		x = a;
	} else {
		x = myVProzent.doubleValue();
		if((x > 100) || (x < 0)) {
			x = 100;
			myVProzent.setDoubleValue(x);
		}
		myVPSlider.setDoubleValue(x);
	}
	currentVMenge = correctVMenge * (x/100);
	currentVProzent = x;
	y = currentOEP.iMsAMat(currentAMD.pe, currentVMenge, currentZPZA);
	if(y >= 0) { myBelast.setDoubleValue(x); }
	else { myBelast.setStringValue("unendl."); }
	y = currentOEP.iMsAMat(currentAMD.pe, currentVMenge, currentAPZA);
	if(y >= 0) { myEntlast.setDoubleValue(y); }
	else { myEntlast.setStringValue("unendl."); }
	myVMenge.setDoubleValue(currentVMenge);
	return;
}
/**
 * Erzeugung des Auslastungsabgleichs-
 * Fensters.
 * Creation date: (15.12.00 18:51:53)
 */
private void createPanel() {

			javax.swing.JLabel LIconLabel = new javax.swing.JLabel();
			LIconLabel.setName("LIconLabel");
			LIconLabel.setIcon(new javax.swing.ImageIcon(getClass().getResource("/dia.gif")));
			LIconLabel.setText("");
			LIconLabel.setBounds(715, 20, 26, 37);

			javax.swing.JLabel myAAFrauenLabel = new javax.swing.JLabel();
			myAAFrauenLabel.setName("myAAFrauenLabel");
			myAAFrauenLabel.setFont(new java.awt.Font("dialog", 0, 12));
			myAAFrauenLabel.setText("Frauen:");
			myAAFrauenLabel.setBounds(210, 490, 80, 17);
			myAAFrauenLabel.setForeground(java.awt.Color.black);
			myAAFrauenLabel.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);

			javax.swing.JLabel myAAMaennerLabel = new javax.swing.JLabel();
			myAAMaennerLabel.setName("myAAMaennerLabel");
			myAAMaennerLabel.setFont(new java.awt.Font("dialog", 0, 12));
			myAAMaennerLabel.setText("Mnner:");
			myAAMaennerLabel.setBounds(210, 466, 80, 17);
			myAAMaennerLabel.setForeground(java.awt.Color.black);
			myAAMaennerLabel.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);

			javax.swing.JLabel myAAMaschLabel = new javax.swing.JLabel();
			myAAMaschLabel.setName("myAAMaschLabel");
			myAAMaschLabel.setFont(new java.awt.Font("dialog", 0, 12));
			myAAMaschLabel.setText("Maschinen:");
			myAAMaschLabel.setBounds(210, 442, 80, 17);
			myAAMaschLabel.setForeground(java.awt.Color.black);
			myAAMaschLabel.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);

			javax.swing.JLabel myAAMMLabel = new javax.swing.JLabel();
			myAAMMLabel.setName("myAAMMLabel");
			myAAMMLabel.setFont(new java.awt.Font("dialog", 0, 12));
			myAAMMLabel.setText("Mindestmenge:");
			myAAMMLabel.setBounds(195, 600, 95, 17);
			myAAMMLabel.setForeground(java.awt.Color.black);
			myAAMMLabel.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);

			javax.swing.JLabel myAAmsALabel = new javax.swing.JLabel();
			myAAmsALabel.setName("myAAmsALabel");
			myAAmsALabel.setFont(new java.awt.Font("dialog", 0, 12));
			myAAmsALabel.setText("mat.-spez. Ausl.:");
			myAAmsALabel.setBounds(195, 648, 95, 17);
			myAAmsALabel.setForeground(java.awt.Color.black);
			myAAmsALabel.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);

			javax.swing.JLabel myAAOUTLabel = new javax.swing.JLabel();
			myAAOUTLabel.setName("myAAOUTLabel");
			myAAOUTLabel.setFont(new java.awt.Font("dialog", 0, 12));
			myAAOUTLabel.setText("Output:");
			myAAOUTLabel.setBounds(210, 672, 80, 17);
			myAAOUTLabel.setForeground(java.awt.Color.black);
			myAAOUTLabel.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);

			javax.swing.JLabel myAAProzentLabel1 = new javax.swing.JLabel();
			myAAProzentLabel1.setName("myAAProzentLabel1");
			myAAProzentLabel1.setFont(new java.awt.Font("dialog.bold", 1, 12));
			myAAProzentLabel1.setText("%");
			myAAProzentLabel1.setBounds(345, 442, 20, 17);
			myAAProzentLabel1.setForeground(java.awt.Color.black);
			myAAProzentLabel1.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);

			javax.swing.JLabel myAAProzentLabel2 = new javax.swing.JLabel();
			myAAProzentLabel2.setName("myAAProzentLabel2");
			myAAProzentLabel2.setFont(new java.awt.Font("dialog.bold", 1, 12));
			myAAProzentLabel2.setText("%");
			myAAProzentLabel2.setBounds(345, 466, 20, 17);
			myAAProzentLabel2.setForeground(java.awt.Color.black);
			myAAProzentLabel2.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);

			javax.swing.JLabel myAAProzentLabel3 = new javax.swing.JLabel();
			myAAProzentLabel3.setName("myAAProzentLabel3");
			myAAProzentLabel3.setFont(new java.awt.Font("dialog.bold", 1, 12));
			myAAProzentLabel3.setText("%");
			myAAProzentLabel3.setBounds(345, 490, 20, 17);
			myAAProzentLabel3.setForeground(java.awt.Color.black);
			myAAProzentLabel3.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);

			javax.swing.JLabel myAAPZALabel = new javax.swing.JLabel();
			myAAPZALabel.setName("myAAPZALabel");
			myAAPZALabel.setFont(new java.awt.Font("dialog.bold", 1, 12));
			myAAPZALabel.setText("Ausgangs-PZA");
			myAAPZALabel.setBounds(222, 362, 130, 17);
			myAAPZALabel.setForeground(java.awt.Color.black);
			myAAPZALabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);

			javax.swing.JLabel myAAQALabel = new javax.swing.JLabel();
			myAAQALabel.setName("myAAQALabel");
			myAAQALabel.setFont(new java.awt.Font("dialog", 0, 12));
			myAAQALabel.setText("Quellenanteil:");
			myAAQALabel.setBounds(210, 624, 80, 17);
			myAAQALabel.setForeground(java.awt.Color.black);
			myAAQALabel.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);

			javax.swing.JLabel myAASchichtLabel = new javax.swing.JLabel();
			myAASchichtLabel.setName("myAASchichtLabel");
			myAASchichtLabel.setFont(new java.awt.Font("dialog", 0, 12));
			myAASchichtLabel.setText("Schichtigkeit:");
			myAASchichtLabel.setBounds(210, 532, 80, 17);
			myAASchichtLabel.setForeground(java.awt.Color.black);
			myAASchichtLabel.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);

			javax.swing.JLabel myAAuslLabel = new javax.swing.JLabel();
			myAAuslLabel.setName("myAAuslLabel");
			myAAuslLabel.setFont(new java.awt.Font("dialog.bold", 1, 12));
			myAAuslLabel.setText("Auslastung in %");
			myAAuslLabel.setBounds(283, 84, 178, 17);
			myAAuslLabel.setForeground(java.awt.Color.black);
			myAAuslLabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);

			javax.swing.JLabel myAAZAhLabel = new javax.swing.JLabel();
			myAAZAhLabel.setName("myAAZAhLabel");
			myAAZAhLabel.setFont(new java.awt.Font("dialog", 0, 12));
			myAAZAhLabel.setText("ZAh:");
			myAAZAhLabel.setBounds(210, 556, 80, 17);
			myAAZAhLabel.setForeground(java.awt.Color.black);
			myAAZAhLabel.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);

			javax.swing.JLabel myALHBLabel = new javax.swing.JLabel();
			myALHBLabel.setName("myALHBLabel");
			myALHBLabel.setFont(new java.awt.Font("dialog", 0, 12));
			myALHBLabel.setText("Hchstbestand:");
			myALHBLabel.setBounds(385, 600, 95, 17);
			myALHBLabel.setForeground(java.awt.Color.black);
			myALHBLabel.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);

			javax.swing.JLabel myALIBLabel = new javax.swing.JLabel();
			myALIBLabel.setName("myALIBLabel");
			myALIBLabel.setFont(new java.awt.Font("dialog", 0, 12));
			myALIBLabel.setText("Ist-Bestand:");
			myALIBLabel.setBounds(590, 600, 80, 17);
			myALIBLabel.setForeground(java.awt.Color.black);
			myALIBLabel.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);

			javax.swing.JLabel myALINLabel = new javax.swing.JLabel();
			myALINLabel.setName("myALINLabel");
			myALINLabel.setFont(new java.awt.Font("dialog", 0, 12));
			myALINLabel.setText("Input:");
			myALINLabel.setBounds(590, 648, 80, 17);
			myALINLabel.setForeground(java.awt.Color.black);
			myALINLabel.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);

			javax.swing.JLabel myALIRWLabel = new javax.swing.JLabel();
			myALIRWLabel.setName("myALIRWLabel");
			myALIRWLabel.setFont(new java.awt.Font("dialog", 0, 12));
			myALIRWLabel.setText("Ist-Reichw.:");
			myALIRWLabel.setBounds(590, 696, 80, 17);
			myALIRWLabel.setForeground(java.awt.Color.black);
			myALIRWLabel.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);	

			javax.swing.JLabel myALMBLabel = new javax.swing.JLabel();
			myALMBLabel.setName("myALMBLabel");
			myALMBLabel.setFont(new java.awt.Font("dialog", 0, 12));
			myALMBLabel.setText("Mindestbestand:");
			myALMBLabel.setBounds(385, 624, 95, 17);
			myALMBLabel.setForeground(java.awt.Color.black);
			myALMBLabel.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);

			javax.swing.JLabel myOELBezLabel = new javax.swing.JLabel();
			myOELBezLabel.setName("myOELBezLabel");
			myOELBezLabel.setFont(new java.awt.Font("dialog.bold", 0, 12));
			myOELBezLabel.setText("gelagert in OEL:");
			myOELBezLabel.setBounds(385, 550, 95, 17);
			myOELBezLabel.setForeground(java.awt.Color.black);
			myOELBezLabel.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);

			javax.swing.JLabel myALRWBLabel = new javax.swing.JLabel();
			myALRWBLabel.setName("myALRWBLabel");
			myALRWBLabel.setFont(new java.awt.Font("dialog", 0, 12));
			myALRWBLabel.setText("Reichw.-best.:");
			myALRWBLabel.setBounds(385, 672, 95, 17);
			myALRWBLabel.setForeground(java.awt.Color.black);
			myALRWBLabel.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);

			javax.swing.JLabel myALRWLabel = new javax.swing.JLabel();
			myALRWLabel.setName("myALRWLabel");
			myALRWLabel.setFont(new java.awt.Font("dialog", 0, 12));
			myALRWLabel.setText("Soll-Reichw.:");
			myALRWLabel.setBounds(400, 696, 80, 17);
			myALRWLabel.setForeground(java.awt.Color.black);
			myALRWLabel.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);

			javax.swing.JLabel myALVPLabel = new javax.swing.JLabel();
			myALVPLabel.setName("myALVPLabel");
			myALVPLabel.setFont(new java.awt.Font("dialog", 0, 12));
			myALVPLabel.setText("Vorproduktion:");
			myALVPLabel.setBounds(400, 648, 80, 17);
			myALVPLabel.setForeground(java.awt.Color.black);
			myALVPLabel.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);

			javax.swing.JLabel myAVBelastLabel = new javax.swing.JLabel();
			myAVBelastLabel.setName("myAVBelastLabel");
			myAVBelastLabel.setFont(new java.awt.Font("dialog", 0, 12));
			myAVBelastLabel.setText("Belastung:");
			myAVBelastLabel.setBounds(562, 487, 70, 17);
			myAVBelastLabel.setForeground(java.awt.Color.black);
			myAVBelastLabel.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);

			javax.swing.JLabel myAVEntlastLabel = new javax.swing.JLabel();
			myAVEntlastLabel.setName("myAVEntlastLabel");
			myAVEntlastLabel.setFont(new java.awt.Font("dialog", 0, 12));
			myAVEntlastLabel.setText("Entlastung:");
			myAVEntlastLabel.setBounds(562, 511, 70, 17);
			myAVEntlastLabel.setForeground(java.awt.Color.black);
			myAVEntlastLabel.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);

			javax.swing.JLabel myAVerschiebLabel = new javax.swing.JLabel();
			myAVerschiebLabel.setName("myAVerschiebLabel");
			myAVerschiebLabel.setFont(new java.awt.Font("dialog.bold", 1, 12));
			myAVerschiebLabel.setText("Lastabgleich:");
			myAVerschiebLabel.setBounds(390, 362, 90, 17);
			myAVerschiebLabel.setForeground(java.awt.Color.black);
			myAVerschiebLabel.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);

			javax.swing.JLabel myAVMengeLabel = new javax.swing.JLabel();
			myAVMengeLabel.setName("myAVMengeLabel");
			myAVMengeLabel.setFont(new java.awt.Font("dialog", 0, 12));
			myAVMengeLabel.setText("Versch.-Menge:");
			myAVMengeLabel.setBounds(385, 487, 85, 17);
			myAVMengeLabel.setForeground(java.awt.Color.black);
			myAVMengeLabel.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);

			javax.swing.JLabel myAVProzentLabel = new javax.swing.JLabel();
			myAVProzentLabel.setName("myAVProzentLabel");
			myAVProzentLabel.setFont(new java.awt.Font("dialog.bold", 1, 12));
			myAVProzentLabel.setText("%");
			myAVProzentLabel.setBounds(524, 511, 20, 17);
			myAVProzentLabel.setForeground(java.awt.Color.black);
			myAVProzentLabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);

			javax.swing.JLabel myAZFrauenLabel = new javax.swing.JLabel();
			myAZFrauenLabel.setName("myAZFrauenLabel");
			myAZFrauenLabel.setFont(new java.awt.Font("dialog", 0, 12));
			myAZFrauenLabel.setText("Frauen:");
			myAZFrauenLabel.setBounds(20, 490, 80, 17);
			myAZFrauenLabel.setForeground(java.awt.Color.black);
			myAZFrauenLabel.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);

			javax.swing.JLabel myAZMaschLabel = new javax.swing.JLabel();
			myAZMaschLabel.setName("myAZMaschLabel");
			myAZMaschLabel.setFont(new java.awt.Font("dialog", 0, 12));
			myAZMaschLabel.setText("Maschinen:");
			myAZMaschLabel.setBounds(20, 442, 80, 17);
			myAZMaschLabel.setForeground(java.awt.Color.black);
			myAZMaschLabel.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);

			javax.swing.JLabel myAZMaennerLabel = new javax.swing.JLabel();
			myAZMaennerLabel.setName("myAZMaennerLabel");
			myAZMaennerLabel.setFont(new java.awt.Font("dialog", 0, 12));
			myAZMaennerLabel.setText("Mnner:");
			myAZMaennerLabel.setBounds(20, 466, 80, 17);
			myAZMaennerLabel.setForeground(java.awt.Color.black);
			myAZMaennerLabel.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);

			javax.swing.JLabel myAZMMLabel = new javax.swing.JLabel();
			myAZMMLabel.setName("myAZMMLabel");
			myAZMMLabel.setFont(new java.awt.Font("dialog", 0, 12));
			myAZMMLabel.setText("Mindestmenge:");
			myAZMMLabel.setBounds(5, 600, 95, 17);
			myAZMMLabel.setForeground(java.awt.Color.black);
			myAZMMLabel.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);

			javax.swing.JLabel myAZOUTLabel = new javax.swing.JLabel();
			myAZOUTLabel.setName("myAZOUTLabel");
			myAZOUTLabel.setFont(new java.awt.Font("dialog", 0, 12));
			myAZOUTLabel.setText("Output:");
			myAZOUTLabel.setBounds(20, 672, 80, 17);
			myAZOUTLabel.setForeground(java.awt.Color.black);
			myAZOUTLabel.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);

			javax.swing.JLabel myAZProzentLabel1 = new javax.swing.JLabel();
			myAZProzentLabel1.setName("myAZProzentLabel1");
			myAZProzentLabel1.setFont(new java.awt.Font("dialog.bold", 1, 12));
			myAZProzentLabel1.setText("%");
			myAZProzentLabel1.setBounds(155, 442, 20, 17);
			myAZProzentLabel1.setForeground(java.awt.Color.black);
			myAZProzentLabel1.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);

			javax.swing.JLabel myAZProzentLabel2 = new javax.swing.JLabel();
			myAZProzentLabel2.setName("myAZProzentLabel2");
			myAZProzentLabel2.setFont(new java.awt.Font("dialog.bold", 1, 12));
			myAZProzentLabel2.setText("%");
			myAZProzentLabel2.setBounds(155, 466, 20, 17);
			myAZProzentLabel2.setForeground(java.awt.Color.black);
			myAZProzentLabel2.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);

			javax.swing.JLabel myAZProzentLabel3 = new javax.swing.JLabel();
			myAZProzentLabel3.setName("myAZProzentLabel3");
			myAZProzentLabel3.setFont(new java.awt.Font("dialog.bold", 1, 12));
			myAZProzentLabel3.setText("%");
			myAZProzentLabel3.setBounds(155, 490, 20, 17);
			myAZProzentLabel3.setForeground(java.awt.Color.black);
			myAZProzentLabel3.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);

			javax.swing.JLabel myAZPZALabel = new javax.swing.JLabel();
			myAZPZALabel.setName("myAZPZALabel");
			myAZPZALabel.setFont(new java.awt.Font("dialog.bold", 1, 12));
			myAZPZALabel.setText("Ziel-PZA");
			myAZPZALabel.setBounds(50, 362, 106, 17);
			myAZPZALabel.setForeground(java.awt.Color.black);			
			myAZPZALabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);

			javax.swing.JLabel myAZQALabel = new javax.swing.JLabel();
			myAZQALabel.setName("myAZQALabel");
			myAZQALabel.setFont(new java.awt.Font("dialog", 0, 12));
			myAZQALabel.setText("Quellenanteil:");
			myAZQALabel.setBounds(20, 624, 80, 17);
			myAZQALabel.setForeground(java.awt.Color.black);
			myAZQALabel.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);

			javax.swing.JLabel myAZSchichtLabel = new javax.swing.JLabel();
			myAZSchichtLabel.setName("myAZSchichtLabel");
			myAZSchichtLabel.setFont(new java.awt.Font("dialog", 0, 12));
			myAZSchichtLabel.setText("Schichtigkeit:");
			myAZSchichtLabel.setBounds(20, 532, 80, 17);
			myAZSchichtLabel.setForeground(java.awt.Color.black);
			myAZSchichtLabel.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);

			javax.swing.JLabel myAZmsALabel = new javax.swing.JLabel();
			myAZmsALabel.setName("myAZmsALabel");
			myAZmsALabel.setFont(new java.awt.Font("dialog", 0, 12));
			myAZmsALabel.setText("mat.-spez. Ausl.:");
			myAZmsALabel.setBounds(5, 648, 95, 17);
			myAZmsALabel.setForeground(java.awt.Color.black);
			myAZmsALabel.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);

			javax.swing.JLabel myAZZAhLabel = new javax.swing.JLabel();
			myAZZAhLabel.setName("myAZZAhLabel");
			myAZZAhLabel.setFont(new java.awt.Font("dialog", 0, 12));
			myAZZAhLabel.setText("ZAh:");
			myAZZAhLabel.setBounds(20, 556, 80, 17);
			myAZZAhLabel.setForeground(java.awt.Color.black);
			myAZZAhLabel.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);

			javax.swing.JLabel myALABLabel = new javax.swing.JLabel();
			myALABLabel.setName("myALABLabel");
			myALABLabel.setFont(new java.awt.Font("dialog", 0, 12));
			myALABLabel.setText("Anfangsbest.:");
			myALABLabel.setBounds(575, 624, 95, 17);
			myALABLabel.setForeground(java.awt.Color.black);
			myALABLabel.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);

			javax.swing.JLabel myALESBLabel = new javax.swing.JLabel();
			myALESBLabel.setName("myALESBLabel");
			myALESBLabel.setFont(new java.awt.Font("dialog", 0, 12));
			myALESBLabel.setText("eff. Soll-Bestand:");
			myALESBLabel.setBounds(570, 576, 100, 17);
			myALESBLabel.setForeground(java.awt.Color.black);
			myALESBLabel.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);

			javax.swing.JLabel myALOUTLabel = new javax.swing.JLabel();
			myALOUTLabel.setName("myALOUTLabel");
			myALOUTLabel.setFont(new java.awt.Font("dialog", 0, 12));
			myALOUTLabel.setText("Output:");
			myALOUTLabel.setBounds(575, 672, 95, 17);
			myALOUTLabel.setForeground(java.awt.Color.black);
			myALOUTLabel.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);

// ======================================================================================

			String[] titles = {"Maschinen","Mnner","Frauen"};

			myAArt = new NEComboBox(titles, this, "changeAArt");
			myAArt.setName("myAArt");
			myAArt.setBounds(15, 45, 100, 21);

			aart = 0;

			String[] titles2 = {"Monate","Wochen"};

			myMorW = new NEComboBox(titles2, this, "changeAWMMode");
			myMorW.setName("myMorW");
			myMorW.setBounds(15, 15, 100, 21);

			WorM = true;

			myAOptAusl = new NECheckBox("Auslastung", this, "changeAnzeige");
			myAOptAusl.setName("myAOptAusl");
			myAOptAusl.setBounds(150, 11, 100, 20);
			myAOptAusl.setSelected(true);
			listmod = 0;
			
			myAOptAuslSchicht = new NECheckBox("Auslastung / Schichtigkeit", this, "changeAnzeige");
			myAOptAuslSchicht.setName("myAOptAuslSchicht");
			myAOptAuslSchicht.setBounds(150, 31, 180, 20);
			
			myAOptSchicht = new NECheckBox("Schichtigkeit", this, "changeAnzeige");
			myAOptSchicht.setName("myAOptSchicht");
			myAOptSchicht.setBounds(150, 51, 100, 20);

			// Group the radio buttons.
			ButtonGroup group = new ButtonGroup();
			group.add((JCheckBox)myAOptAusl.getComponent());
			group.add((JCheckBox)myAOptAuslSchicht.getComponent());
			group.add((JCheckBox)myAOptSchicht.getComponent());

			myAListButton = new NEButton("Liste", this, "generateList");
			myAListButton.setName("myAListButton");
			myAListButton.setBounds(600, 45, 80, 25);
			
// ======================================================================================

			myOEPBez = new javax.swing.JLabel();
			myOEPBez.setName("myOEPBez");
			myOEPBez.setFont(new java.awt.Font("dialog.bold", 0, 12));
			myOEPBez.setText("");
			myOEPBez.setBounds(485, 362, 260, 17);
			myOEPBez.setForeground(java.awt.Color.black);
			myOEPBez.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);

			myALAB = new NENumberTextField("", this, "changeALParameter");
			myALAB.setName("myALAB");
			myALAB.setBounds(675, 622, 80, 21);
			myALAB.setEditable(false);

			myALIB = new NENumberTextField("", null, null);
			myALIB.setName("myALIB");
			myALIB.setBounds(675, 598, 80, 21);
			myALIB.setEditable(false);

			myALIn = new NENumberTextField("", null, null);
			myALIn.setName("myALIn");
			myALIn.setBounds(675, 646, 80, 21);
			myALIn.setEditable(false);

			myALIRW = new NENumberTextField("", null, null);
			myALIRW.setName("myALIRW");
			myALIRW.setBounds(675, 694, 80, 21);
			myALIRW.setEditable(false);

			myALHB = new NENumberTextField("", this, "changeALParameter");
			myALHB.setName("myALHB");
			myALHB.setBounds(485, 598, 80, 21);

			myALMB = new NENumberTextField("", this, "changeALParameter");
			myALMB.setName("myALMB");
			myALMB.setBounds(485, 622, 80, 21);

			myALVP = new NENumberTextField("", this, "changeALParameter");
			myALVP.setName("myALVP");
			myALVP.setBounds(485, 646, 80, 21);

			myOELBez = new javax.swing.JLabel();
			myOELBez.setName("myOELBez");
			myOELBez.setText("");
			myOELBez.setForeground(java.awt.Color.black);
			myOELBez.setHorizontalTextPosition(javax.swing.SwingConstants.RIGHT);
			myOELBez.setFont(new java.awt.Font("dialog.bold", 0, 12));
			myOELBez.setBounds(485, 550, 260, 17);
			myOELBez.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);

			myALOut = new NENumberTextField("", null, null);
			myALOut.setName("myALOut");
			myALOut.setBounds(675, 670, 80, 21);
			myALOut.setEditable(false);

			myALRW = new NENumberTextField("", this, "changeALParameter");
			myALRW.setName("myALRW");
			myALRW.setBounds(485, 694, 80, 21);

			myALRWB = new NENumberTextField("", null, null);
			myALRWB.setName("myALRWB");
			myALRWB.setBounds(485, 670, 80, 21);
			myALRWB.setEditable(false);

			myALSB = new NENumberTextField("", null, null);
			myALSB.setName("myALSB");
			myALSB.setBounds(675, 574, 80, 21);
			myALSB.setEditable(false);

// ======================================================================================

			myAQPZA = new NENumberTextField("", this, "changeAPZA");
			myAQPZA.setName("myAQPZA");
			myAQPZA.setBounds(315, 400, 25, 21);
			myAQPZA.setIntegerFormat(false);
			
			myAQPZABez = new NETextField("", null);
			myAQPZABez.setName("myAQPZABez");
			myAQPZABez.setBounds(230, 400, 80, 21);
			myAQPZABez.setEditable(false);

			myAQPZASlider = new NEScrollBar(this, "changeAPZA");
			myAQPZASlider.setName("myAQPZASlider");
			myAQPZASlider.setBounds(200, 380, 170, 17);
			myAQPZASlider.setOrientation(javax.swing.JScrollBar.HORIZONTAL);

			myAQSchicht = new NENumberTextField("", this, "changeAQSchichtig");
			myAQSchicht.setName("myAQSchicht");
			myAQSchicht.setBounds(295, 530, 39, 21);
			myAQSchicht.setIntegerFormat(false);

			myAQSchichtPM = new NEScrollBar(this, "changeAQSchichtig");
			myAQSchichtPM.setName("myAQSchichtPM");
			myAQSchichtPM.setBounds(337, 532, 38, 17);
			myAQSchichtPM.setMinMaxValue(1, 3);
			myAQSchichtPM.setOrientation(javax.swing.JScrollBar.HORIZONTAL);

			myAQZAh = new NENumberTextField("", this, "changeAQZAh");
			myAQZAh.setName("myAQZAh");
			myAQZAh.setBounds(295, 554, 40, 21);

			myAQFraA = new NENumberTextField("", null);
			myAQFraA.setName("myAQFraA");
			myAQFraA.setBounds(295, 488, 45, 21);
			myAQFraA.setEditable(false);
			
			myAQMaeA = new NENumberTextField("", null);
			myAQMaeA.setName("myAQMaeA");
			myAQMaeA.setBounds(295, 464, 45, 21);
			myAQMaeA.setEditable(false);

			myAQMaschA = new NENumberTextField("", null);
			myAQMaschA.setName("myAQMaschA");
			myAQMaschA.setBounds(295, 440, 45, 21);
			myAQMaschA.setEditable(false);

			myAQMM = new NENumberTextField("", this, "changeAMM");
			myAQMM.setName("myAQMM");
			myAQMM.setBounds(295, 598, 80, 21);

			myAQmsA = new NENumberTextField("", null);
			myAQmsA.setName("myAQmsA");
			myAQmsA.setBounds(295, 646, 80, 21);
			myAQmsA.setEditable(false);

			myAQOut = new NENumberTextField("", null);
			myAQOut.setName("myAQOUT");
			myAQOut.setBounds(295, 670, 80, 21);
			myAQOut.setEditable(false);

			myAQQA = new NENumberTextField("", this, "changeAQA");
			myAQQA.setName("myAQQA");
			myAQQA.setBounds(295, 622, 80, 21);

// ======================================================================================

			myAZPZA = new NENumberTextField("", this, "changeAPZA");
			myAZPZA.setName("myAZPZA");
			myAZPZA.setBounds(125, 400, 25, 21);
			myAZPZA.setIntegerFormat(false);
			
			myAZPZABez = new NETextField("", null);
			myAZPZABez.setName("myAZPZABez");
			myAZPZABez.setBounds(40, 400, 80, 21);
			myAZPZABez.setEditable(false);

			myAZPZASlider = new NEScrollBar(this, "changeAPZA");
			myAZPZASlider.setName("myAZPZASlider");
			myAZPZASlider.setBounds(10, 380, 170, 17);
			myAZPZASlider.setOrientation(javax.swing.JScrollBar.HORIZONTAL);

			myAZSchicht = new NENumberTextField("", this, "changeAZSchichtig");
			myAZSchicht.setName("myAZSchicht");
			myAZSchicht.setBounds(105, 530, 39, 21);
			myAZSchicht.setIntegerFormat(false);

			myAZSchichtPM = new NEScrollBar(this, "changeAZSchichtig");
			myAZSchichtPM.setName("myAZSchichtPM");
			myAZSchichtPM.setBounds(147, 532, 38, 17);
			myAZSchichtPM.setMinMaxValue(1, 3);
			myAZSchichtPM.setOrientation(javax.swing.JScrollBar.HORIZONTAL);

			myAZZAh = new NENumberTextField("", this, "changeAZZAh");
			myAZZAh.setName("myAZZAh");
			myAZZAh.setBounds(105, 554, 40, 21);

			myAZFraA = new NENumberTextField("", null);
			myAZFraA.setName("myAZFraA");
			myAZFraA.setBounds(105, 488, 45, 21);
			myAZFraA.setEditable(false);
			
			myAZMaeA = new NENumberTextField("", null);
			myAZMaeA.setName("myAZMaeA");
			myAZMaeA.setBounds(105, 464, 45, 21);
			myAZMaeA.setEditable(false);

			myAZMaschA = new NENumberTextField("", null);
			myAZMaschA.setName("myAZMaschA");
			myAZMaschA.setBounds(105, 440, 45, 21);
			myAZMaschA.setEditable(false);

			myAZMM = new NENumberTextField("", this, "changeAMM");
			myAZMM.setName("myAZMM");
			myAZMM.setBounds(105, 598, 80, 21);

			myAZmsA = new NENumberTextField("", null);
			myAZmsA.setName("myAZmsA");
			myAZmsA.setBounds(105, 646, 80, 21);
			myAZmsA.setEditable(false);

			myAZOut = new NENumberTextField("", null);
			myAZOut.setName("myAZOUT");
			myAZOut.setBounds(105, 670, 80, 21);
			myAZOut.setEditable(false);

			myAZQA = new NENumberTextField("", this, "changeAQA");
			myAZQA.setName("myAZQA");
			myAZQA.setBounds(105, 622, 80, 21);
			
// ======================================================================================

			myAVPButton = new NEButton("OK!", this, "plusOutput");
			myAVPButton.setName("myAVPButton");
			myAVPButton.setBounds(685, 485, 65, 21);
			
			myAVUndoButton = new NEButton("Undo", this, "undoOutput");
			myAVUndoButton.setName("myAVUndoButton");
			myAVUndoButton.setBounds(685, 509, 65, 21);

			myBelast = new NENumberTextField("", null);
			myBelast.setName("myBelast");
			myBelast.setBounds(637, 485, 45, 21);
			myBelast.setEditable(false);
			
			myEntlast = new NENumberTextField("", null);
			myEntlast.setName("myEntlast");
			myEntlast.setBounds(637, 509, 45, 21);
			myEntlast.setEditable(false);

			myVMenge = new NENumberTextField("", this, "changeVMenge");
			myVMenge.setName("myVMenge");
			myVMenge.setBounds(475, 485, 80, 21);
			
			myVProzent = new NENumberTextField("", this, "changeVProzent");
			myVProzent.setName("myVProzent");
			myVProzent.setBounds(475, 509, 45, 21);
			
			myVPSlider = new NEScrollBar(this, "changeVProzent");
			myVPSlider.setName("myVPSlider");
			myVPSlider.setMinMaxValue(0, 100);
			myVPSlider.setBounds(390, 511, 80, 17);
			myVPSlider.setOrientation(javax.swing.JScrollBar.HORIZONTAL);

// ======================================================================================

			JSeparator ASeparator1 = new javax.swing.JSeparator();
			ASeparator1.setName("ASeparator1");
			ASeparator1.setBounds(0, 80, 760, 2);

			JSeparator ASeparator2 = new javax.swing.JSeparator();
			ASeparator2.setName("ASeparator2");
			ASeparator2.setBounds(0, 360, 760, 2);

			JSeparator ASeparator3 = new javax.swing.JSeparator();
			ASeparator3.setName("ASeparator3");
			ASeparator3.setBounds(0, 430, 380, 2);

			JSeparator ASeparator4 = new javax.swing.JSeparator();
			ASeparator4.setName("ASeparator4");
			ASeparator4.setBounds(0, 520, 380, 2);

			JSeparator ASeparator5 = new javax.swing.JSeparator();
			ASeparator5.setName("ASeparator5");
			ASeparator5.setBounds(380, 540, 380, 2);

			JSeparator ASeparator6 = new javax.swing.JSeparator();
			ASeparator6.setName("ASeparator6");
			ASeparator6.setBounds(0, 585, 380, 2);

			JSeparator ASeperator7 = new javax.swing.JSeparator();
			ASeperator7.setName("ASeperator7");
			ASeperator7.setBounds(190, 360, 1, 360);
			ASeperator7.setOrientation(javax.swing.SwingConstants.VERTICAL);

			JSeparator ASeperator8 = new javax.swing.JSeparator();
			ASeperator8.setName("ASeperator8");
			ASeperator8.setBounds(380, 360, 1, 360);
			ASeperator8.setOrientation(javax.swing.SwingConstants.VERTICAL);

// ======================================================================================

			myABrowser = new NETableBrowser(this, "browserClick", null);
			myABrowser.setName("myABrowser");
			myABrowser.setVerticalScrollBarPolicy(javax.swing.JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
			myABrowser.setHorizontalScrollBarPolicy(javax.swing.JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);
		//	myABrowser.setSelectionMode(ListSelectionModel.SINGLE_INTERVAL_SELECTION);
			myABrowser.setBounds(10, 105, 740, 250);

			myAMatBrowser = new NETableBrowser(this, "amatbrowserClick", null);
			myAMatBrowser.setName("myAMatBrowser");
			myAMatBrowser.setBounds(390, 380, 360, 100);

// ======================================================================================

			NEPanel theJDialogContentPane = new NEPanel();
			theJDialogContentPane.setName("AuslContentPane");
			theJDialogContentPane.setLayout(null);
			theJDialogContentPane.add(myAQPZABez);
			theJDialogContentPane.add(LIconLabel);
			theJDialogContentPane.add(myAQPZA);
			theJDialogContentPane.add(myAQMM);
			theJDialogContentPane.add(myAVerschiebLabel);
			theJDialogContentPane.add(myAAMMLabel);
			theJDialogContentPane.add(myAOptAusl);
			theJDialogContentPane.add(myAOptAuslSchicht);
			theJDialogContentPane.add(myAOptSchicht);
			theJDialogContentPane.add(myAListButton);
			theJDialogContentPane.add(myAQQA);
			theJDialogContentPane.add(myAQmsA);
			theJDialogContentPane.add(myAQOut);
			theJDialogContentPane.add(ASeparator3);
			theJDialogContentPane.add(myAAQALabel);
			theJDialogContentPane.add(myAAmsALabel);
			theJDialogContentPane.add(myAAOUTLabel);
			theJDialogContentPane.add(myAAuslLabel);
			theJDialogContentPane.add(myAMatBrowser);
			theJDialogContentPane.add(myAQMaschA);
			theJDialogContentPane.add(myAQMaeA);
			theJDialogContentPane.add(myAQFraA);
			theJDialogContentPane.add(myVPSlider);
			theJDialogContentPane.add(myAQPZASlider);
			theJDialogContentPane.add(myAAProzentLabel1);
			theJDialogContentPane.add(myVMenge);
			theJDialogContentPane.add(myAAProzentLabel2);
			theJDialogContentPane.add(myAAProzentLabel3);
			theJDialogContentPane.add(myAZPZALabel);
			theJDialogContentPane.add(myAAPZALabel);
			theJDialogContentPane.add(ASeparator2);
			theJDialogContentPane.add(ASeperator8);
			theJDialogContentPane.add(ASeparator1);
			theJDialogContentPane.add(ASeperator7);
			theJDialogContentPane.add(myAVPButton);
			theJDialogContentPane.add(myAVUndoButton);
			theJDialogContentPane.add(myAZMMLabel);
			theJDialogContentPane.add(myAZMM);
			theJDialogContentPane.add(myAZQA);
			theJDialogContentPane.add(myAZQALabel);
			theJDialogContentPane.add(myAZmsA);
			theJDialogContentPane.add(myAZmsALabel);
			theJDialogContentPane.add(myAZOUTLabel);
			theJDialogContentPane.add(myAZOut);
			theJDialogContentPane.add(myMorW);
			theJDialogContentPane.add(myAArt);
			theJDialogContentPane.add(myBelast);
			theJDialogContentPane.add(myEntlast);
			theJDialogContentPane.add(myAVBelastLabel);
			theJDialogContentPane.add(myAVEntlastLabel);
			theJDialogContentPane.add(myAQZAh);
			theJDialogContentPane.add(myAQSchicht);
			theJDialogContentPane.add(myAQSchichtPM);
			theJDialogContentPane.add(myAASchichtLabel);
			theJDialogContentPane.add(myAAZAhLabel);
			theJDialogContentPane.add(myAZZAh);
			theJDialogContentPane.add(myAZSchicht);
			theJDialogContentPane.add(myAZSchichtPM);
			theJDialogContentPane.add(myAZSchichtLabel);
			theJDialogContentPane.add(myAZZAhLabel);
			theJDialogContentPane.add(myAAMaschLabel);
			theJDialogContentPane.add(myAAMaennerLabel);
			theJDialogContentPane.add(myAAFrauenLabel);
			theJDialogContentPane.add(myAZPZA);
			theJDialogContentPane.add(myAZPZABez);
			theJDialogContentPane.add(myAZPZASlider);
			theJDialogContentPane.add(myVProzent);
			theJDialogContentPane.add(myAVProzentLabel);
			theJDialogContentPane.add(ASeparator5);
			theJDialogContentPane.add(myALABLabel);
			theJDialogContentPane.add(myALINLabel);
			theJDialogContentPane.add(myALOUTLabel);
			theJDialogContentPane.add(myALIRWLabel);
			theJDialogContentPane.add(myALIRW);
			theJDialogContentPane.add(myALOut);
			theJDialogContentPane.add(myALIn);
			theJDialogContentPane.add(myALAB);
			theJDialogContentPane.add(myALMBLabel);
			theJDialogContentPane.add(myALVPLabel);
			theJDialogContentPane.add(myALRWBLabel);
			theJDialogContentPane.add(myALRWLabel);
			theJDialogContentPane.add(myALRW);
			theJDialogContentPane.add(myALRWB);
			theJDialogContentPane.add(myALVP);
			theJDialogContentPane.add(myALMB);
			theJDialogContentPane.add(myALESBLabel);
			theJDialogContentPane.add(myALIBLabel);
			theJDialogContentPane.add(myALSB);
			theJDialogContentPane.add(myALIB);
			theJDialogContentPane.add(myAVMengeLabel);
			theJDialogContentPane.add(myALHBLabel);
			theJDialogContentPane.add(myALHB);
			theJDialogContentPane.add(myABrowser);
			theJDialogContentPane.add(myAZMaschA);
			theJDialogContentPane.add(myAZMaeA);
			theJDialogContentPane.add(myAZFraA);
			theJDialogContentPane.add(myAZFrauenLabel);
			theJDialogContentPane.add(myAZMaennerLabel);
			theJDialogContentPane.add(myAZMaschLabel);
			theJDialogContentPane.add(myAZProzentLabel1);
			theJDialogContentPane.add(myAZProzentLabel2);
			theJDialogContentPane.add(myAZProzentLabel3);
			theJDialogContentPane.add(myOELBezLabel);
			theJDialogContentPane.add(myOELBez);
			theJDialogContentPane.add(myOEPBez);
			theJDialogContentPane.add(ASeparator6);
			theJDialogContentPane.add(ASeparator4);

			myAPanel = new javax.swing.JFrame();
			myAPanel.setName("myAPanel");
			myAPanel.setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
			myAPanel.setBounds(10, 40, 760+wp, 720+hp);
			myAPanel.setTitle("Auslastungsabgleich - Demonstration Bundles und Werkzeuge");
			myAPanel.setResizable(false);
			myAPanel.setContentPane(theJDialogContentPane.getComponent());

	
}
public void generateList(NEDialogElement sender)
{
	if(myListContr == null) { 
		myListContr = (ListController) mainController.controllerWithKey(strings.getProperty("listcontroller")); 
	}
	if(myListContr != null) {	
		myListContr.generateList(0,0,null);
	}
	return;
}
public void handleEvent(NEDialogElement ctrl, java.util.EventObject ev) {

	JOptionPane.showMessageDialog(null, "Funktion ist noch nicht implementiert");


}
private void initBrowser()
{
	int a;

	anzahlOEP = myUModell.getOEPcount();

	if(WorM) {
		myABrowser.setTable(anzahlOEP, maxMonth, true, true);
		for(a = 0; a != anzahlOEP; a++) {
			myABrowser.setRowTitle(myUModell.getOESchl(a), a);
		}
		for(a = maxWeek; a != maxPZA; a++) {
			myABrowser.setColumnTitle(myKalender.pzabez(a), (a - maxWeek));
		}

	} else {	
		myABrowser.setTable(anzahlOEP, maxWeek, true, true);
		for(a = 0; a != anzahlOEP; a++) {
			myABrowser.setRowTitle(myUModell.getOESchl(a), a);
		}
		for(a = 0; a != maxWeek; a++) {
			myABrowser.setColumnTitle(myKalender.pzabez(a), a);
		}
	}
	this.loadBrowser();
	myABrowser.display();
	myABrowser.setCellSelectionEnabled(true);
	return;
}
public void loadAMatBrowser()
{
	int a, i, amdcount, pecount, row;
	double x, y;
	boolean found = false;
	AMatData amd, amdneu;
	ProduktionsElement pe = null;
	LagerElement le = null;
	theAMatList = new Vector();

	if(currentOEP != null) {

		pecount = currentOEP.pecount();

	} else {

		pecount = 0;

	}
	amdcount = 0;

	for(a = 0; a < pecount; a++) {
		pe = currentOEP.produktionselement(a);
		le = pe.getMat().lagerlagerelement();
		if(le == null) { continue; }
		y = currentOEP.iMsAusl(pe, currentAPZA);
		amdneu = new AMatData();
		amdneu.pe = pe;
		amdneu.le = le;
		for(i = 0; i < amdcount && !found; i++) {
			amd = (AMatData) theAMatList.elementAt(i);
			x = currentOEP.iMsAusl(amd.pe, currentAPZA);		
			if(y > x) {
				found = true;	
				theAMatList.insertElementAt(amdneu, i);
				break;
			}
		}
		if(!found) {
			theAMatList.addElement(amdneu);
		}
		amdcount = theAMatList.size();
		found = false;
	}
		
	if(!myAMatBrowser.isDisplayed()) {
			
		myAMatBrowser.setTable(amdcount, 3, true, false);
		myAMatBrowser.setColumnTitle("MatSchl", 0);
		myAMatBrowser.setColumnTitle("Bezeichnung", 1);
		myAMatBrowser.setColumnTitle("MESchl", 2);
			
	} else {

		myAMatBrowser.updateTableModelRows(amdcount);

	}
		
	for(row = 0; row < amdcount; row++) {
		amd = (AMatData) theAMatList.elementAt(row);	
		myAMatBrowser.setValueAt(amd.pe.articleno(), row, 0);
		myAMatBrowser.setValueAt(amd.pe.articlename(), row, 1);			
		myAMatBrowser.setValueAt(amd.pe.unit(), row, 2);	
	}
	if(amdcount == 0) { currentAMat = -1; }
	myAMatBrowser.display();
	return;

}
public void loadBrowser()
{
	int a, b, c;
	OrganisationsEinheit tmp;
	double x = 0;
	String val;
	int ausl;
	int sch;

	if(WorM) {
		for(a = 0; a != anzahlOEP; a++) {
			tmp = myUModell.getOEByIndex(a);
			for(b = maxWeek; b != maxPZA; b++) {
				c = b - maxWeek;
				sch = tmp.schicht(b);
				ausl = 0;
				switch(aart) {
					case 0: /* Masch */
						ausl = (int) tmp.auslmasch(b);
						break;
					case 1:	/* Mae */
						ausl = (int) tmp.auslmae(b);
						break;
					case 2:
						ausl = (int) tmp.auslfra(b);
						break;
				}
				switch(listmod) {		
					case 0: /* Ausl */
						if(ausl >= 0) {
							myABrowser.setValueAt(new Integer(ausl), a, c);
						} else {
							myABrowser.setValueAt("unendl.", a, c);
						}
						break;
					case 2: /* Schicht */
						myABrowser.setValueAt(new Integer(sch), a, c);
						break;
					case 1: /* Ausl/Schicht */
						val = sch + " / " + ausl;
						myABrowser.setValueAt(val, a, c);
						break;
				}
			}
		}

	} else {
		for(a = 0; a != anzahlOEP; a++) {
			tmp = myUModell.getOEByIndex(a);
			for(b = 0; b != maxWeek; b++) {
				sch = tmp.schicht(b);
				ausl = 0;
				switch(aart) {
					case 0: /* Masch */
						ausl = (int) tmp.auslmasch(b);
						break;
					case 1:	/* Mae */
						ausl = (int) tmp.auslmae(b);
						break;
					case 2:
						ausl = (int) tmp.auslfra(b);
						break;
				}
				switch(listmod) {		
					case 0: /* Ausl */
						if(ausl >= 0) {
							myABrowser.setValueAt(new Integer(ausl), a, b);
						} else {
							myABrowser.setValueAt("unendl.", a, b);
						}
						break;
					case 2: /* Schicht */
						myABrowser.setValueAt(new Integer(sch), a, b);
						break;
					case 1: /* Ausl/Schicht */
						val = sch + " / " + ausl;
						myABrowser.setValueAt(val, a, b);
						break;
				}
			}
		}
	}
	return;
}
public void loadQMat()
{
	double x;
	if(currentAMD != null) {
		myAQMM.setDoubleValue(currentAMD.pe.minmeng(currentAPZA));
		myAQQA.setDoubleValue((currentAMD.pe.quantl(currentAPZA)*100));
		x = currentOEP.iMsAusl(currentAMD.pe,currentAPZA);
		if(x >= 0) { myAQmsA.setDoubleValue(x); }
		else { myAQmsA.setStringValue("unendl."); }
		this.testcurrentVMenge();
		myAQOut.setDoubleValue(currentAMD.pe.output(currentAPZA));
		currentVProzent = 100;
		if(currentVMenge > 0) {
			x = currentOEP.iMsAMat(currentAMD.pe, currentVMenge, currentAPZA);
			if(x >= 0) { myEntlast.setDoubleValue(x); }
			else { myEntlast.setStringValue("unendl."); }
			x = currentOEP.iMsAMat(currentAMD.pe, currentVMenge, currentZPZA);
			if(x >= 0) { myBelast.setDoubleValue(x); }
			else { myBelast.setStringValue("unendl."); }
			myVMenge.setDoubleValue(currentVMenge);
			myVPSlider.setDoubleValue(currentVProzent);
			myVPSlider.setEnabled(true);
			myVProzent.setDoubleValue(currentVProzent);
		}
		else {
			myVMenge.setStringValue("");
			myVProzent.setStringValue("");
			myBelast.setStringValue("");
			myEntlast.setStringValue("");
			myVPSlider.setDoubleValue(100);
			myVPSlider.setEnabled(false);
		}
	}
	else {
		myAQMM.setStringValue("");
		myAQQA.setStringValue("");
		myAQmsA.setStringValue("");
		myAQOut.setStringValue("");
	}
}
public void loadQParameter()
{
	double x;
	if(currentAPZA != -1) {
		myAQSchicht.setIntValue(currentOEP.schicht(currentAPZA));
		myAQSchichtPM.setIntValue(currentOEP.schicht(currentAPZA));
		myAQZAh.setDoubleValue(currentOEP.zah(currentAPZA));
		x = currentOEP.auslmasch(currentAPZA);
		if(x != -1) { myAQMaschA.setDoubleValue(x); }
		else { myAQMaschA.setStringValue("unendl."); }
		x = currentOEP.auslmae(currentAPZA);
		if(x != -1) { myAQMaeA.setDoubleValue(x); }
		else { myAQMaeA.setStringValue("unendl."); }
		x = currentOEP.auslfra(currentAPZA);
		if(x != -1) { myAQFraA.setDoubleValue(x); }
		else { myAQFraA.setStringValue("unendl."); }
	}
	else {
		myAQSchicht.setStringValue("");
		myAQZAh.setStringValue("");
		myAQMaschA.setStringValue("");
		myAQMaeA.setStringValue("");
		myAQFraA.setStringValue("");
	}
}
public void loadZMat()
{
	double x, y, z, w, sb, irw;
	if(currentAMD != null) {
		
		myOELBez.setText(currentAMD.le.getOE().oeschl() + " " + currentAMD.le.getOE().bezeichnung());
		
		myAZMM.setDoubleValue(currentAMD.pe.minmeng(currentZPZA));
		myAZQA.setDoubleValue((currentAMD.pe.quantl(currentZPZA)*100));
		x = currentOEP.iMsAusl(currentAMD.pe, currentZPZA);
		if(x >= 0) { myAZmsA.setDoubleValue(x); }
		else { myAZmsA.setStringValue("unendl."); }
		myAZOut.setDoubleValue(currentAMD.pe.output(currentZPZA));
		w = currentAMD.le.maxbest(currentZPZA);
		if(w >= 0) { myALHB.setDoubleValue(w); }
		else { myALHB.setStringValue("unendl."); }

		irw = currentAMD.le.ist_reichw(currentZPZA);
		if(irw >= 0) { myALIRW.setDoubleValue(irw); }
		else { myALIRW.setStringValue("bis ENDE"); }	

		x = currentAMD.le.minbest(currentZPZA);
		myALMB.setDoubleValue(x);
		y = currentAMD.le.rw_best(currentZPZA);
		myALRWB.setDoubleValue(y);
		z = currentAMD.le.vorprod(currentZPZA);
		myALVP.setDoubleValue(z);
		myALRW.setDoubleValue(currentAMD.le.reichw(currentZPZA));
		myALIB.setDoubleValue(currentAMD.le.endbest(currentZPZA));
		if(WorM) {
			if(currentZPZA == maxWeek) {
				myALAB.setEditable(true);
			} else {
				myALAB.setEditable(false);
			}
		} else {
			if(currentZPZA == 0) {
				myALAB.setEditable(true);
			} else {
				myALAB.setEditable(false);
			}
		}
				
		myALAB.setDoubleValue(currentAMD.le.anfbest(currentZPZA));
		myALOut.setDoubleValue(currentAMD.le.output(currentZPZA));
		myALIn.setDoubleValue(currentAMD.le.input(currentZPZA));
		/*
		sb = (y > z) ? y : z;
		if(w >= 0) { sb = (sb < w) ? sb : w; }
		sb = (sb > x) ? sb : x;
		*/
		myALSB.setDoubleValue(currentAMD.le.sollbest(currentZPZA));
		if(correctVMenge > 0) {
			x = correctVMenge;
			y = currentOEP.iMsAMat(currentAMD.pe, x, currentZPZA);
			if(y >= 0) { myBelast.setDoubleValue(y); }
			else { myBelast.setStringValue("unendl."); }
		}
		else {
			myVMenge.setStringValue("");
			myVProzent.setStringValue("");
			myBelast.setStringValue("");
			myEntlast.setStringValue("");
			myVPSlider.setDoubleValue(100);
			myVPSlider.setEnabled(false);
		}
	}
	else {
		myOELBez.setText("");
		myAZMM.setStringValue("");
		myAZQA.setStringValue("");
		myAZmsA.setStringValue("");
		myAZOut.setStringValue("");
		myALHB.setStringValue("");
		myALIRW.setStringValue("");
		myALMB.setStringValue("");
		myALRWB.setStringValue("");
		myALVP.setStringValue("");
		myALRW.setStringValue("");
		myALIB.setStringValue("");
		myALAB.setStringValue("");
		myALOut.setStringValue("");
		myALIn.setStringValue("");
		myALSB.setStringValue("");
		myVMenge.setStringValue("");
		myVProzent.setStringValue("");
		myBelast.setStringValue("");
		myEntlast.setStringValue("");
		myVPSlider.setDoubleValue(100);
		myVPSlider.setEnabled(false);
		currentVMenge = -1;
	}
}
public void loadZParameter()
{
	double x;
	if(currentAPZA != -1) {
		myAZSchicht.setIntValue(currentOEP.schicht(currentZPZA));
		myAZSchichtPM.setIntValue(currentOEP.schicht(currentZPZA));
		myAZZAh.setDoubleValue(currentOEP.zah(currentZPZA));
		x = currentOEP.auslmasch(currentZPZA);
		if(x != -1) { myAZMaschA.setDoubleValue(x); }
		else { myAZMaschA.setStringValue("unendl."); }
		x = currentOEP.auslmae(currentZPZA);
		if(x != -1) { myAZMaeA.setDoubleValue(x); }
		else { myAZMaeA.setStringValue("unendl."); }
		x = currentOEP.auslfra(currentZPZA);
		if(x != -1) { myAZFraA.setDoubleValue(x); }
		else { myAZFraA.setStringValue("unendl."); }
	}
	else {
		myAZSchicht.setStringValue("");
		myAZZAh.setStringValue("");
		myAZMaschA.setStringValue("");
		myAZMaeA.setStringValue("");
		myAZFraA.setStringValue("");
	}
}
public void openWindow(NEDialogElement sender)
{
	int index;
	int a;

	if(myAPanel != null) {
		if(myAPanel.isVisible()) { return; }
	}

	if(myQAContr == null) { 
		myQAContr = (QAController) mainController.controllerWithKey(strings.getProperty("qacontroller")); 
	}

	if(myUModell != null) {
		
		if(myAPanel == null) {	
			this.createPanel();
	
			if(WorM) {
				myAQPZASlider.setMinMaxValue((maxWeek+2), maxPZA);
				myAZPZASlider.setMinMaxValue((maxWeek+1), (maxPZA-1));
			}
			else {
				myAQPZASlider.setMinMaxValue(2, maxWeek);
				myAZPZASlider.setMinMaxValue(1, (maxWeek-1));
			}
		
			currentAOE = -1;
			currentOEP = null;
		
			this.initBrowser();
		}
		
		myAPanel.setVisible(true);
		
	} else {
		JOptionPane.showMessageDialog(null, "Kein Modell aktiv!");
	}

	return;
}
public void plusOutput(NEDialogElement sender)
{  
	int a;
	double xd, yd;
	boolean WARN = false;
	
	if(currentAMD != null) {
	   //	xd = [ABMat[currentAMat].AAP output:currentAPZA];
	  //  for(a = currentZPZA; a != currentAPZA; a++) {
	   //     yd = [currentLE sollbestand:a];
	  //      [currentLE setSBestand:(xd+yd):a:NO];
	  //  }
		xd = currentVMenge;
		undoZPZA = currentZPZA;
		undoAPZA = currentAPZA;
		undoLE = currentAMD.le;
		undoVP = new double[maxPZA];
		for(a = (currentAPZA-1); a != (currentZPZA-1); a--) {
			yd = undoLE.endbest(a);
			undoVP[a] = undoLE.vorprod(a);
			if(a != currentZPZA) {
				if(undoLE.setSBestand((xd+yd), a, false) && !WARN) { 	
					WARN = true;
				}
			}
			else {
				if(undoLE.setSBestand((xd+yd), a, true) && !WARN) { 	
					WARN = YES;
				}
			}
		}
		if(WARN) {
			JOptionPane.showMessageDialog(null, "Hchstbestand wurde erhht!", "Achtung!", 
				JOptionPane.WARNING_MESSAGE);
		//	NSRunAlertPanel(@"", @"Hchstbestand wurde erhht!", @"", nil, nil, strerror(errno));
		}
		mainController.update(false);
		UNDO = true;
	}
}
public void testcurrentVMenge()
{
	int a;
	double anfang, xd, yd;
	boolean WARN = false;

	anfang = currentAMD.pe.output(currentAPZA);
	for(a = (currentAPZA-1); a != (currentZPZA-1); a--) {
		yd = currentAMD.le.endbest(a);
		xd = currentAMD.le.maxbest(a);
		if(((xd - yd) < anfang) && (xd >= 0))
		  { 	
			anfang = xd - yd;
			if(anfang < 0) { anfang = 0;}
			WARN = true;
		  }
	}
	if(WARN) {
		JOptionPane.showMessageDialog(null, "Verschiebemenge durch Hchstbestand reduziert!", "Achtung!", 
				JOptionPane.WARNING_MESSAGE);
	//	NSRunAlertPanel(@"", @"Verschiebemenge durch Hchstbestand reduziert!", @"", nil, nil, strerror(errno));
//		Warning = false;
	}
	correctVMenge = currentVMenge = anfang;

}
public void undoOutput(NEDialogElement sender)
{  
	int a;
	if(UNDO) {
		for(a = (undoAPZA-1); a != (undoZPZA-1); a--) {
			if(a != undoZPZA) {
				undoLE.setSBestand(undoVP[a],a, false);
			} else {
				undoLE.setSBestand(undoVP[a], a, true);
			}
		}
		mainController.update(false);
		UNDO = false;
	}
}
public void update(boolean pzachanged)
{
	if(myAPanel == null) { return; }
	if(!myAPanel.isVisible()) { return; }
	if(pzachanged) {
		super.update(pzachanged);
		maxMonth = myUModell.monthPZA();
		maxWeek = myUModell.weekPZA();
		maxPZA = maxWeek + maxMonth;
		if(WorM) {
			myAQPZASlider.setMinMaxValue((maxWeek+2), maxPZA);
			myAZPZASlider.setMinMaxValue((maxWeek+1), (maxPZA-1));
		}
		else {
			myAQPZASlider.setMinMaxValue(2, maxWeek);
			myAZPZASlider.setMinMaxValue(1, (maxWeek-1));
		}
		currentAPZA = -1;
		this.loadBrowser();
		return;
	}
	this.loadBrowser();
	this.loadQMat();
	this.loadZMat();
	this.loadZParameter();
	this.loadQParameter();
	return;
}
public void updateModell(UModell modell)
{
	super.updateModell(modell);

	if(myAPanel != null) {
		myAPanel.setVisible(false);
		myAPanel = null;
	}
}
}
