package com.nerthus.proisys.bundles;

import java.util.*;
import javax.swing.*;
import com.nerthus.proisys.pps.kernel.*;
import com.nerthus.appkit.*;
import com.nerthus.appkit.table.*;
import com.nerthus.proisys.pps.*;
/**
 * Standard-Dialog NeRTHUS PPS.
 * 
 * @author: R.Bohlig
 */
 
public class PPSDialog extends com.nerthus.proisys.pps.NEController implements NEDialogDelegate {
	
	static int hp = 30;
	static int wp = 5;

	private DialogManager myDM;
	private QAController myQAContr = null;
	private ListController myListContr = null;

//    id  myOutWindow;
//    id  resultView;

	/* ========== PZA Panel ============== */

	private javax.swing.JFrame myPZAPanel;
	private NEDateTextField myDate;
	private NENumberTextField myNat;
	private NENumberTextField myNatf38;
	private NENumberTextField myrPZA;
	private NENumberTextField myPZABez;
	private NEScrollBar myPZASlider;
	private NETableBrowser PZABrowser;

	/* ========== OEP Panel ============== */
	
	private javax.swing.JFrame myOEPPanel;

	private NECheckBox myPListOptAllOEP;
	private NECheckBox myPListOptNull;
	private	NECheckBox myPListOptAllPZA;
	private	NEButton myPListButton;
	private	NEButton myPSLButton;
	private	NEButton myPAPButton;
	private NERadioButton myPWochen;
	private	NERadioButton myPMonate;

	private	javax.swing.JLabel myPQOELBez;
	private	javax.swing.JLabel myPSOELBez;
	
	private NETextField myPPZABez;
	private NEScrollBar myPPZASlider;
	private NENumberTextField myPrPZA;
	private NENumberTextField myMaschAnz;
	private NENumberTextField myMaeAnz;
	private NENumberTextField myFraAnz;
	private NENumberTextField mySchicht;
	private NENumberTextField myZAh;
	private NENumberTextField myMaschVbkt;
	private NENumberTextField myMaeVbkt;
	private NENumberTextField myFraVbkt;
	private NEScrollBar myMaschVSlider;
	private NEScrollBar myMaeVSlider;
	private NEScrollBar myFraVSlider;
	private NENumberTextField myMaschAusl;
	private NENumberTextField myMaeAusl;
	private NENumberTextField myFraAusl;
	private NEScrollBar myPSchichtPM;
	private NENumberTextField mySMB;
	private NENumberTextField mySHB;
	private NENumberTextField mySSB;
	private NENumberTextField mySRW;
	private NENumberTextField mySRWB;
	private NENumberTextField mySAB;
	private NENumberTextField mySIST;
	private NENumberTextField mySINPUT;
	private NENumberTextField mySOUTPUT;
	private NENumberTextField mySmsV;
	private NENumberTextField myQMM;
	private NENumberTextField myQQA;
	private NENumberTextField myQMsA;
	private NENumberTextField myQOUTPUT;
	private NETableBrowser OEPBrowser;
	private NETableBrowser UMBrowser;
	private NETableBrowser OMBrowser;
	
	/* ========== OEL Panel ============== */
	private javax.swing.JFrame myOELPanel;
	
	private NECheckBox myLListOptAllLager;
	private NECheckBox myLListOptAllPara;
	private	NECheckBox myLListOptAllPZA;
	private	NEButton myLListButton;
	private NERadioButton myLWochen;
	private	NERadioButton myLMonate;

	private NETableBrowser OELBrowser;
	private NETableBrowser LMBrowser;
	private NETableBrowser QBrowser;
	private NEScrollBar myLPZASlider;
	private NENumberTextField myLrPZA;
	private NETextField myLPZABez;
	private NENumberTextField myLMB;
	private NENumberTextField myLHB;
	private NENumberTextField myLeffSB;
	private NENumberTextField myLeffHB;
	private NENumberTextField myLeffMB;
	private NENumberTextField myLSB;
	private NENumberTextField myLRW;
	private NENumberTextField myLHRW;
	private NENumberTextField myLMRW;
	private NENumberTextField myLIRW;
	private NENumberTextField myLRWB;
	private NENumberTextField myLHRWB;
	private NENumberTextField myLMRWB;
	private NENumberTextField myLAB;
	private NENumberTextField myLIB;
	private NENumberTextField myLINPUT;
	private NENumberTextField myLOUTPUT;
	private NENumberTextField myLQAus;
	private NENumberTextField myLQms;
	private NENumberTextField myLQQA;
	private NENumberTextField myLQMM;
	private NENumberTextField myLQOUT;
	
	/* ========== Einkauf ============== */
	
	private javax.swing.JFrame myOEEPanel;

	private NECheckBox myEListOptAllMat;
	private NECheckBox myEListOptNull;
	private	NECheckBox myEListOptAllPZA;
	private	NECheckBox myEListSelekt;
	private	NEButton myEListButton;
	private NERadioButton myEWochen;
	private	NERadioButton myEMonate;

	private	javax.swing.JLabel myEOELBez;

	private NETableBrowser EBrowser;
	private NEScrollBar myEPZASlider;
	private NENumberTextField myErPZA;
	private NETextField myEPZABez;
	private NENumberTextField myEQA;
	private NENumberTextField myEMM;
	private NENumberTextField myEOut;

	/* ========== Verkauf ============== */
	
	private javax.swing.JFrame myOEVPanel;

	private NECheckBox myVListOptAllMat;
	private NECheckBox myVListOptNull;
	private	NECheckBox myVListOptAllPZA;
	private	NECheckBox myVListSelekt;
	private	NEButton myVListButton;
	private NERadioButton myVWochen;
	private	NERadioButton myVMonate;

	private	javax.swing.JLabel myVOELBez;

	private NETableBrowser VBrowser;
	private NEScrollBar myVPZASlider;
	private NENumberTextField myVrPZA;
	private NETextField myVPZABez;
	private NENumberTextField myVBedarf;
	private NENumberTextField myVZBedarf;
	private NENumberTextField myVAR;
	
	/* ========= current objects and parameters ============== */
	
	private OrganisationsEinheit myOEV;
	private OrganisationsEinheit myOEE;
	private OrganisationsEinheit myOEP;
	private OrganisationsEinheit myOEL;
	private Material currentLMat;
	private EinkaufsElement currentEE;
	private VerkaufsElement currentVE;
	private LagerElement currentLE;
	private LagerElement currentULE;
	private ProduktionsElement currentPE;

	private int anzahloeh;
	private int anzahloel;
	private int currentPZA;
	private int currentOPZA;
	private int currentLPZA;
	private int currentVPZA;
	private int currentEPZA;
	private int currentOEP;
	private int currentOEL;
	private int currentMat;
	private int currentLM;
	private int currentUM;
	private int currentOM;
	private int currentQ;
	private int currentEM;
	private int currentVM;
	private boolean PWorM;			/* YES = Monat */
	private boolean LWorM;			/* YES = Monat */
	private boolean EWorM;			/* YES = Monat */
	private boolean VWorM;			/* YES = Monat */
	private boolean VLM[] = new boolean[2];
	private boolean ELM[] = new boolean[2];

/**
 * PPSDialog constructor comment.
 * @param resfile java.lang.String
 */
        public PPSDialog(String resfile) {
	super(resfile);

}
/**
 * PPSDialog constructor comment.
 * @param resfile java.lang.String
 * @param resfile com.nerthus.proisys.NEMainController
 */
public PPSDialog(String resfile,NEMainController mc) {
	super(resfile, mc);

}
public void aktualisiereE()
{
	this.changeEM();
}
public void aktualisiereL()
{
	this.changeLM();
	this.changeQ(); 
}
public void aktualisiereP()
{
	this.changeOEP();
	this.changeOM();
	this.changeUM(); 

}
public void aktualisiereV()
{
	this.changeVM();
}
public void browserClick(NEDialogElement sender)
{
	int index;

	if(sender == OELBrowser) {
		
		index = OELBrowser.selectedRow();
		if (index != (currentOEL-anzahloeh)) {
			
			currentOEL = anzahloeh + index;
			myOEL = myUModell.getOEByIndex(currentOEL);	

			currentLM = 0;
			currentLE = null;
			currentLMat = null;
			this.loadLBrowser(LMBrowser);
			LMBrowser.selectRows(currentLM, currentLM);
			this.changeLM();

			currentQ = 0;
			this.loadLBrowser(QBrowser);
			QBrowser.selectRows(currentQ, currentQ);	
			this.changeQ();
		}
		return;
	}

	if(sender == LMBrowser) {

		index = LMBrowser.selectedRow();
		if (index != currentLM) {
			
			currentLM = index;
			this.changeLM();

			currentQ = 0;
			this.loadLBrowser(QBrowser);		
			QBrowser.selectRows(currentQ, currentQ);
			this.changeQ();
		}

		return;
	}

	if(sender == QBrowser) {

		index = QBrowser.selectedRow();
		if (index != currentQ) {
			
			currentQ = index;
			this.changeQ();
		}
		
		return;
	}

// ==========================================================================

	if(sender == OEPBrowser) {
		
		index = OEPBrowser.selectedRow();
		if (index != currentOEP) {
			
			currentOEP = index;
			myOEP = myUModell.getOEByIndex(currentOEP);	
			
			this.changeOEP();

	   	 	currentOM = 0;
			currentPE = null;
			
			this.loadPBrowser(OMBrowser);
			OMBrowser.selectRows(currentOM, currentOM);
			this.changeOM();

			currentUM = 0;		
			currentULE = null;
			
			this.loadPBrowser(UMBrowser);
			UMBrowser.selectRows(currentUM, currentUM);	
			this.changeUM();
		}
		return;
	}

	if(sender == OMBrowser) {

		index = OMBrowser.selectedRow();
		if (index != currentOM) {
			
			currentOM = index;
			currentPE = null;
			
			this.changeOM();

			currentUM = 0;		
			currentULE = null;
			
			this.loadPBrowser(UMBrowser);
			UMBrowser.selectRows(currentUM, currentUM);	
			this.changeUM();
		}

		return;
	}

	if(sender == UMBrowser) {

		index = UMBrowser.selectedRow();
		if (index != currentUM) {
			
			currentUM = index;		
			currentULE = null;
			
			this.changeUM();
		}
		
		return;
	}

// ==========================================================================

	if(sender == VBrowser) {

		index = VBrowser.selectedRow();
		if (index != currentVM) {
			
			currentVM = index;
			this.changeVM();
		}

		return;
	}

// ==========================================================================

	if(sender == EBrowser) {

		index = EBrowser.selectedRow();
		if (index != currentEM) {
			
			currentEM = index;
			this.changeEM();
		}

		return;
	}
	
}
public void changeAnzRess(NEDialogElement sender)
{
	double x;
	int b;
	x = 0;
	if(sender == myMaschAnz) {
		b = myMaschAnz.intValue();
		if(b < 0) {
			b = myOEP.anzmasch(currentOPZA);
			myMaschAnz.setIntValue(b);
			return;
		}
		myOEP.setAnzmasch(b, currentOPZA);
		x = myOEP.auslmasch(currentOPZA);
		if(x >= 0) { myMaschAusl.setDoubleValue(x); }
		else { myMaschAusl.setStringValue("unendl."); }
		if(currentPE != null) {
			x = myOEP.iMsAusl(currentPE, currentOPZA);
			if(x < 0) { myQMsA.setStringValue("unendl."); }
			else { myQMsA.setDoubleValue(x); }
		}
	}
	if(sender == myMaeAnz) {
		b = myMaeAnz.intValue();
		if(b < 0) {
			b = myOEP.anzmae(currentOPZA);
			myMaeAnz.setIntValue(b);
			return;
		}
		myOEP.setAnzmae(b, currentOPZA);
		x = myOEP.auslmae(currentOPZA);
		if(x >= 0) { myMaeAusl.setDoubleValue(x); }
		else { myMaeAusl.setStringValue("unendl."); }
	}
	if(sender == myFraAnz) {
		b = myFraAnz.intValue();
		if(b < 0) {
			b = myOEP.anzfra(currentOPZA);
			myFraAnz.setIntValue(b);
			return;
		}
		myOEP.setAnzfra(b, currentOPZA);
				x = myOEP.auslfra(currentOPZA);
		if(x >= 0) { myFraAusl.setDoubleValue(x); }
		else { myFraAusl.setStringValue("unendl."); }
	}
	mainController.update(false);
	return;
}
private void changeEM()
{
	LagerElement le;
	double x;
	int am;
	if(currentEM >= 0) {
		currentEE = myOEE.einkaufselement(currentEM);
		
		myEMM.setDoubleValue(currentEE.minmeng(currentEPZA));
		myEQA.setDoubleValue(currentEE.quantl(currentEPZA)*100);
		myEOut.setDoubleValue(currentEE.output(currentEPZA));

		le = currentEE.getMat().lagerlagerelement();
		if(le == null) {
			myEOELBez.setText("Kein Lager!");
		} else {
			myEOELBez.setText(le.getOE().oeschl() + " " + le.getOE().bezeichnung());
		}
		
	} else {
		myEMM.setStringValue("");
		myEQA.setStringValue("");
		myEOut.setStringValue("");
	}
	return;
}
public void changeEParameter(NEDialogElement sender)
{
	double x;
	if(currentEE != null) {
		if(sender == myEMM) {
			x = myEMM.doubleValue();
			if(x >= 0) {
				currentEE.setMinmeng(x, currentEPZA);
				this.changeEM();

				mainController.update(false); 
			}
			else {
				myEMM.setDoubleValue(currentEE.minmeng(currentEPZA));
			}
		}
		if(sender == myEQA) {
			if((currentEE.getMat().sourcecount() > 1) && (myQAContr != null)) {
				x = myEQA.doubleValue();
				// Aufruf QA-Dialog 
				myQAContr.openQAPanel((x/100), currentEPZA, currentEE);
			}
			else {
				myEQA.setDoubleValue(currentEE.quantl(currentEPZA)*100);
			}
		}
	}
	else { 
		myEQA.setStringValue("");
		myEMM.setStringValue(""); 	
	} 
}
private void changeEPZA() {
	if(EWorM) {
		myEPZASlider.setMinMaxValue((maxWeek+1), maxPZA);
		currentEPZA = maxWeek;
	} else {
		myEPZASlider.setMinMaxValue(1, maxWeek);
		currentEPZA = 0;
	}
	myEPZASlider.setIntValue(currentEPZA + 1);
	myErPZA.setIntValue(currentEPZA + 1);
	myEPZABez.setStringValue(myKalender.pzabez(currentEPZA));
}
public void changeEPZASlider(NEDialogElement sender)
{
	currentEPZA = myEPZASlider.intValue() - 1;
	myErPZA.setIntValue(currentEPZA + 1);
	myEPZABez.setStringValue(myKalender.pzabez(currentEPZA));
	this.aktualisiereE(); 
}
public void changeErPZA(NEDialogElement sender)
{
	currentEPZA = myErPZA.intValue() - 1;
	if(EWorM) {
		if(currentEPZA > maxPZA) {
			currentEPZA = maxPZA-1;
			myErPZA.setIntValue(currentEPZA + 1);
		}
		if(currentEPZA < maxWeek) {
			currentEPZA = maxWeek;
			myErPZA.setIntValue(currentEPZA + 1);
		}
	}
	else {
		if(currentEPZA > maxWeek) {
			currentEPZA = maxWeek-1;
			myErPZA.setIntValue(currentEPZA + 1);
		}
		if(currentEPZA < 0) {
			currentEPZA = 0;
			myErPZA.setIntValue(currentEPZA + 1);
		}
	}
	myEPZASlider.setIntValue(currentEPZA + 1);
	myEPZABez.setStringValue(myKalender.pzabez(currentEPZA));
	this.aktualisiereE();
	
}
public void changeEWMMode(NEDialogElement sender)
{
	if(sender == myEMonate) {
		EWorM = true;
	} else {
		EWorM = false;
	}
	this.changeEPZA();
	this.aktualisiereE();
}
public void changeESelectionMode(NEDialogElement sender)
{
/* ListSelectionModel.SINGLE_SELECTION
 * ListSelectionModel.SINGLE_INTERVAL_SELECTION
 * ListSelectionModel.MULTIPLE_INTERVAL_SELECTION
 */
	if(sender == myEListSelekt) {
		if(myEListSelekt.isSelected()) {
			EBrowser.setSelectionMode(ListSelectionModel.MULTIPLE_INTERVAL_SELECTION);
		} else {
		        EBrowser.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		}
	}
	return;
}
private void changeLM()				/* fuer OEL Dialog */
{
	int b, d, e;
	double x;
	if(currentLM >= 0) {
		currentLE = myOEL.lagerelement(currentLM);
		currentLMat = currentLE.getMat();

		myLAB.setEditable(((currentLPZA == 0) || (currentLPZA == maxWeek)));
		
		myLMB.setDoubleValue(currentLE.minbest(currentLPZA));
		myLMRW.setDoubleValue(currentLE.mreichw(currentLPZA));
		myLeffMB.setDoubleValue(currentLE.sollmbest(currentLPZA));
		myLMRWB.setDoubleValue(currentLE.mrw_best(currentLPZA));
		
		x = currentLE.maxbest(currentLPZA);
		if(x >= 0) { myLHB.setDoubleValue(x); }
		else { myLHB.setStringValue("unendl."); }
		x = currentLE.hreichw(currentLPZA);
		if(x >= 0) { myLHRW.setDoubleValue(x); }
		else { myLHRW.setStringValue("unendl."); }
		x = currentLE.sollhbest(currentLPZA);
		if(x >= 0) { myLeffHB.setDoubleValue(x); }
		else { myLeffHB.setStringValue("unendl."); }
		x = currentLE.hrw_best(currentLPZA);
		if(x >= 0) { myLHRWB.setDoubleValue(x); }
		else { myLHRWB.setStringValue("unendl."); }
		
		myLSB.setDoubleValue(currentLE.vorprod(currentLPZA));
		myLeffSB.setDoubleValue(currentLE.sollbest(currentLPZA));
		myLRW.setDoubleValue(currentLE.reichw(currentLPZA));
		myLRWB.setDoubleValue(currentLE.rw_best(currentLPZA));
		
		x = currentLE.ist_reichw(currentLPZA);
		if(x >= 0) { myLIRW.setDoubleValue(x); }
		else { myLIRW.setStringValue("bis ENDE"); }

		myLAB.setDoubleValue(currentLE.anfbest(currentLPZA));

		/*
		if((currentLPZA == maxWeek) || (currentLPZA == 0)) {
			if(currentLPZA == 0) { myLAB.setDoubleValue(currentLE.anfbest(0)); }
			else { myLAB.setDoubleValue(currentLE.anfbest(maxWeek)); }
		}
		else { myLAB.setDoubleValue(currentLE.endbest((currentLPZA - 1))); }
		*/
		
		myLIB.setDoubleValue(currentLE.endbest(currentLPZA));
		myLINPUT.setDoubleValue(currentLE.input(currentLPZA));
		myLOUTPUT.setDoubleValue(currentLE.output(currentLPZA));
	}
	else {
		myLMB.setStringValue("");
		myLHB.setStringValue("");
		myLSB.setStringValue("");
		myLRW.setStringValue("");
		myLRWB.setStringValue("");
		myLIRW.setStringValue("");
		myLAB.setStringValue("");
		myLIB.setStringValue("");
		myLINPUT.setStringValue("");
		myLOUTPUT.setStringValue("");
		myLINPUT.setStringValue("");
	}
}
public void changeLParameter(NEDialogElement sender)
{
	int a;
	double x, y, z;
	LagerElement tmp;
	
	if(sender == myLHB) {
		if(currentLM >= 0) {
			x = myLHB.doubleValue();
			tmp = myOEL.lagerelement(currentLM);
			if(x >= 0) {
				if(x < tmp.minbest(currentLPZA)) {
					x = tmp.minbest(currentLPZA);
				}
				tmp.setMaxbest(x, currentLPZA);
			} else {
				tmp.setMaxbest((-1), currentLPZA);
				myLHB.setStringValue("unendl.");
			}
			  //  [self aktLager:self];
			mainController.update(false);
		} else { myLHB.setStringValue(""); }
		return;
	}
	if(sender == myLHRW) {
		if(currentLM >= 0) {
			x = myLHRW.doubleValue();
			tmp = myOEL.lagerelement(currentLM);
			if(x >= 0) {
				if(x < tmp.mreichw(currentLPZA)) {
					x = tmp.mreichw(currentLPZA);
				}
				tmp.setHreichw(x,currentLPZA);
			} else {
				tmp.setHreichw((-1),currentLPZA);
				myLHRW.setStringValue("unendl.");
			}
			   // [self aktLager:self);
			mainController.update(false);
		}
		else { myLHRW.setStringValue(""); }
		return;
	}
	if(sender == myLMB) {
		if(currentLM >= 0) {
			x = myLMB.doubleValue();
			tmp = myOEL.lagerelement(currentLM);
			if(x >= 0) {
				y = tmp.maxbest(currentLPZA);
				if(y >= 0) {
					if(x > y) {
						x = tmp.maxbest(currentLPZA);
					}
				}
				tmp.setMinbest(x,currentLPZA);
				  //  [self aktLager:self);
				mainController.update(false);
			} else {
				myLMB.setDoubleValue(tmp.minbest(currentLPZA));
			}
		} else { myLMB.setStringValue(""); }
		return;
	}
	if(sender == myLMRW) {
		if(currentLM >= 0) {
			x = myLMRW.doubleValue();
			tmp = myOEL.lagerelement(currentLM);
			if(x >= 0) {
				y = tmp.hreichw(currentLPZA);
				if(y >= 0) {
					if(x > y) {
						x = tmp.hreichw(currentLPZA);
					}
				}
				tmp.setMreichw(x,currentLPZA);
				  //  [self aktLager:self);
				mainController.update(false);
			} else {
					myLMRW.setDoubleValue(tmp.mreichw(currentLPZA));
			}
		} else { myLMB.setStringValue(""); }
		return;
	}
	if(sender == myLSB) {
		if(currentLM >= 0) {
			x = myLSB.doubleValue();
			tmp = myOEL.lagerelement(currentLM);
			y = tmp.maxbest(currentLPZA);
			z = tmp.minbest(currentLPZA);
			if(x >= 0) {
				if(((x > y) && (y >= 0)) || (x < z)) {
					JOptionPane.showMessageDialog(null, "Vorproduktion ist nicht im Regelbereich!");
				}	
				tmp.setVorprod(x,currentLPZA);
			   //     [self aktLager:self);
				mainController.update(false);
			}
			myLSB.setDoubleValue(tmp.vorprod(currentLPZA));
		} else { myLSB.setStringValue(""); }
		return;
	}
	if(sender == myLRW) {
		if(currentLM >= 0) {
			x = myLRW.doubleValue();
			tmp = myOEL.lagerelement(currentLM);
			if(x >= 0) {
				tmp.setReichw(x,currentLPZA);
				   // [self aktLager:self);
				mainController.update(false);
			} else {
				myLRW.setDoubleValue(tmp.reichw(currentLPZA));
			}
		} else { myLRW.setStringValue(""); }
		return;
	}
	if(sender == myLAB) {
		tmp = myOEL.lagerelement(currentLM);
		if((currentLPZA == 0)||(currentLPZA == maxWeek)) {
			if(currentLM >= 0) {
				x = myLAB.doubleValue();
				if(x >= 0) {
					tmp.setAnfbest(x,currentLPZA);
					   // [self aktLager:self);
					mainController.update(false);
				} else {
					myLAB.setDoubleValue(tmp.anfbest(currentLPZA));
				}
			} else { myLAB.setStringValue(""); }
		} else {
			myLAB.setDoubleValue(tmp.anfbest(currentLPZA));
		}
		return; 
	}
	return;
}
private void changeLPZA() {
	if(LWorM) {
		myLPZASlider.setMinMaxValue((maxWeek+1), maxPZA);
		currentLPZA = maxWeek;
	} else {
		myLPZASlider.setMinMaxValue(1, maxWeek);
		currentLPZA = 0;
	}
	myLPZASlider.setIntValue(currentLPZA + 1);
	myLrPZA.setIntValue(currentLPZA + 1);
	myLPZABez.setStringValue(myKalender.pzabez(currentLPZA));
}
public void changeLPZASlider(NEDialogElement sender)
{
	currentLPZA = myLPZASlider.intValue() - 1;
	myLrPZA.setIntValue(currentLPZA + 1);
	myLPZABez.setStringValue(myKalender.pzabez(currentLPZA));
	this.aktualisiereL(); 
}
public void changeLQParameter(NEDialogElement sender)
{
	int b;
	double x = 0;
	NEElement tmp;
	ProduktionsElement pe = null;
	EinkaufsElement ee = null;
	
	if(currentQ >= 0) {
		tmp = currentLMat.quelle(currentQ);
		if(tmp instanceof ProduktionsElement) {
			pe = (ProduktionsElement) tmp;
		} else {
			ee = (EinkaufsElement) tmp;
		}
	} else {
		myLQMM.setStringValue("");
		myLQQA.setStringValue("");
		return;
	}
		

	if(sender == myLQQA) {
		if((currentLMat.sourcecount() > 1) && (myQAContr != null)) { 
			x = myLQQA.doubleValue();
				myQAContr.openQAPanel((x/100), currentLPZA, currentLMat.quelle(currentQ));
			// ob schon im QA-Dialog???	
			//	mainController.update(false);
		} else {
			if(pe != null) {
				myLQQA.setDoubleValue(pe.quantl(currentLPZA)*100);
			} else {
				myLQQA.setDoubleValue(ee.quantl(currentLPZA)*100);
			}
		}
		return;
	}
		
	if(sender == myLQMM) {
		x = myLQMM.doubleValue();
		if(x >= 0) {
			if(pe != null) {
				pe.setMinmeng(x, currentLPZA);
			} else {
				ee.setMinmeng(x, currentLPZA);
			}
				//	[self aktLager:self];
			mainController.update(false); 
		} else {
			if(pe != null) {
				myLQMM.setDoubleValue(pe.minmeng(currentLPZA));
			} else {
				myLQMM.setDoubleValue(ee.minmeng(currentLPZA));
			}
		}
		return;
	}
	
}
public void changeLrPZA(NEDialogElement sender)
{
	currentLPZA = myLrPZA.intValue() - 1;
	if(LWorM) {
		if(currentLPZA > maxPZA) {
			currentLPZA = maxPZA-1;
			myLrPZA.setIntValue(currentLPZA + 1);
		}
		if(currentLPZA < maxWeek) {
			currentLPZA = maxWeek;
			myLrPZA.setIntValue(currentLPZA + 1);
		}
	}
	else {
		if(currentLPZA > maxWeek) {
			currentLPZA = maxWeek-1;
			myLrPZA.setIntValue(currentLPZA + 1);
		}
		if(currentLPZA < 0) {
			currentLPZA = 0;
			myLrPZA.setIntValue(currentLPZA + 1);
		}
	}
	myLPZASlider.setIntValue(currentLPZA + 1);
	myLPZABez.setStringValue(myKalender.pzabez(currentLPZA));
	this.aktualisiereL();
	
}
public void changeLWMMode(NEDialogElement sender)
{
	if(sender == myLMonate) {
		LWorM = true;
	} else {
		LWorM = false;
	} 
	this.changeLPZA();
	this.aktualisiereL();
}
public void changeNat(NEDialogElement sender)
{
	int a = myNat.intValue();
	if((a >= 0)&&(a <= 23)&&(a >= 0)) {
		myKalender.setNat(a,currentPZA);
		PZABrowser.setValueAt(new Integer(a), currentPZA, 2);
		myUModell.computeCapacity();
		mainController.update(NO);
	}  else { myNat.setIntValue(myKalender.nat(currentPZA)); }
}
private void changeOEP()
{
	double x;
	int a;
	myMaschAnz.setIntValue(myOEP.anzmasch(currentOPZA));
	myMaeAnz.setIntValue(myOEP.anzmae(currentOPZA));
	myFraAnz.setIntValue(myOEP.anzfra(currentOPZA));
	myZAh.setDoubleValue(myOEP.zah(currentOPZA));
	a = myOEP.schicht(currentOPZA);
	mySchicht.setIntValue(a);
	myPSchichtPM.setIntValue(a);
	x = myOEP.vbkMasch(currentOPZA,(a)) * 100;
	myMaschVbkt.setDoubleValue(x);
	myMaschVSlider.setDoubleValue(x);
	x = myOEP.vbkMae(currentOPZA,(a)) * 100;
	myMaeVbkt.setDoubleValue(x);
	myMaeVSlider.setDoubleValue(x);
	x = myOEP.vbkFra(currentOPZA,(a)) * 100;
	myFraVbkt.setDoubleValue(x);
	myFraVSlider.setDoubleValue(x);
	x = myOEP.auslfra(currentOPZA);
	if(x >= 0) { myFraAusl.setDoubleValue(x); }
	else { myFraAusl.setStringValue("unendl."); }
	x = myOEP.auslmae(currentOPZA);
	if(x >= 0) { myMaeAusl.setDoubleValue(x); }
	else { myMaeAusl.setStringValue("unendl."); }
	x = myOEP.auslmasch(currentOPZA);
	if(x >= 0) { myMaschAusl.setDoubleValue(x); }
	else { myMaschAusl.setStringValue("unendl."); }

}
private void changeOM()
{
	LagerElement le;
	double x;
	int am;
	if(currentOM >= 0) {
		currentPE = myOEP.produktionselement(currentOM);
		myQMM.setDoubleValue(currentPE.minmeng(currentOPZA));
		myQQA.setDoubleValue(currentPE.quantl(currentOPZA)*100);
		x = myOEP.iMsAusl(currentPE, currentOPZA);
		if(x < 0) { myQMsA.setStringValue("unendl."); }
		else { myQMsA.setDoubleValue(x); }
		myQOUTPUT.setDoubleValue(currentPE.output(currentOPZA));
		
		le = currentPE.getMat().lagerlagerelement();
		if(le == null) {
			myPQOELBez.setText("Kein Lager!");
		} else {
			myPQOELBez.setText(le.getOE().oeschl() + " " + le.getOE().bezeichnung());
		}
		
	} else {
		myQMM.setStringValue("");
		myQQA.setStringValue("");
		myQMsA.setStringValue("");
		myQOUTPUT.setStringValue("");
	}
	return;
}
private void changePPZA() {
	if(PWorM) {
		myPPZASlider.setMinMaxValue((maxWeek+1), maxPZA);
		currentOPZA = maxWeek;
	} else {
		myPPZASlider.setMinMaxValue(1, maxWeek);
		currentOPZA = 0;
	}
	myPPZASlider.setIntValue((currentOPZA + 1));
	myPrPZA.setIntValue((currentOPZA + 1));
	myPPZABez.setStringValue(myKalender.pzabez(currentOPZA)); 
}
public void changePPZASlider(NEDialogElement sender)
{
	currentOPZA = myPPZASlider.intValue() - 1;
	myPrPZA.setIntValue(currentOPZA + 1);
	myPPZABez.setStringValue(myKalender.pzabez(currentOPZA));
	this.aktualisiereP(); 
}
public void changePrPZA(NEDialogElement sender)
{	
 	currentOPZA = myPrPZA.intValue() - 1;
	if(PWorM) {
		if(currentOPZA >= maxPZA) {
			currentOPZA = maxPZA-1;
			myPrPZA.setIntValue(currentOPZA + 1);
		}
		if(currentOPZA < maxWeek) {
			currentOPZA = maxWeek;
			myPrPZA.setIntValue(currentOPZA + 1);
		}
	} else {
		if(currentOPZA >= maxWeek) {
			currentOPZA = maxWeek-1;
			myPrPZA.setIntValue(currentOPZA + 1);
		}
		if(currentOPZA < 0) {
			currentOPZA = 0;
			myPrPZA.setIntValue(currentOPZA + 1);
		}
	}
	myPPZASlider.setIntValue(currentOPZA + 1);
	myPPZABez.setStringValue(myKalender.pzabez(currentOPZA));
	this.aktualisiereP();
}
public void changePWMMode(NEDialogElement sender)
{
	if(sender == myPMonate) {
		PWorM = true;
	} else {
		PWorM = false;
	}
	this.changePPZA();
	this.aktualisiereP();
}
private void changePZA()
{
	int index = PZABrowser.selectedRow();
	myNat.setIntValue(myKalender.nat(currentPZA));
	if (index != currentPZA) {
		PZABrowser.selectRows(currentPZA, currentPZA);
	}
}
public void changePZABrowser(NEDialogElement sender)
{
	currentPZA = PZABrowser.selectedRow();
	myNat.setIntValue(myKalender.nat(currentPZA));
	myrPZA.setIntValue((currentPZA + 1));
	myPZASlider.setIntValue((currentPZA + 1));
	
}
public void changePZASlider(NEDialogElement sender)
{
		currentPZA = (myPZASlider.intValue() - 1);
		myrPZA.setIntValue((currentPZA + 1));
		this.changePZA();
}
private void changeQ()				/* fuer OEL Dialog */
{	
	double x;
	NEElement tmp;
	ProduktionsElement pe;
	EinkaufsElement ee;
	if(currentQ >= 0) {
		tmp = currentLMat.quelle(currentQ);
		if(tmp instanceof ProduktionsElement) {
			pe = (ProduktionsElement) tmp;
			myLQMM.setDoubleValue(pe.minmeng(currentLPZA));
			myLQQA.setDoubleValue(pe.quantl(currentLPZA)*100);
			myLQOUT.setDoubleValue(pe.output(currentLPZA));
			x = pe.getOE().auslmasch(currentLPZA);
			if(x < 0) { myLQAus.setStringValue("unendl."); }
			else {  myLQAus.setDoubleValue(x); }
			x = pe.getOE().iMsAusl(pe, currentLPZA);
			if(x < 0) { myLQms.setStringValue("unendl."); }
			else { myLQms.setDoubleValue(x); }
		}
		if(tmp instanceof EinkaufsElement) {
			ee = (EinkaufsElement) tmp;
			myLQMM.setDoubleValue(ee.minmeng(currentLPZA));
			myLQQA.setDoubleValue(ee.quantl(currentLPZA)*100);
			myLQOUT.setDoubleValue(ee.output(currentLPZA));
			myLQAus.setStringValue("");
			myLQms.setStringValue("");
		}
	}
	else {
	 	myLQMM.setStringValue("");
		myLQQA.setStringValue("");
		myLQOUT.setStringValue(""); 
	}
 
}
public void changeQMM(NEDialogElement sender)
{
	double x;
	if(currentPE != null) {
		x = myQMM.doubleValue();
		if(x >= 0) {
			currentPE.setMinmeng(x, currentOPZA);
			this.changeOM();

			mainController.update(false); 
		}
		else {
			myQMM.setDoubleValue(currentPE.minmeng(currentOPZA));
		}
	}
	else { myQMM.setStringValue(""); } 
}
public void changeQQA(NEDialogElement sender)
{	
	double x;
	if((currentPE != null) && (myQAContr != null)) {
		if((currentPE.getMat().sourcecount() > 1) && (myQAContr != null)) {
			x = myQQA.doubleValue();
			// Aufruf QA-Dialog 
			myQAContr.openQAPanel((x/100), currentOPZA, currentPE);
		}
		else {
			myQQA.setDoubleValue(currentPE.quantl(currentOPZA)*100);
		}

	}
	else { myQQA.setStringValue(""); } 
}
public void changeRPZA(NEDialogElement sender)
{
	currentPZA = (myrPZA.intValue() - 1);
	if(currentPZA >= maxPZA) {
		currentPZA = (maxPZA -1);
		myrPZA.setIntValue((currentPZA + 1));
	}
	if(currentPZA < 0) {
		currentPZA = 0;
		myrPZA.setIntValue((currentPZA + 1));
	}
	myPZASlider.setIntValue((currentPZA + 1));
	this.changePZA();
}
public void changeSAB(NEDialogElement sender)
{
 	double x;
	LagerElement tmp = currentULE;
	if((currentOPZA == 0)||(currentOPZA == maxWeek)) {
		if(currentULE != null) {
			x = mySAB.doubleValue();
			if(x >= 0) {
				currentULE.setAnfbest(x, currentOPZA);
				this.changeUM();

				mainController.update(false); 
			}
			else {
				mySAB.setDoubleValue(currentULE.anfbest(currentOPZA));
			}
		}
		else { mySAB.setStringValue(""); }
	}
	else { mySAB.setDoubleValue(currentULE.anfbest(currentOPZA));  } 
}
public void changeSchicht(NEDialogElement sender)
{
	double x;
	int b = 1;

	if(sender == mySchicht) {	
		b = mySchicht.intValue();
		if(b <= 0) { 
			b = 1; 
			mySchicht.setIntValue(b);
		}
		if(b >= 4) { 
			b = 3;
			mySchicht.setIntValue(b);
		}
		myPSchichtPM.setIntValue(b);
	}
	if(sender == myPSchichtPM) {
	
		b = myPSchichtPM.intValue();
		mySchicht.setIntValue(b);
	}
	myOEP.setSchicht(b, currentOPZA); 
	x = myOEP.vbkMasch(currentOPZA,(b)) * 100;
	myMaschVbkt.setDoubleValue(x);
	myMaschVSlider.setDoubleValue(x);
	x = myOEP.vbkMae(currentOPZA, (b)) * 100;
	myMaeVbkt.setDoubleValue(x);
	myMaeVSlider.setDoubleValue(x);
	x = myOEP.vbkFra(currentOPZA, (b)) * 100;
	myFraVbkt.setDoubleValue(x);
	myFraVSlider.setDoubleValue(x);
	x = myOEP.auslmasch(currentOPZA);
	if(x >= 0) { myMaschAusl.setDoubleValue(x); }
	else { myMaschAusl.setStringValue("unendl."); }
	x = myOEP.auslmae(currentOPZA);
	if(x >= 0) { myMaeAusl.setDoubleValue(x); }
	else { myMaeAusl.setStringValue("unendl."); }
	x = myOEP.auslfra(currentOPZA);
	if(x >= 0) { myFraAusl.setDoubleValue(x); }
	else { myFraAusl.setStringValue("unendl."); }
	if(currentPE != null) {
		x = myOEP.iMsAusl(currentPE, currentOPZA);
		if(x < 0) { myQMsA.setStringValue("unendl."); }
		else { myQMsA.setDoubleValue(x); }
	}
	mainController.update(false);
}
public void changeSHB(NEDialogElement sender)
{
	double x;
	if(currentULE != null) {
			x = mySHB.doubleValue();
		if(x >= 0) {
			if(x < currentULE.minbest(currentOPZA)) {
				x = currentULE.minbest(currentOPZA);
			}
			currentULE.setMaxbest(x,currentOPZA);
		}
		else {
			currentULE.setMaxbest((-1), currentOPZA);
			mySHB.setStringValue("unendl.");
		}
		this.changeUM();
		
		mainController.update(false); 
	}
	else { mySHB.setStringValue(""); }
}
public void changeSMB(NEDialogElement sender)
{
	double x, y;
	if(currentULE != null) {
		x = mySMB.doubleValue();
		if(x >= 0) {
			y = currentULE.maxbest(currentOPZA);
			if(y >= 0) {
				if(x > y) {
					x = currentULE.maxbest(currentOPZA);
				}
			}
			currentULE.setMinbest(x, currentOPZA);
			this.changeUM();
			mainController.update(false); 
		}
		else {
			mySMB.setDoubleValue(currentULE.minbest(currentOPZA));
		}
	}
	else { mySMB.setStringValue(""); } 
}
public void changeSRW(NEDialogElement sender)
{
	double x;
	if(currentULE != null) {
		x = mySRW.doubleValue();
		if(x >= 0) {
			currentULE.setReichw(x, currentOPZA);
			this.changeUM();
			
			mainController.update(false); 
		}
		else {
			mySRW.setDoubleValue(currentULE.reichw(currentOPZA));
		}
	}
	else { mySRW.setStringValue(""); } 
}
public void changeSSB(NEDialogElement sender)
{
	double x, y, z;
	y = z = 0;
	if(currentULE != null) {
		x = mySSB.doubleValue();
		y = currentULE.maxbest(currentOPZA);
		z = currentULE.minbest(currentOPZA);
		if(x >= 0) {
			if(((x > y) && (y >= 0)) || (x < z)) {
				JOptionPane.showMessageDialog(null, "Sollbestand ist nicht im Regelbereich!");
			}
			currentULE.setVorprod(x, currentOPZA);
			this.changeUM();
			
			mainController.update(false); 
		}
		mySSB.setDoubleValue(currentULE.vorprod(currentOPZA));
	}
	else { mySSB.setStringValue(""); }
}
private void changeUM()
{
	double x;
	LagerElement le;

	if(currentUM >= 0) { 
		currentULE = (LagerElement) currentPE.stuecklistenelement(currentUM).supplier(0);

		mySAB.setEditable(((currentOPZA == 0) || (currentOPZA == maxWeek)));
		
		mySMB.setDoubleValue(currentULE.minbest(currentOPZA));
		x = currentULE.maxbest(currentOPZA);
		if(x >= 0) { mySHB.setDoubleValue(x); }
		else { mySHB.setStringValue("unendl."); }
		mySSB.setDoubleValue(currentULE.vorprod(currentOPZA));
		mySRW.setDoubleValue(currentULE.reichw(currentOPZA));
		mySRWB.setDoubleValue(currentULE.rw_best(currentOPZA));
		mySAB.setDoubleValue(currentULE.anfbest(currentOPZA));
		mySIST.setDoubleValue(currentULE.endbest(currentOPZA));
		mySOUTPUT.setDoubleValue(currentULE.output(currentOPZA));
		mySINPUT.setDoubleValue(currentULE.input(currentOPZA));
		
		mySmsV.setDoubleValue(currentPE.stuecklistenelement(currentUM).output(currentOPZA));

		le = currentULE.getMat().lagerlagerelement();
		if(le == null) {
			myPSOELBez.setText("Kein Lager!");
		} else {
			myPSOELBez.setText(le.getOE().oeschl() + " " + le.getOE().bezeichnung());
		}
		
	} else { 
		mySMB.setStringValue("");
		mySHB.setStringValue("");
		mySSB.setStringValue("");
		mySRW.setStringValue("");
		mySRWB.setStringValue("");
		mySIST.setStringValue("");
		mySAB.setStringValue("");
		mySINPUT.setStringValue("");
		mySOUTPUT.setStringValue("");
		mySmsV.setStringValue("");
	}
}
public void changeVFra(NEDialogElement sender)
{
	double x;
	int a = myOEP.schicht(currentOPZA);
	x = myFraVbkt.doubleValue();
	if(x < 0) { 
		x = 0;
		myFraVbkt.setDoubleValue(x); 
	}
	if(x > 100) { 
		x = 100;
		myFraVbkt.setDoubleValue(x); 
	}
	myFraVSlider.setDoubleValue(x);
	myOEP.setVfra((x / 100), currentOPZA, (a));
	x = myOEP.auslfra(currentOPZA);
	if(x >= 0) { myFraAusl.setDoubleValue(x); }
	else { myFraAusl.setStringValue("unendl."); }
	mainController.update(false);
}
private void changeVM()
{
	LagerElement le;
	double x;
	int am;
	if(currentVM >= 0) {
		currentVE = myOEV.verkaufselement(currentVM);
		
		myVAR.setEditable(((currentVPZA == 0) || (currentVPZA == maxWeek)));
		
		myVBedarf.setDoubleValue(currentVE.amount(currentVPZA));
		myVZBedarf.setDoubleValue(currentVE.extraamount(currentVPZA));
		myVAR.setDoubleValue(currentVE.rueck(currentVPZA));
		
		le = currentVE.getMat().lagerlagerelement();
		if(le == null) {
			myVOELBez.setText("Kein Lager!");
		} else {
			myVOELBez.setText(le.getOE().oeschl() + " " + le.getOE().bezeichnung());
		}
		
	} else {
		myVBedarf.setStringValue("");
		myVZBedarf.setStringValue("");
		myVAR.setStringValue("");
		myVOELBez.setText("");
	}
	return;
}
public void changeVMae(NEDialogElement sender)
{
	double x;
	int a = myOEP.schicht(currentOPZA);
	x = myMaeVbkt.doubleValue();
	if(x < 0) { 
		x = 0;
		myMaeVbkt.setDoubleValue(x); 
	}
	if(x > 100) { 
		x = 100;
		myMaeVbkt.setDoubleValue(x); 
	}
	myMaeVSlider.setDoubleValue(x);
	myOEP.setVmae((x / 100), currentOPZA, (a));
	x = myOEP.auslmae(currentOPZA);
	if(x >= 0) { myMaeAusl.setDoubleValue(x); }
	else { myMaeAusl.setStringValue("unendl."); }
	mainController.update(false);
}
public void changeVMasch(NEDialogElement sender)
{
	double x;
	int a = myOEP.schicht(currentOPZA);
	x = myMaschVbkt.doubleValue();
	if(x < 0) { 
		x = 0;
		myMaschVbkt.setDoubleValue(x); 
	}
	if(x > 100) { 
		x = 100;
		myMaschVbkt.setDoubleValue(x); 
	}
	myMaschVSlider.setDoubleValue(x);
	myOEP.setVmasch((x / 100), currentOPZA, (a));
	x = myOEP.auslmasch(currentOPZA);
	if(x >= 0) { myMaschAusl.setDoubleValue(x); }
	else { myMaschAusl.setStringValue("unendl."); }
	if(currentPE != null) {
		x = myOEP.iMsAusl(currentPE, currentOPZA);
		if(x < 0) { myQMsA.setStringValue("unendl."); }
		else { myQMsA.setDoubleValue(x); }
	}
	mainController.update(false);
}
public void changeVParameter(NEDialogElement sender)
{
	double x;
	
	if(currentVE != null) {	
		if(sender == myVBedarf) {
			x = myVBedarf.doubleValue();
			if(x >= 0) {
				currentVE.setAmount(x, currentVPZA);
				this.changeVM();

				mainController.update(false); 
			}
			else {
				myVBedarf.setDoubleValue(currentVE.amount(currentVPZA));
			}
		}
		if(sender == myVZBedarf) {
			x = myVZBedarf.doubleValue();
			if(x >= 0) {
				currentVE.setExtraamount(x, currentVPZA);
				this.changeVM();

				mainController.update(false); 
			}
			else {
				myVZBedarf.setDoubleValue(currentVE.extraamount(currentVPZA));
			}
		}
		if(sender == myVAR) {
			x = myVAR.doubleValue();
			currentVE.setRueck(x, currentVPZA);
			this.changeVM();

			mainController.update(false); 
		}	
		
	} else { 
		myVBedarf.setStringValue("");
		myVZBedarf.setStringValue("");
		myVAR.setStringValue("");	
	} 
}
private void changeVPZA() {
	if(VWorM) {
		myVPZASlider.setMinMaxValue((maxWeek+1), maxPZA);
		currentVPZA = maxWeek;
	} else {
		myVPZASlider.setMinMaxValue(1, maxWeek);
		currentVPZA = 0;
	}
	myVPZASlider.setIntValue(currentVPZA + 1);
	myVrPZA.setIntValue(currentVPZA + 1);
	myVPZABez.setStringValue(myKalender.pzabez(currentVPZA));
}
public void changeVPZASlider(NEDialogElement sender)
{
	currentVPZA = myVPZASlider.intValue() - 1;
	myVrPZA.setIntValue(currentVPZA + 1);
	myVPZABez.setStringValue(myKalender.pzabez(currentVPZA));
	this.aktualisiereV(); 
}
public void changeVrPZA(NEDialogElement sender)
{
	currentVPZA = myVrPZA.intValue() - 1;
	if(VWorM) {
		if(currentVPZA > maxPZA) {
			currentVPZA = maxPZA-1;
			myVrPZA.setIntValue(currentVPZA + 1);
		}
		if(currentVPZA < maxWeek) {
			currentVPZA = maxWeek;
			myVrPZA.setIntValue(currentVPZA + 1);
		}
	}
	else {
		if(currentVPZA > maxWeek) {
			currentVPZA = maxWeek-1;
			myVrPZA.setIntValue(currentVPZA + 1);
		}
		if(currentVPZA < 0) {
			currentVPZA = 0;
			myVrPZA.setIntValue(currentVPZA + 1);
		}
	}
	myVPZASlider.setIntValue(currentVPZA + 1);
	myVPZABez.setStringValue(myKalender.pzabez(currentVPZA));
	this.aktualisiereV();
	
}
public void changeVSlider(NEDialogElement sender)
{
	double x;
	int a = myOEP.schicht(currentOPZA);
	
	if(sender == myMaschVSlider) {
		x = myMaschVSlider.doubleValue();
		myMaschVbkt.setDoubleValue(x);
		myOEP.setVmasch((x / 100), currentOPZA, (a));
		x = myOEP.auslmasch(currentOPZA);
		if(x >= 0) { myMaschAusl.setDoubleValue(x); }
		else { myMaschAusl.setStringValue("unendl."); }
		if(currentPE != null) {
			x = myOEP.iMsAusl(currentPE, currentOPZA);
			if(x < 0) { myQMsA.setStringValue("unendl."); }
			else { myQMsA.setDoubleValue(x); }
		}
	}
	if(sender == myMaeVSlider) {
		x = myMaeVSlider.doubleValue();
		myMaeVbkt.setDoubleValue(x);
		myOEP.setVmae((x / 100), currentOPZA, (a));
		x = myOEP.auslmae(currentOPZA);
		if(x >= 0) { myMaeAusl.setDoubleValue(x); }
		else { myMaeAusl.setStringValue("unendl."); }
	}
	if(sender == myFraVSlider) {
		x = myFraVSlider.doubleValue();
		myFraVbkt.setDoubleValue(x);
		myOEP.setVfra((x / 100), currentOPZA, (a));
		x = myOEP.auslfra(currentOPZA);
		if(x >= 0) { myFraAusl.setDoubleValue(x); }
		else { myFraAusl.setStringValue("unendl."); }
	}
	mainController.update(false);

}
public void changeVWMMode(NEDialogElement sender)
{
	if(sender == myEMonate) {
		VWorM = true;
	} else {
		VWorM = false;
	}
	this.changeVPZA();
	this.aktualisiereV();
}
public void changeZAh(NEDialogElement sender)
{
	int a;
	double x = 0;
	double y = 0;
	a = myOEP.schicht(currentOPZA);
	y = myZAh.doubleValue();
	switch(a) {
		case 1:
			if(y > 128) { 
				y = 128; 
				myZAh.setDoubleValue(y);
			}
			if(y < 0) { 
				y = 0;
				myZAh.setDoubleValue(y); 
			}
			break;
		case 2:
			if(y > 88) { 
				y = 88; 
				myZAh.setDoubleValue(y);
			}
			if(y < 0) { 
				y = 0;
				myZAh.setDoubleValue(y); 
			}
			break;
		case 3:
			if(y > 48) { 
				y = 48; 
				myZAh.setDoubleValue(y);
			}
			if(y < 0) { 
				y = 0;
				myZAh.setDoubleValue(y); 
			}
			break;
	}
	myOEP.setZah(y, currentOPZA);

	x = myOEP.auslmasch(currentOPZA);
	if(x >= 0) { myMaschAusl.setDoubleValue(x); }
	else { myMaschAusl.setStringValue("unendl."); }
	if(currentPE != null) {
		x = myOEP.iMsAusl(currentPE, currentOPZA);
		if(x < 0) { myQMsA.setStringValue("unendl."); }
		else { myQMsA.setDoubleValue(x); }
	}

	x = myOEP.auslmae(currentOPZA);
	if(x >= 0) { myMaeAusl.setDoubleValue(x); }
	else { myMaeAusl.setStringValue("unendl."); }

	x = myOEP.auslfra(currentOPZA);
	if(x >= 0) { myFraAusl.setDoubleValue(x); }
	else { myFraAusl.setStringValue("unendl."); }

	mainController.update(false);
}
/**
 * Insert the method's description here.
 * Creation date: (02.11.00 11:31:14)
 */
private void createOEEPanel() {

			javax.swing.JLabel LIconLabel = new javax.swing.JLabel();
			LIconLabel.setName("LIconLabel");
			LIconLabel.setIcon(new javax.swing.ImageIcon(getClass().getResource("/dia.gif")));
			LIconLabel.setText("");
			LIconLabel.setBounds(420, 20, 25, 35);

			javax.swing.JLabel myELabelList = new javax.swing.JLabel();
			myELabelList.setName("myELabelList");
			myELabelList.setFont(new java.awt.Font("dialog.bold", 1, 12));
			myELabelList.setText("Listenoption");
			myELabelList.setBounds(65, 225, 117, 17);
			myELabelList.setForeground(java.awt.Color.black);
			myELabelList.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
			
			javax.swing.JLabel myELabelMM = new javax.swing.JLabel();
			myELabelMM.setName("myELabelMM");
			myELabelMM.setFont(new java.awt.Font("dialog", 0, 12));
			myELabelMM.setText("Mindestmenge:");
			myELabelMM.setBounds(260, 265, 100, 17);
			myELabelMM.setForeground(java.awt.Color.black);
			myELabelMM.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);

			javax.swing.JLabel myELabelOut = new javax.swing.JLabel();
			myELabelOut.setName("myELabelOut");
			myELabelOut.setFont(new java.awt.Font("dialog", 0, 12));
			myELabelOut.setText("Output:");
			myELabelOut.setBounds(280, 289, 80, 17);
			myELabelOut.setForeground(java.awt.Color.black);
			myELabelOut.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
	
			javax.swing.JLabel myELabelPZA = new javax.swing.JLabel();
			myELabelPZA.setName("myELabelPZA");
			myELabelPZA.setFont(new java.awt.Font("dialog.bold", 1, 12));
			myELabelPZA.setText("Planungszeitabschnitt");
			myELabelPZA.setBounds(85, 170, 178, 17);
			myELabelPZA.setForeground(java.awt.Color.black);
			myELabelPZA.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);

			javax.swing.JLabel myELabelQA = new javax.swing.JLabel();
			myELabelQA.setName("myELabelQA");
			myELabelQA.setFont(new java.awt.Font("dialog", 0, 12));
			myELabelQA.setText("Quellenanteil:");
			myELabelQA.setBounds(280, 241, 80, 17);
			myELabelQA.setForeground(java.awt.Color.black);
			myELabelQA.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);

			javax.swing.JLabel myELabelOEL = new javax.swing.JLabel();
			myELabelOEL.setName("myELabelOEL");
			myELabelOEL.setFont(new java.awt.Font("dialog.bold", 0, 12));
			myELabelOEL.setText("zu OEL:");
			myELabelOEL.setBounds(15, 325, 80, 17);
			myELabelOEL.setForeground(java.awt.Color.black);
			myELabelOEL.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);

// ======================================================================================
					
			myEPZABez = new NETextField("", null);
			myEPZABez.setName("myEPZABez");
			myEPZABez.setBounds(15, 190, 80, 21);
			myEPZABez.setEditable(false);

			myErPZA = new NENumberTextField("", this, "changeErPZA");
			myErPZA.setName("myErPZA");
			myErPZA.setBounds(100, 190, 25, 21);
			myErPZA.setIntegerFormat(false);

			myEPZASlider = new NEScrollBar(this, "changeEPZASlider");
			myEPZASlider.setName("myEPZASlider");	
			myEPZASlider.setBounds(135, 192, 215, 17);
			myEPZASlider.setOrientation(javax.swing.JScrollBar.HORIZONTAL);

// ======================================================================================

			myEWochen = new NERadioButton("Wochen", this, "changeEWMMode");
			myEWochen.setName("myEWochen");
			myEWochen.setBounds(380, 105, 80, 20);

			myEMonate = new NERadioButton("Monate", this, "changeEWMMode");
			myEMonate.setName("myEMonate");
			myEMonate.setBounds(380, 125, 80, 20);

			// Group the radio buttons.
			ButtonGroup group = new ButtonGroup();
			group.add((JRadioButton)myEWochen.getComponent());
			group.add((JRadioButton)myEMonate.getComponent());

			EWorM = true;
			myEMonate.setSelected(true);

			myEListOptAllMat = new NECheckBox("alle Mat.", null, null);
			myEListOptAllMat.setName("myEListOptAllMat");
			myEListOptAllMat.setBounds(15, 245, 80, 20);

			myEListOptAllPZA = new NECheckBox("alle PZA", null, null);
			myEListOptAllPZA.setName("myEListOptAllPZA");
			myEListOptAllPZA.setBounds(15, 265, 80, 20);

			myEListOptNull = new NECheckBox("nur > 0", null, null);
			myEListOptNull.setName("myEListOptNull");
			myEListOptNull.setBounds(15, 285, 80, 20);

			myEListSelekt = new NECheckBox("Selektion", this, "changeESelectionMode");
			myEListSelekt.setName("myEListSelekt");
			myEListSelekt.setBounds(120, 245, 80, 20);
			
			myEListButton = new NEButton("Liste", this, "generateEList");
			myEListButton.setName("myEListButton");
			myEListButton.setBounds(120, 280, 80, 25);
			
// ======================================================================================

			myEQA = new NENumberTextField("", this, "changeEParameter");
			myEQA.setName("myEQA");
			myEQA.setBounds(365, 240, 80, 21);

			myEMM = new NENumberTextField("", this, "changeEParameter");
			myEMM.setName("myEMM");
			myEMM.setBounds(365, 264, 80, 21);

			myEOut = new NENumberTextField("", null);
			myEOut.setName("myEOut");
			myEOut.setBounds(365, 288, 80, 21);
			myEOut.setEditable(false);

// ======================================================================================

			EBrowser = new NETableBrowser(this, "browserClick", null);
			EBrowser.setName("EBrowser");
			EBrowser.setBounds(15, 15, 350, 150);

// ======================================================================================

			javax.swing.JSeparator ESeparator1 = new javax.swing.JSeparator();
			ESeparator1.setName("ESeparator1");
			ESeparator1.setBounds(15, 220, 430, 2);
			
			javax.swing.JSeparator ESeparator2 = new javax.swing.JSeparator();
			ESeparator2.setName("ESeparator2");
			ESeparator2.setBounds(230, 220, 2, 95);
			ESeparator2.setOrientation(javax.swing.SwingConstants.VERTICAL);
			
			javax.swing.JSeparator ESeparator3 = new javax.swing.JSeparator();
			ESeparator3.setName("ESeparator3");
			ESeparator3.setBounds(15, 315, 430, 2);

			myEOELBez = new javax.swing.JLabel();
			myEOELBez.setName("myEOELBez");
			myEOELBez.setFont(new java.awt.Font("dialog.bold", 0, 12));
			myEOELBez.setText("");
			myEOELBez.setBounds(100, 325, 250, 17);
			myEOELBez.setForeground(java.awt.Color.black);
			myEOELBez.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);

			NEPanel theDialogContentPane = new NEPanel();
			theDialogContentPane.setName("JDialogContentPane");
			theDialogContentPane.setLayout(null);
			theDialogContentPane.add(LIconLabel);
			theDialogContentPane.add(myELabelList);
			theDialogContentPane.add(myELabelMM);
			theDialogContentPane.add(myELabelOEL);
			theDialogContentPane.add(myELabelOut);
			theDialogContentPane.add(myELabelPZA);
			theDialogContentPane.add(myELabelQA);
			theDialogContentPane.add(myEOELBez);
			theDialogContentPane.add(ESeparator1);
			theDialogContentPane.add(ESeparator2);
			theDialogContentPane.add(ESeparator3);
			theDialogContentPane.add(EBrowser);
			theDialogContentPane.add(myEListOptAllMat);
			theDialogContentPane.add(myEListOptAllPZA);
			theDialogContentPane.add(myEListButton);
			theDialogContentPane.add(myEListOptNull);
			theDialogContentPane.add(myEListSelekt);
			theDialogContentPane.add(myEMonate);
			theDialogContentPane.add(myEQA);
			theDialogContentPane.add(myEMM);			
			theDialogContentPane.add(myEOut);
			theDialogContentPane.add(myEPZABez);
			theDialogContentPane.add(myEPZASlider);
			theDialogContentPane.add(myErPZA);
			theDialogContentPane.add(myEWochen);

			myOEEPanel = new javax.swing.JFrame();
			myOEEPanel.setName("myOEEPanel");
			myOEEPanel.setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
			myOEEPanel.setResizable(false);
			myOEEPanel.setBounds(525, 425, 460+wp, 355+hp);
			myOEEPanel.setTitle("Einkauf");
			myOEEPanel.setContentPane(theDialogContentPane.getComponent());
	
	return;	
}
/**
 * Insert the method's description here.
 * Creation date: (02.11.00 11:31:14)
 */
private void createOELPanel() {

			javax.swing.JLabel LIconLabel = new javax.swing.JLabel();
			LIconLabel.setName("LIconLabel");
			LIconLabel.setIcon(new javax.swing.ImageIcon(getClass().getResource("/dia.gif")));
			LIconLabel.setText("");
			LIconLabel.setBounds(530, 20, 25, 35);

			javax.swing.JLabel myLLabelMin = new javax.swing.JLabel();
			myLLabelMin.setName("myLLabelMin");
			myLLabelMin.setFont(new java.awt.Font("dialog.bold", 1, 12));
			myLLabelMin.setText("Mindest");
			myLLabelMin.setBounds(113, 440, 53, 17);
			myLLabelMin.setForeground(java.awt.Color.black);
			myLLabelMin.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);

			javax.swing.JLabel myLLabelEff = new javax.swing.JLabel();
			myLLabelEff.setName("myLLabelEff");
			myLLabelEff.setFont(new java.awt.Font("dialog", 0, 12));
			myLLabelEff.setText("effektiv:");
			myLLabelEff.setBounds(15, 462, 80, 17);
			myLLabelEff.setForeground(java.awt.Color.black);
			myLLabelEff.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);

			javax.swing.JLabel myLLabelRW = new javax.swing.JLabel();
			myLLabelRW.setName("myLLabelRW");
			myLLabelRW.setFont(new java.awt.Font("dialog", 0, 12));
			myLLabelRW.setText("aus Reichw.:");
			myLLabelRW.setBounds(15, 486, 80, 17);
			myLLabelRW.setForeground(java.awt.Color.black);
			myLLabelRW.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);

			javax.swing.JLabel myLLabelAbs = new javax.swing.JLabel();
			myLLabelAbs.setName("myLLabelAbs");
			myLLabelAbs.setFont(new java.awt.Font("dialog", 0, 12));
			myLLabelAbs.setText("absolut:");
			myLLabelAbs.setBounds(15, 509, 80, 17);
			myLLabelAbs.setForeground(java.awt.Color.black);
			myLLabelAbs.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);

			javax.swing.JLabel myLLabelRW1 = new javax.swing.JLabel();
			myLLabelRW1.setName("myLLabelRW1");
			myLLabelRW1.setFont(new java.awt.Font("dialog", 0, 12));
			myLLabelRW1.setText("Reichweite:");
			myLLabelRW1.setBounds(15, 534, 80, 17);
			myLLabelRW1.setForeground(java.awt.Color.black);
			myLLabelRW1.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);

			javax.swing.JLabel myLLabelAusl = new javax.swing.JLabel();
			myLLabelAusl.setName("myLLabelAusl");
			myLLabelAusl.setFont(new java.awt.Font("dialog", 0, 12));
			myLLabelAusl.setText("Auslastung:");
			myLLabelAusl.setBounds(395, 307, 80, 17);
			myLLabelAusl.setForeground(java.awt.Color.black);
			myLLabelAusl.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);

			javax.swing.JLabel myLLabelMs = new javax.swing.JLabel();
			myLLabelMs.setName("myLLabelMs");
			myLLabelMs.setFont(new java.awt.Font("dialog", 0, 12));
			myLLabelMs.setText("mat.-spez:");
			myLLabelMs.setBounds(395, 331, 80, 17);
			myLLabelMs.setForeground(java.awt.Color.black);
			myLLabelMs.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);

			javax.swing.JLabel myLLabelQA = new javax.swing.JLabel();
			myLLabelQA.setName("myLLabelQA");
			myLLabelQA.setFont(new java.awt.Font("dialog", 0, 12));
			myLLabelQA.setText("Qu.-Anteil:");
			myLLabelQA.setBounds(395, 355, 80, 17);
			myLLabelQA.setForeground(java.awt.Color.black);
			myLLabelQA.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);

			javax.swing.JLabel myLLabelMM = new javax.swing.JLabel();
			myLLabelMM.setName("myLLabelMM");
			myLLabelMM.setFont(new java.awt.Font("dialog", 0, 12));
			myLLabelMM.setText("Min.-Menge:");
			myLLabelMM.setBounds(395, 379, 80, 17);
			myLLabelMM.setForeground(java.awt.Color.black);
			myLLabelMM.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);

			javax.swing.JLabel myLLabelOut = new javax.swing.JLabel();
			myLLabelOut.setName("myLLabelOut");
			myLLabelOut.setFont(new java.awt.Font("dialog", 0, 12));
			myLLabelOut.setText("Output:");
			myLLabelOut.setBounds(395, 403, 80, 17);
			myLLabelOut.setForeground(java.awt.Color.black);
			myLLabelOut.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);

			javax.swing.JLabel myLLabelIRW = new javax.swing.JLabel();
			myLLabelIRW.setName("myLLabelIRW");
			myLLabelIRW.setFont(new java.awt.Font("dialog", 0, 12));
			myLLabelIRW.setText("Ist-Reichw.:");
			myLLabelIRW.setBounds(395, 486, 80, 17);
			myLLabelIRW.setForeground(java.awt.Color.black);
			myLLabelIRW.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);

			javax.swing.JLabel myLLabelIB = new javax.swing.JLabel();
			myLLabelIB.setName("myLLabelIB");
			myLLabelIB.setFont(new java.awt.Font("dialog", 0, 12));
			myLLabelIB.setText("Ist-Bestand:");
			myLLabelIB.setBounds(395, 462, 80, 17);
			myLLabelIB.setForeground(java.awt.Color.black);
			myLLabelIB.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);

			javax.swing.JLabel myLLabelOut2 = new javax.swing.JLabel();
			myLLabelOut2.setName("myLLabelOut2");
			myLLabelOut2.setFont(new java.awt.Font("dialog", 0, 12));
			myLLabelOut2.setText("Output:");
			myLLabelOut2.setBounds(395, 534, 80, 17);
			myLLabelOut2.setForeground(java.awt.Color.black);
			myLLabelOut2.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);

			javax.swing.JLabel myLLabelIn = new javax.swing.JLabel();
			myLLabelIn.setName("myLLabelIn");
			myLLabelIn.setFont(new java.awt.Font("dialog", 0, 12));
			myLLabelIn.setText("Input:");
			myLLabelIn.setBounds(395, 510, 80, 17);
			myLLabelIn.setForeground(java.awt.Color.black);
			myLLabelIn.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);

			javax.swing.JLabel myLLabelAB = new javax.swing.JLabel();
			myLLabelAB.setName("myLLabelAB");
			myLLabelAB.setFont(new java.awt.Font("dialog", 0, 12));
			myLLabelAB.setText("Anfangsbest.:");
			myLLabelAB.setBounds(395, 438, 80, 17);
			myLLabelAB.setForeground(java.awt.Color.black);
			myLLabelAB.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);

			javax.swing.JLabel myLLabelSoll = new javax.swing.JLabel();
			myLLabelSoll.setName("myLLabel2");
			myLLabelSoll.setFont(new java.awt.Font("dialog.bold", 1, 12));
			myLLabelSoll.setText("Soll");
			myLLabelSoll.setBounds(200, 440, 53, 17);
			myLLabelSoll.setForeground(java.awt.Color.black);
			myLLabelSoll.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);

			javax.swing.JLabel myLLabelH = new javax.swing.JLabel();
			myLLabelH.setName("myLLabelH");
			myLLabelH.setFont(new java.awt.Font("dialog.bold", 1, 12));
			myLLabelH.setText("Hchst");
			myLLabelH.setBounds(285, 440, 53, 17);
			myLLabelH.setForeground(java.awt.Color.black);
			myLLabelH.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);

			javax.swing.JLabel myLLabelPZA = new javax.swing.JLabel();
			myLLabelPZA.setName("myLLabelPZA");
			myLLabelPZA.setFont(new java.awt.Font("dialog.bold", 1, 12));
			myLLabelPZA.setText("Planungszeitabschnitt");
			myLLabelPZA.setBounds(84, 172, 178, 17);
			myLLabelPZA.setForeground(java.awt.Color.black);
			myLLabelPZA.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);

			javax.swing.JLabel myLLabelQL = new javax.swing.JLabel();
			myLLabelQL.setName("myLLabelQL");
			myLLabelQL.setFont(new java.awt.Font("dialog.bold", 1, 12));
			myLLabelQL.setText("Quelle/Lieferant");
			myLLabelQL.setBounds(410, 205, 117, 17);
			myLLabelQL.setForeground(java.awt.Color.black);
			myLLabelQL.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);

// ======================================================================================
					
			myLPZABez = new NETextField("", null);
			myLPZABez.setName("myLPZABez");
			myLPZABez.setBounds(15, 195, 80, 21);
			myLPZABez.setEditable(false);

			myLrPZA = new NENumberTextField("", this, "changeLrPZA");
			myLrPZA.setName("myLrPZA");
			myLrPZA.setBounds(100, 195, 25, 21);
			myLrPZA.setIntegerFormat(false);

			myLPZASlider = new NEScrollBar(this, "changeLPZASlider");
			myLPZASlider.setName("myLPZASlider");	
			myLPZASlider.setBounds(135, 197, 215, 17);
			myLPZASlider.setOrientation(javax.swing.JScrollBar.HORIZONTAL);

// ======================================================================================

			myLWochen = new NERadioButton("Wochen", this, "changeLWMMode");
			myLWochen.setName("myLWochen");
			myLWochen.setBounds(380, 20, 80, 20);

			myLMonate = new NERadioButton("Monate", this, "changeLWMMode");
			myLMonate.setName("myLMonate");
			myLMonate.setBounds(380, 40, 80, 20);

			// Group the radio buttons.
			ButtonGroup group = new ButtonGroup();
			group.add((JRadioButton)myLWochen.getComponent());
			group.add((JRadioButton)myLMonate.getComponent());

			LWorM = true;
			myLMonate.setSelected(true);

			myLListOptAllLager = new NECheckBox("alle Lager", null, null);
			myLListOptAllLager.setName("myLListOptAllLager");
			myLListOptAllLager.setBounds(380, 80, 110, 20);

			myLListOptAllPara = new NECheckBox("alle Parameter", null, null);
			myLListOptAllPara.setName("myLListOptAllPara");
			myLListOptAllPara.setBounds(380, 120, 100, 20);

			myLListOptAllPZA = new NECheckBox("alle PZA", null, null);
			myLListOptAllPZA.setName("myLListOptAllPZA");
			myLListOptAllPZA.setBounds(380, 100, 100, 20);
			
			myLListButton = new NEButton("Liste", this, "generateLList");
			myLListButton.setName("myLListButton");
			myLListButton.setBounds(480, 140, 80, 25);
			
// ======================================================================================

			myLQAus = new NENumberTextField("", null);
			myLQAus.setName("myLQAus");
			myLQAus.setBounds(480, 305, 80, 21);
			myLQAus.setEditable(false);
			
			myLQms = new NENumberTextField("", null);
			myLQms.setName("myLQms");
			myLQms.setBounds(480, 329, 80, 21);
			myLQms.setEditable(false);

			myLQQA = new NENumberTextField("", this, "changeLQParameter");
			myLQQA.setName("myLQQA");
			myLQQA.setBounds(480, 353, 80, 21);

			myLQMM = new NENumberTextField("", this, "changeLQParameter");
			myLQMM.setName("myLQMM");
			myLQMM.setBounds(480, 377, 80, 21);

			myLQOUT = new NENumberTextField("", null);
			myLQOUT.setName("myLQOUT");
			myLQOUT.setBounds(480, 401, 80, 21);
			myLQOUT.setEditable(false);

// ======================================================================================
		
			myLeffMB = new NENumberTextField("", null);
			myLeffMB.setName("myLeffMB");
			myLeffMB.setBounds(100, 460, 80, 21);
			myLeffMB.setEditable(false);

			myLeffSB = new NENumberTextField("", null);
			myLeffSB.setName("myLeffSB");
			myLeffSB.setBounds(185, 460, 80, 21);
			myLeffSB.setEditable(false);

			myLeffHB = new NENumberTextField("", null);
			myLeffHB.setName("myLeffHB");
			myLeffHB.setBounds(270, 460, 80, 21);
			myLeffHB.setEditable(false);

			myLMRWB = new NENumberTextField("", null);
			myLMRWB.setName("myLMRWB");
			myLMRWB.setBounds(100, 484, 80, 21);
			myLMRWB.setEditable(false);
			
			myLRWB = new NENumberTextField("", null);
			myLRWB.setName("myLRWB");
			myLRWB.setBounds(185, 484, 80, 21);		
			myLRWB.setEditable(false);

			myLHRWB = new NENumberTextField("", null);
			myLHRWB.setName("myLHRWB");
			myLHRWB.setBounds(270, 484, 80, 21);
			myLHRWB.setEditable(false);
			
			myLMB = new NENumberTextField("", this, "changeLParameter");
			myLMB.setName("myLMB");
			myLMB.setBounds(100, 508, 80, 21);
			
			myLSB = new NENumberTextField("", this, "changeLParameter");
			myLSB.setName("myLSB");
			myLSB.setBounds(185, 508, 80, 21);
			
			myLHB = new NENumberTextField("", this, "changeLParameter");
			myLHB.setName("myLHB");
			myLHB.setBounds(270, 508, 80, 21);

			myLMRW = new NENumberTextField("", this, "changeLParameter");
			myLMRW.setName("myLMRW");
			myLMRW.setBounds(100, 532, 80, 21);
			
			myLRW = new NENumberTextField("", this, "changeLParameter");
			myLRW.setName("myLRW");
			myLRW.setBounds(185, 532, 80, 21);

			myLHRW = new NENumberTextField("", this, "changeLParameter");
			myLHRW.setName("myLHRW");
			myLHRW.setBounds(270, 532, 80, 21);

// ======================================================================================
			
			myLAB = new NENumberTextField("", this, "changeLParameter");
			myLAB.setName("myLAB");
			myLAB.setBounds(480, 436, 80, 21);

			myLINPUT = new NENumberTextField("", null);
			myLINPUT.setName("myLINPUT");
			myLINPUT.setBounds(480, 508, 80, 21);
			myLINPUT.setEditable(false);
			
			myLOUTPUT = new NENumberTextField("", null);
			myLOUTPUT.setName("myLOUTPUT");
			myLOUTPUT.setBounds(480, 532, 80, 21);
			myLOUTPUT.setEditable(false);

			myLIRW = new NENumberTextField("", null);
			myLIRW.setName("myLIRW");
			myLIRW.setBounds(480, 484, 80, 21);
			myLIRW.setEditable(false);	

			myLIB = new NENumberTextField("", null);
			myLIB.setName("myLIB");
			myLIB.setBounds(480, 460, 80, 21);
			myLIB.setEditable(false);

// ======================================================================================

			OELBrowser = new NETableBrowser(this, "browserClick", null);
			OELBrowser.setName("OELBrowser");
			OELBrowser.setBounds(15, 15, 350, 150);

			QBrowser = new NETableBrowser(this, "browserClick", null);
			QBrowser.setName("QBrowser");
			QBrowser.setBounds(380, 230, 180, 70);

			LMBrowser = new NETableBrowser(this, "browserClick", null);
			LMBrowser.setName("LMBrowser");
			LMBrowser.setBounds(15, 230, 350, 200);

// ======================================================================================

			javax.swing.JSeparator JSeparator1 = new javax.swing.JSeparator();
			JSeparator1.setName("JSeparator1");
			JSeparator1.setBounds(367, 428, 190, 2);

			NEPanel theDialogContentPane = new NEPanel();
			theDialogContentPane.setName("JDialogContentPane");
			theDialogContentPane.setLayout(null);
			theDialogContentPane.add(LIconLabel);
			theDialogContentPane.add((JComponent)myLLabelMin);
			theDialogContentPane.add(myLLabelEff);
			theDialogContentPane.add(myLLabelRW);
			theDialogContentPane.add(myLLabelAbs);
			theDialogContentPane.add(myLLabelRW1);
			theDialogContentPane.add(myLLabelAusl);
			theDialogContentPane.add(myLLabelMs);
			theDialogContentPane.add(myLLabelQA);
			theDialogContentPane.add(myLLabelMM);
			theDialogContentPane.add(myLLabelOut);
			theDialogContentPane.add(myLLabelIRW);
			theDialogContentPane.add(myLLabelIB);
			theDialogContentPane.add(myLLabelOut2);
			theDialogContentPane.add(myLLabelIn);
			theDialogContentPane.add(myLLabelAB);
			theDialogContentPane.add(myLLabelSoll);
			theDialogContentPane.add(myLLabelH);
			theDialogContentPane.add(myLLabelPZA);
			theDialogContentPane.add(myLLabelQL);
			theDialogContentPane.add(JSeparator1);
			theDialogContentPane.add(myLWochen);
			theDialogContentPane.add(myLMonate);
			theDialogContentPane.add(myLListOptAllLager);
			theDialogContentPane.add(myLListOptAllPara);
			theDialogContentPane.add(myLListOptAllPZA);
			theDialogContentPane.add(myLListButton);			
			theDialogContentPane.add(myLPZABez);
			theDialogContentPane.add(myLrPZA);
			theDialogContentPane.add(myLPZASlider);
			theDialogContentPane.add(myLQAus);
			theDialogContentPane.add(myLQms);
			theDialogContentPane.add(myLQQA);
			theDialogContentPane.add(myLQMM);
			theDialogContentPane.add(myLQOUT);
			theDialogContentPane.add(myLeffMB);
			theDialogContentPane.add(myLeffSB);
			theDialogContentPane.add(myLeffHB);
			theDialogContentPane.add(myLMRWB);
			theDialogContentPane.add(myLRWB);
			theDialogContentPane.add(myLHRWB);
			theDialogContentPane.add(myLMB);
			theDialogContentPane.add(myLSB);
			theDialogContentPane.add(myLHB);
			theDialogContentPane.add(myLMRW);
			theDialogContentPane.add(myLRW);
			theDialogContentPane.add(myLHRW);
			theDialogContentPane.add(myLAB);
			theDialogContentPane.add(myLINPUT);
			theDialogContentPane.add(myLOUTPUT);
			theDialogContentPane.add(myLIRW);
			theDialogContentPane.add(myLIB);
			theDialogContentPane.add(OELBrowser);
			theDialogContentPane.add(QBrowser);
			theDialogContentPane.add(LMBrowser);

			myOELPanel = new javax.swing.JFrame();
			myOELPanel.setName("myOELPanel");
			myOELPanel.setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
			myOELPanel.setResizable(false);
			myOELPanel.setBounds(25, 50, 570+wp, 565+hp);
			myOELPanel.setTitle("Lager");
			myOELPanel.setContentPane(theDialogContentPane.getComponent());
	
	return;	
}
/**
 * Insert the method's description here.
 * Creation date: (02.11.00 11:31:14)
 */
private void createOEPPanel() {

			javax.swing.JLabel PIconLabel = new javax.swing.JLabel();
			PIconLabel.setName("PIconLabel");
			PIconLabel.setIcon(new javax.swing.ImageIcon(getClass().getResource("/dia.gif")));
			PIconLabel.setText("");
			PIconLabel.setBounds(560, 20, 25, 35);

			javax.swing.JLabel myPAnliefLabel = new javax.swing.JLabel();
			myPAnliefLabel.setName("myPAnliefLabel");
			myPAnliefLabel.setFont(new java.awt.Font("dialog.bold", 1, 12));
			myPAnliefLabel.setText("Anlieferung");
			myPAnliefLabel.setBounds(362, 301, 178, 17);
			myPAnliefLabel.setForeground(java.awt.Color.black);
			myPAnliefLabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);

			javax.swing.JLabel myPAnzLabel = new javax.swing.JLabel();
			myPAnzLabel.setName("myPAnzLabel");
			myPAnzLabel.setFont(new java.awt.Font("dialog.bold", 1, 12));
			myPAnzLabel.setText("Anzahl");
			myPAnzLabel.setBounds(94, 202, 53, 17);
			myPAnzLabel.setForeground(java.awt.Color.black);
			myPAnzLabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);

			javax.swing.JLabel myPAusliefLabel = new javax.swing.JLabel();
			myPAusliefLabel.setName("myPAusliefLabel");
			myPAusliefLabel.setFont(new java.awt.Font("dialog.bold", 1, 12));
			myPAusliefLabel.setText("Auslieferung");
			myPAusliefLabel.setBounds(61, 301, 178, 17);
			myPAusliefLabel.setForeground(java.awt.Color.black);
			myPAusliefLabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);

			javax.swing.JLabel myPAuslLabel = new javax.swing.JLabel();
			myPAuslLabel.setName("myPAuslLabel");
			myPAuslLabel.setFont(new java.awt.Font("dialog.bold", 1, 12));
			myPAuslLabel.setText("Auslastung");
			myPAuslLabel.setBounds(383, 202, 80, 17);
			myPAuslLabel.setForeground(java.awt.Color.black);
			myPAuslLabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);

			javax.swing.JLabel myPFrauenLabel = new javax.swing.JLabel();
			myPFrauenLabel.setName("myPFrauenLabel");
			myPFrauenLabel.setFont(new java.awt.Font("dialog", 0, 12));
			myPFrauenLabel.setText("Frauen:");
			myPFrauenLabel.setBounds(15, 273, 80, 17);
			myPFrauenLabel.setForeground(java.awt.Color.black);
			myPFrauenLabel.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);

			javax.swing.JLabel myPMaennerLabel = new javax.swing.JLabel();
			myPMaennerLabel.setName("myPMaennerLabel");
			myPMaennerLabel.setFont(new java.awt.Font("dialog", 0, 12));
			myPMaennerLabel.setText("Mnner:");
			myPMaennerLabel.setBounds(15, 250, 80, 17);
			myPMaennerLabel.setForeground(java.awt.Color.black);
			myPMaennerLabel.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);

			javax.swing.JLabel myPMaschLabel = new javax.swing.JLabel();
			myPMaschLabel.setName("myPMaschLabel");
			myPMaschLabel.setFont(new java.awt.Font("dialog", 0, 12));
			myPMaschLabel.setText("Maschinen:");
			myPMaschLabel.setBounds(15, 226, 80, 17);
			myPMaschLabel.setForeground(java.awt.Color.black);
			myPMaschLabel.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);

			javax.swing.JLabel myPProzentLabel = new javax.swing.JLabel();
			myPProzentLabel.setName("myPProzentLabel");
			myPProzentLabel.setFont(new java.awt.Font("dialog.bold", 1, 12));
			myPProzentLabel.setText("%");
			myPProzentLabel.setBounds(457, 226, 15, 17);
			myPProzentLabel.setForeground(java.awt.Color.black);
			myPProzentLabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);

			javax.swing.JLabel myPProzentLabel1 = new javax.swing.JLabel();
			myPProzentLabel1.setName("myPProzentLabel1");
			myPProzentLabel1.setFont(new java.awt.Font("dialog.bold", 1, 12));
			myPProzentLabel1.setText("%");
			myPProzentLabel1.setBounds(457, 250, 15, 17);
			myPProzentLabel1.setForeground(java.awt.Color.black);
			myPProzentLabel1.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);

			javax.swing.JLabel myPProzentLabel11 = new javax.swing.JLabel();
			myPProzentLabel11.setName("myPProzentLabel11");
			myPProzentLabel11.setFont(new java.awt.Font("dialog.bold", 1, 12));
			myPProzentLabel11.setText("%");
			myPProzentLabel11.setBounds(199, 250, 15, 17);
			myPProzentLabel11.setForeground(java.awt.Color.black);
			myPProzentLabel11.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);

			javax.swing.JLabel myPProzentLabel2 = new javax.swing.JLabel();
			myPProzentLabel2.setName("myPProzentLabel2");
			myPProzentLabel2.setFont(new java.awt.Font("dialog.bold", 1, 12));
			myPProzentLabel2.setText("%");
			myPProzentLabel2.setBounds(457, 275, 15, 17);
			myPProzentLabel2.setForeground(java.awt.Color.black);
			myPProzentLabel2.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);

			javax.swing.JLabel myPProzentLabel21 = new javax.swing.JLabel();
			myPProzentLabel21.setName("myPProzentLabel21");
			myPProzentLabel21.setFont(new java.awt.Font("dialog.bold", 1, 12));
			myPProzentLabel21.setText("%");
			myPProzentLabel21.setBounds(199, 275, 15, 17);
			myPProzentLabel21.setForeground(java.awt.Color.black);
			myPProzentLabel21.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);

			javax.swing.JLabel myPProzentLabel3 = new javax.swing.JLabel();
			myPProzentLabel3.setName("myPProzentLabel3");
			myPProzentLabel3.setFont(new java.awt.Font("dialog.bold", 1, 12));
			myPProzentLabel3.setText("%");
			myPProzentLabel3.setBounds(199, 226, 15, 17);
			myPProzentLabel3.setForeground(java.awt.Color.black);
			myPProzentLabel3.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);

			javax.swing.JLabel myPPZALabel = new javax.swing.JLabel();
			myPPZALabel.setName("myPPZALabel");
			myPPZALabel.setFont(new java.awt.Font("dialog.bold", 1, 12));
			myPPZALabel.setText("Planungszeitabschnitt");
			myPPZALabel.setBounds(84, 146, 178, 17);
			myPPZALabel.setForeground(java.awt.Color.black);
			myPPZALabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);

			javax.swing.JLabel myPQMMLabel = new javax.swing.JLabel();
			myPQMMLabel.setName("myPQMMLabel");
			myPQMMLabel.setFont(new java.awt.Font("dialog", 0, 12));
			myPQMMLabel.setText("Mindestmenge:");
			myPQMMLabel.setBounds(92, 457, 100, 17);
			myPQMMLabel.setForeground(java.awt.Color.black);
			myPQMMLabel.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);

			javax.swing.JLabel myPmsALabel = new javax.swing.JLabel();
			myPmsALabel.setName("myPmsALabel");
			myPmsALabel.setFont(new java.awt.Font("dialog", 0, 12));
			myPmsALabel.setText("mat.-spez. Ausl.:");
			myPmsALabel.setBounds(97, 505, 95, 17);
			myPmsALabel.setForeground(java.awt.Color.black);
			myPmsALabel.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);

			javax.swing.JLabel myPQOUTLabel = new javax.swing.JLabel();
			myPQOUTLabel.setName("myPQOUTLabel");
			myPQOUTLabel.setFont(new java.awt.Font("dialog", 0, 12));
			myPQOUTLabel.setText("Output:");
			myPQOUTLabel.setBounds(112, 529, 80, 17);
			myPQOUTLabel.setForeground(java.awt.Color.black);
			myPQOUTLabel.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);

			javax.swing.JLabel myPQQALabel = new javax.swing.JLabel();
			myPQQALabel.setName("myPQQALabel");
			myPQQALabel.setFont(new java.awt.Font("dialog", 0, 12));
			myPQQALabel.setText("Quellenanteil:");
			myPQQALabel.setBounds(112, 481, 80, 17);
			myPQQALabel.setForeground(java.awt.Color.black);
			myPQQALabel.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);

			javax.swing.JLabel myPSABLabel = new javax.swing.JLabel();
			myPSABLabel.setName("myPSABLabel");
			myPSABLabel.setFont(new java.awt.Font("dialog", 0, 12));
			myPSABLabel.setText("AB:");
			myPSABLabel.setBounds(465, 481, 40, 17);
			myPSABLabel.setForeground(java.awt.Color.black);
			myPSABLabel.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);

			javax.swing.JLabel myPSchichtLabel = new javax.swing.JLabel();
			myPSchichtLabel.setName("myPSchichtLabel");
			myPSchichtLabel.setFont(new java.awt.Font("dialog", 0, 12));
			myPSchichtLabel.setText("Schichtigkeit:");
			myPSchichtLabel.setBounds(465, 250, 80, 17);
			myPSchichtLabel.setForeground(java.awt.Color.black);
			myPSchichtLabel.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);

			javax.swing.JLabel myPSHBLabel = new javax.swing.JLabel();
			myPSHBLabel.setName("myPSHBLabel");
			myPSHBLabel.setFont(new java.awt.Font("dialog", 0, 12));
			myPSHBLabel.setText("HB:");
			myPSHBLabel.setBounds(310, 457, 40, 17);
			myPSHBLabel.setForeground(java.awt.Color.black);
			myPSHBLabel.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
			
			javax.swing.JLabel myPSINLabel = new javax.swing.JLabel();
			myPSINLabel.setName("myPSINLabel");
			myPSINLabel.setFont(new java.awt.Font("dialog", 0, 12));
			myPSINLabel.setText("IN:");
			myPSINLabel.setBounds(465, 505, 40, 17);
			myPSINLabel.setForeground(java.awt.Color.black);
			myPSINLabel.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);

			javax.swing.JLabel myPSISTLabel = new javax.swing.JLabel();
			myPSISTLabel.setName("myPSISTLabel");
			myPSISTLabel.setFont(new java.awt.Font("dialog", 0, 12));
			myPSISTLabel.setText("IST:");
			myPSISTLabel.setBounds(465, 457, 40, 17);
			myPSISTLabel.setForeground(java.awt.Color.black);
			myPSISTLabel.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);

			javax.swing.JLabel myPSMBLabel = new javax.swing.JLabel();
			myPSMBLabel.setName("myPSMBLabel");
			myPSMBLabel.setFont(new java.awt.Font("dialog", 0, 12));
			myPSMBLabel.setText("MB:");
			myPSMBLabel.setBounds(310, 481, 40, 17);
			myPSMBLabel.setForeground(java.awt.Color.black);
			myPSMBLabel.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);

			javax.swing.JLabel myPSmsVLabel = new javax.swing.JLabel();
			myPSmsVLabel.setName("myPSmsVLabel");
			myPSmsVLabel.setFont(new java.awt.Font("dialog", 0, 12));
			myPSmsVLabel.setText("mat.-sp. Verbr.:");
			myPSmsVLabel.setBounds(404, 562, 100, 17);
			myPSmsVLabel.setForeground(java.awt.Color.black);
			myPSmsVLabel.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);

			javax.swing.JLabel myPSOUTLabel = new javax.swing.JLabel();
			myPSOUTLabel.setName("myPSOUTLabel");
			myPSOUTLabel.setFont(new java.awt.Font("dialog", 0, 12));
			myPSOUTLabel.setText("Verbr.:");
			myPSOUTLabel.setBounds(465, 529, 40, 17);
			myPSOUTLabel.setForeground(java.awt.Color.black);
			myPSOUTLabel.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);

			javax.swing.JLabel myPSRWBLabel = new javax.swing.JLabel();
			myPSRWBLabel.setName("myPSRWBLabel");
			myPSRWBLabel.setFont(new java.awt.Font("dialog", 0, 12));
			myPSRWBLabel.setText("RWB:");
			myPSRWBLabel.setBounds(310, 529, 40, 17);
			myPSRWBLabel.setForeground(java.awt.Color.black);
			myPSRWBLabel.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);

			javax.swing.JLabel myPSRWLabel = new javax.swing.JLabel();
			myPSRWLabel.setName("myPSRWLabel");
			myPSRWLabel.setFont(new java.awt.Font("dialog", 0, 12));
			myPSRWLabel.setText("RW:");
			myPSRWLabel.setBounds(309, 562, 40, 17);
			myPSRWLabel.setForeground(java.awt.Color.black);
			myPSRWLabel.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);

			javax.swing.JLabel myPSSBLabel = new javax.swing.JLabel();
			myPSSBLabel.setName("myPSSBLabel");
			myPSSBLabel.setFont(new java.awt.Font("dialog", 0, 12));
			myPSSBLabel.setText("SB:");
			myPSSBLabel.setBounds(310, 505, 40, 17);
			myPSSBLabel.setForeground(java.awt.Color.black);
			myPSSBLabel.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);

			javax.swing.JLabel myPVbktLabel = new javax.swing.JLabel();
			myPVbktLabel.setName("myPVbktLabel");
			myPVbktLabel.setFont(new java.awt.Font("dialog.bold", 1, 12));
			myPVbktLabel.setText("Verfgbarkeit (%)");
			myPVbktLabel.setBounds(162, 202, 117, 17);
			myPVbktLabel.setForeground(java.awt.Color.black);
			myPVbktLabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);

			javax.swing.JLabel myPZAhLabel = new javax.swing.JLabel();
			myPZAhLabel.setName("myPZAhLabel");
			myPZAhLabel.setFont(new java.awt.Font("dialog", 0, 12));
			myPZAhLabel.setText("ZAh:");
			myPZAhLabel.setBounds(465, 276, 80, 17);
			myPZAhLabel.setForeground(java.awt.Color.black);
			myPZAhLabel.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);

			javax.swing.JLabel myPLabelQOEL = new javax.swing.JLabel();
			myPLabelQOEL.setName("myPLabelQOEL");
			myPLabelQOEL.setFont(new java.awt.Font("dialog.bold", 0, 12));
			myPLabelQOEL.setText("zu OEL:");
			myPLabelQOEL.setBounds(15, 593, 60, 17);
			myPLabelQOEL.setForeground(java.awt.Color.black);
			myPLabelQOEL.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);

			javax.swing.JLabel myPLabelSOEL = new javax.swing.JLabel();
			myPLabelSOEL.setName("myPLabelSOEL");
			myPLabelSOEL.setFont(new java.awt.Font("dialog.bold", 0, 12));
			myPLabelSOEL.setText("von OEL:");
			myPLabelSOEL.setBounds(315, 593, 60, 17);
			myPLabelSOEL.setForeground(java.awt.Color.black);
			myPLabelSOEL.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);

// ======================================================================================
					
			myPPZABez = new NETextField("", null);
			myPPZABez.setName("myPPZABez");
			myPPZABez.setBounds(15, 168, 80, 21);
			myPPZABez.setEditable(false);

			myPrPZA = new NENumberTextField("", this, "changePrPZA");
			myPrPZA.setName("myPrPZA");
			myPrPZA.setBounds(100, 168, 25, 21);
			myPrPZA.setIntegerFormat(false);

			myPPZASlider = new NEScrollBar(this, "changePPZASlider");
			myPPZASlider.setName("myPPZASlider");	
			myPPZASlider.setBounds(135, 170, 215, 17);
			myPPZASlider.setOrientation(javax.swing.JScrollBar.HORIZONTAL);

// ======================================================================================

			myPWochen = new NERadioButton("Wochen", this, "changePWMMode");
			myPWochen.setName("myPWochen");
			myPWochen.setBounds(380, 20, 70, 20);

			myPMonate = new NERadioButton("Monate", this, "changePWMMode");
			myPMonate.setName("myPMonate");
			myPMonate.setBounds(380, 40, 70, 20);

			// Group the radio buttons.
			ButtonGroup group = new ButtonGroup();
			group.add((JRadioButton)myPWochen.getComponent());
			group.add((JRadioButton)myPMonate.getComponent());

			PWorM = true;
			myPMonate.setSelected(true);

			myPListOptAllOEP = new NECheckBox("alle OEP", null, null);
			myPListOptAllOEP.setName("myPListOptAllOEP");
			myPListOptAllOEP.setBounds(455, 20, 80, 20);

			myPListOptAllPZA = new NECheckBox("alle PZA", null, null);
			myPListOptAllPZA.setName("myPListOptAllPZA");
			myPListOptAllPZA.setBounds(455, 40, 80, 20);

			myPListOptNull = new NECheckBox("nur > 0", null, null);
			myPListOptNull.setName("myPListOptNull");
			myPListOptNull.setBounds(455, 60, 80, 20);

			myPAPButton = new NEButton("Arbeitsplan", this, "generateAPList");
			myPAPButton.setName("myPAPButton");
			myPAPButton.setBounds(455, 155, 100, 27);

			myPListButton = new NEButton("Prod.-Plan", this, "generatePList");
			myPListButton.setName("myPListButton");
			myPListButton.setBounds(455, 90, 100, 25);

			myPSLButton = new NEButton("Stckliste", this, "generateSLList");
			myPSLButton.setName("myPSLButton");
			myPSLButton.setBounds(455, 125, 100, 27);
			
// ======================================================================================

			myPSchichtPM = new NEScrollBar(this, "changeSchicht");
			myPSchichtPM.setName("myPSchichtPM");
			myPSchichtPM.setBounds(550, 225, 40, 17);
			myPSchichtPM.setMinMaxValue(1, 3);
			myPSchichtPM.setOrientation(javax.swing.JScrollBar.HORIZONTAL);
			
			myZAh = new NENumberTextField("", this, "changeZAh");
			myZAh.setName("myZAh");
			myZAh.setBounds(550, 272, 40, 21);
		//	myZAh.setIntegerFormat(false);
			
			mySchicht = new NENumberTextField("", this, "changeSchicht");
			mySchicht.setName("mySchicht");
			mySchicht.setBounds(550, 248, 40, 21);
			mySchicht.setIntegerFormat(false);

// ======================================================================================
		
			myFraAusl = new NENumberTextField("", null);
			myFraAusl.setName("myFraAusl");
			myFraAusl.setBounds(395, 272, 60, 21);
			myFraAusl.setEditable(false);
			
			myFraAnz = new NENumberTextField("", this, "changeAnzRess");
			myFraAnz.setName("myFraAnz");
			myFraAnz.setBounds(100, 272, 40, 21);
			myFraAnz.setIntegerFormat(false);
			
			myFraVbkt = new NENumberTextField("", this, "changeVFra");
			myFraVbkt.setName("myFraVbkt");
			myFraVbkt.setBounds(152, 272, 45, 21);
			
			myFraVSlider = new NEScrollBar(this, "changeVSlider");
			myFraVSlider.setName("myFraVSlider");
		//	myFraVSlider.setMaxValue(100);
			myFraVSlider.setMinMaxValue(0, 100);
			myFraVSlider.setBounds(220, 274, 165, 17);
			myFraVSlider.setOrientation(javax.swing.JScrollBar.HORIZONTAL);
			
			myMaeAnz = new NENumberTextField("", this, "changeAnzRess");
			myMaeAnz.setName("myMaeAnz");
			myMaeAnz.setBounds(100, 248, 40, 21);
			myMaeAnz.setIntegerFormat(false);
			
			myMaeAusl = new NENumberTextField("", null);
			myMaeAusl.setName("myMaeAusl");
			myMaeAusl.setBounds(395, 248, 60, 21);
			myMaeAusl.setEditable(false);
			
			myMaeVbkt = new NENumberTextField("", this, "changeVMae");
			myMaeVbkt.setName("myMaeVbkt");
			myMaeVbkt.setBounds(152, 248, 45, 21);
			
			myMaeVSlider = new NEScrollBar(this, "changeVSlider");
			myMaeVSlider.setName("myMaeVSlider");
		//	myMaeVSlider.setMaxValue(100);
			myMaeVSlider.setMinMaxValue(0, 100);
			myMaeVSlider.setBounds(220, 250, 165, 17);
			myMaeVSlider.setOrientation(javax.swing.JScrollBar.HORIZONTAL);
			
			myMaschAnz = new NENumberTextField("", this, "changeAnzRess");
			myMaschAnz.setName("myMaschAnz");
			myMaschAnz.setBounds(100, 224, 40, 21);
			myMaschAnz.setIntegerFormat(false);
			
			myMaschAusl = new NENumberTextField("", null);
			myMaschAusl.setName("myMaschAusl");
			myMaschAusl.setBounds(395, 224, 60, 21);
			myMaschAusl.setEditable(false);
			
			myMaschVbkt = new NENumberTextField("", this, "changeVMasch");
			myMaschVbkt.setName("myMaschVbkt");
			myMaschVbkt.setBounds(152, 224, 45, 21);
			
			myMaschVSlider = new NEScrollBar(this, "changeVSlider");
			myMaschVSlider.setName("myMaschVSlider");
			myMaschVSlider.setMinMaxValue(0, 100);
			myMaschVSlider.setBounds(220, 226, 165, 17);
			myMaschVSlider.setOrientation(javax.swing.JScrollBar.HORIZONTAL);

// ======================================================================================
			
			myQMM = new NENumberTextField("", this, "changeQMM");
			myQMM.setName("myQMM");
			myQMM.setBounds(197, 455, 80, 21);
			
			myQQA = new NENumberTextField("", this, "changeQQA");
			myQQA.setName("myQQA");
			myQQA.setBounds(197, 479, 80, 21);
			
			myQMsA = new NENumberTextField("", null);
			myQMsA.setName("myQMsA");
			myQMsA.setBounds(197, 503, 80, 21);
			myQMsA.setEditable(false);
			
			myQOUTPUT = new NENumberTextField("", null);
			myQOUTPUT.setName("myQOUTPUT");
			myQOUTPUT.setBounds(197, 527, 80, 21);
			myQOUTPUT.setEditable(false);

// ======================================================================================

			mySAB = new NENumberTextField("", this, "changeSAB");
			mySAB.setName("mySAB");
			mySAB.setBounds(510, 479, 80, 21);

			mySHB = new NENumberTextField("", this, "changeSHB");
			mySHB.setName("mySHB");
			mySHB.setBounds(355, 455, 80, 21);
			
			mySINPUT = new NENumberTextField("", null);
			mySINPUT.setName("mySINPUT");
			mySINPUT.setBounds(510, 503, 80, 21);
			mySINPUT.setEditable(false);
			
			mySIST = new NENumberTextField("", null);
			mySIST.setName("mySIST");
			mySIST.setBounds(510, 455, 80, 21);
			mySIST.setEditable(false);
			
			mySMB = new NENumberTextField("", this, "changeSMB");
			mySMB.setName("mySMB");
			mySMB.setBounds(355, 479, 80, 21);
			
			mySmsV = new NENumberTextField("", null);
			mySmsV.setName("mySmsV");
			mySmsV.setBounds(509, 560, 80, 21);
			mySmsV.setEditable(false);
			
			mySOUTPUT = new NENumberTextField("", null);
			mySOUTPUT.setName("mySOUTPUT");
			mySOUTPUT.setBounds(510, 527, 80, 21);
			mySOUTPUT.setEditable(false);
			
			mySRW = new NENumberTextField("", this, "changeSRW");
			mySRW.setName("mySRW");
			mySRW.setBounds(354, 560, 40, 21);
			
			mySRWB = new NENumberTextField("", null);
			mySRWB.setName("mySRWB");
			mySRWB.setBounds(355, 527, 80, 21);
			mySRWB.setEditable(false);
			
			mySSB = new NENumberTextField("", this, "changeSSB");
			mySSB.setName("mySSB");
			mySSB.setBounds(355, 503, 80, 21);

// ======================================================================================

			OEPBrowser = new NETableBrowser(this, "browserClick", null);
			OEPBrowser.setName("OEPBrowser");
			OEPBrowser.setBounds(15, 15, 350, 125);
			
			OMBrowser = new NETableBrowser(this, "browserClick", null);
			OMBrowser.setName("OMBrowser");
			OMBrowser.setBounds(15, 320, 280, 125);

			UMBrowser = new NETableBrowser(this, "browserClick", null);
			UMBrowser.setName("UMBrowser");
			UMBrowser.setBounds(310, 320, 280, 125);

// ======================================================================================

			myPQOELBez = new javax.swing.JLabel();
			myPQOELBez.setName("myPQOELBez");
			myPQOELBez.setFont(new java.awt.Font("dialog.bold", 0, 12));
			myPQOELBez.setText("");
			myPQOELBez.setBounds(85, 593, 180, 17);
			myPQOELBez.setForeground(java.awt.Color.black);
			myPQOELBez.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);

			myPSOELBez = new javax.swing.JLabel();
			myPSOELBez.setName("myPSOELBez");
			myPSOELBez.setFont(new java.awt.Font("dialog.bold", 0, 12));
			myPSOELBez.setText("");
			myPSOELBez.setBounds(385, 593, 180, 17);
			myPSOELBez.setForeground(java.awt.Color.black);
			myPSOELBez.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);

			JSeparator JSeparator11 = new javax.swing.JSeparator();
			JSeparator11.setName("JSeparator11");
			JSeparator11.setBounds(15, 194, 575, 2);

			JSeparator JSeparator111 = new javax.swing.JSeparator();
			JSeparator111.setName("JSeparator111");
			JSeparator111.setBounds(15, 299, 575, 2);

			JSeparator JSeparator4 = new javax.swing.JSeparator();
			JSeparator4.setName("JSeparator4");
			JSeparator4.setBounds(15, 585, 575, 2);

			JSeparator JSeparator1 = new javax.swing.JSeparator();
			JSeparator1.setName("JSeparator1");
			JSeparator1.setBounds(302, 300, 2, 310);
			JSeparator1.setOrientation(javax.swing.SwingConstants.VERTICAL);


			NEPanel theDialogContentPane = new NEPanel();
			theDialogContentPane.setName("JDialogContentPane");
			theDialogContentPane.setLayout(null);
			theDialogContentPane.add(PIconLabel);
			theDialogContentPane.add(myPVbktLabel);
			theDialogContentPane.add(myPmsALabel);
			theDialogContentPane.add(myPAuslLabel);
			theDialogContentPane.add(myPAnzLabel);
			theDialogContentPane.add(myPQQALabel);
			theDialogContentPane.add(myPQMMLabel);
			theDialogContentPane.add(myPQOUTLabel);
			theDialogContentPane.add(myPPZALabel);
			theDialogContentPane.add(myPSOUTLabel);
			theDialogContentPane.add(myPSINLabel);
			theDialogContentPane.add(myPSABLabel);
			theDialogContentPane.add(myPSISTLabel);
			theDialogContentPane.add(myPFrauenLabel);
			theDialogContentPane.add(myPMaennerLabel);
			theDialogContentPane.add(myPMaschLabel);
			theDialogContentPane.add(myPZAhLabel);
			theDialogContentPane.add(myPSchichtLabel);
			theDialogContentPane.add(myPProzentLabel);
			theDialogContentPane.add(myPSHBLabel);
			theDialogContentPane.add(myPSMBLabel);
			theDialogContentPane.add(myPSRWLabel);
			theDialogContentPane.add(myPSmsVLabel);
			theDialogContentPane.add(myPSRWBLabel);
			theDialogContentPane.add(myPSSBLabel);
			theDialogContentPane.add(myPProzentLabel1);
			theDialogContentPane.add(myPProzentLabel2);
			theDialogContentPane.add(myPProzentLabel21);
			theDialogContentPane.add(myPProzentLabel11);
			theDialogContentPane.add(myPProzentLabel3);
			theDialogContentPane.add(myPAusliefLabel);
			theDialogContentPane.add(myPAnliefLabel);
			
			theDialogContentPane.add(JSeparator11);
			theDialogContentPane.add(JSeparator111);
			theDialogContentPane.add(JSeparator1);
			theDialogContentPane.add(JSeparator4);
			theDialogContentPane.add(myPLabelQOEL);
			theDialogContentPane.add(myPLabelSOEL);
			theDialogContentPane.add(myPQOELBez);
			theDialogContentPane.add(myPSOELBez);
			
			theDialogContentPane.add(myPPZABez);
			theDialogContentPane.add(myPPZASlider);
			theDialogContentPane.add(myPrPZA);
			theDialogContentPane.add(myQMsA);
			theDialogContentPane.add(OEPBrowser);
			theDialogContentPane.add(OMBrowser);
			theDialogContentPane.add(myPWochen);
			theDialogContentPane.add(myPMonate);
			theDialogContentPane.add(myPListOptAllOEP);
			theDialogContentPane.add(myPListOptAllPZA);
			theDialogContentPane.add(myPListOptNull);
			theDialogContentPane.add(myQQA);
			theDialogContentPane.add(myQMM);
			theDialogContentPane.add(myQOUTPUT);
			theDialogContentPane.add(myPListButton);
			theDialogContentPane.add(mySIST);
			theDialogContentPane.add(mySAB);
			theDialogContentPane.add(mySINPUT);
			theDialogContentPane.add(mySOUTPUT);
			theDialogContentPane.add(UMBrowser);
			theDialogContentPane.add(myMaschAnz);
			theDialogContentPane.add(myMaeAnz);
			theDialogContentPane.add(myFraAnz);
			theDialogContentPane.add(myMaschVbkt);
			theDialogContentPane.add(myMaeVbkt);
			theDialogContentPane.add(myFraVbkt);
			theDialogContentPane.add(myMaschAusl);
			theDialogContentPane.add(myMaeAusl);
			theDialogContentPane.add(myFraAusl);
			theDialogContentPane.add(myMaschVSlider);
			theDialogContentPane.add(myMaeVSlider);
			theDialogContentPane.add(myFraVSlider);
			theDialogContentPane.add(mySchicht);
			theDialogContentPane.add(myZAh);
			theDialogContentPane.add(mySHB);
			theDialogContentPane.add(mySMB);
			theDialogContentPane.add(mySSB);
			theDialogContentPane.add(mySRWB);
			theDialogContentPane.add(mySRW);
			theDialogContentPane.add(mySmsV);
			theDialogContentPane.add(myPSLButton);
			theDialogContentPane.add(myPAPButton);
			theDialogContentPane.add(myPSchichtPM);

			myOEPPanel = new javax.swing.JFrame();
			myOEPPanel.setName("myOEPPanel");
			myOEPPanel.setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
			myOEPPanel.setResizable(false);
			myOEPPanel.setBounds(200, 250, 605+wp, 625+hp);
			myOEPPanel.setTitle("Produktion");
			myOEPPanel.setContentPane(theDialogContentPane.getComponent());
	
	return;	
}
/**
 * Insert the method's description here.
 * Creation date: (02.11.00 11:31:14)
 */
private void createOEVPanel() {

			javax.swing.JLabel LIconLabel = new javax.swing.JLabel();
			LIconLabel.setName("LIconLabel");
			LIconLabel.setIcon(new javax.swing.ImageIcon(getClass().getResource("/dia.gif")));
			LIconLabel.setText("");
			LIconLabel.setBounds(420, 20, 25, 35);

			javax.swing.JLabel myVLabelAR = new javax.swing.JLabel();
			myVLabelAR.setName("myVLabelAR");
			myVLabelAR.setToolTipText("Test");
			myVLabelAR.setText("Anfangsrckstand:");
			myVLabelAR.setForeground(java.awt.Color.black);
			myVLabelAR.setFont(new java.awt.Font("dialog", 0, 12));
			myVLabelAR.setBounds(240, 289, 120, 17);
			myVLabelAR.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);

			javax.swing.JLabel myVLabelBedarf = new javax.swing.JLabel();
			myVLabelBedarf.setName("myVLabelBedarf");
			myVLabelBedarf.setFont(new java.awt.Font("dialog", 0, 12));
			myVLabelBedarf.setText("Bedarf:");
			myVLabelBedarf.setBounds(280, 241, 80, 17);
			myVLabelBedarf.setForeground(java.awt.Color.black);
			myVLabelBedarf.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);

			javax.swing.JLabel myVLabelList = new javax.swing.JLabel();
			myVLabelList.setName("myVLabelList");
			myVLabelList.setFont(new java.awt.Font("dialog.bold", 1, 12));
			myVLabelList.setText("Listenoption");
			myVLabelList.setBounds(65, 225, 117, 17);
			myVLabelList.setForeground(java.awt.Color.black);
			myVLabelList.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);

			javax.swing.JLabel myVLabelOEL = new javax.swing.JLabel();
			myVLabelOEL.setName("myVLabelOEL");
			myVLabelOEL.setFont(new java.awt.Font("dialog.bold", 0, 12));
			myVLabelOEL.setText("von OEL:");
			myVLabelOEL.setBounds(15, 325, 80, 17);
			myVLabelOEL.setForeground(java.awt.Color.black);
			myVLabelOEL.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);

			javax.swing.JLabel myVLabelPZA = new javax.swing.JLabel();
			myVLabelPZA.setName("myVLabelPZA");
			myVLabelPZA.setFont(new java.awt.Font("dialog.bold", 1, 12));
			myVLabelPZA.setText("Planungszeitabschnitt");
			myVLabelPZA.setBounds(85, 170, 178, 17);
			myVLabelPZA.setForeground(java.awt.Color.black);
			myVLabelPZA.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);

			javax.swing.JLabel myVLabelZB = new javax.swing.JLabel();
			myVLabelZB.setName("myVLabelZB");
			myVLabelZB.setFont(new java.awt.Font("dialog", 0, 12));
			myVLabelZB.setText("Zusatzbedarf:");
			myVLabelZB.setBounds(280, 265, 80, 17);
			myVLabelZB.setForeground(java.awt.Color.black);
			myVLabelZB.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);

// ======================================================================================
					
			myVPZABez = new NETextField("", null);
			myVPZABez.setName("myVPZABez");
			myVPZABez.setBounds(15, 190, 80, 21);
			myVPZABez.setEditable(false);

			myVrPZA = new NENumberTextField("", this, "changeVrPZA");
			myVrPZA.setName("myVrPZA");
			myVrPZA.setBounds(100, 190, 25, 21);
			myVrPZA.setIntegerFormat(false);

			myVPZASlider = new NEScrollBar(this, "changeVPZASlider");
			myVPZASlider.setName("myVPZASlider");	
			myVPZASlider.setBounds(135, 192, 215, 17);
			myVPZASlider.setOrientation(javax.swing.JScrollBar.HORIZONTAL);

// ======================================================================================

			myVWochen = new NERadioButton("Wochen", this, "changeVWMMode");
			myVWochen.setName("myVWochen");
			myVWochen.setBounds(380, 105, 80, 20);

			myVMonate = new NERadioButton("Monate", this, "changeVWMMode");
			myVMonate.setName("myVMonate");
			myVMonate.setBounds(380, 125, 80, 20);

			// Group the radio buttons.
			ButtonGroup group = new ButtonGroup();
			group.add((JRadioButton)myVWochen.getComponent());
			group.add((JRadioButton)myVMonate.getComponent());

			VWorM = true;
			myVMonate.setSelected(true);

			myVListOptAllMat = new NECheckBox("alle Mat.", null, null);
			myVListOptAllMat.setName("myVListOptAllMat");
			myVListOptAllMat.setBounds(15, 245, 80, 20);

			myVListOptAllPZA = new NECheckBox("alle PZA", null, null);
			myVListOptAllPZA.setName("myVListOptAllPZA");
			myVListOptAllPZA.setBounds(15, 265, 80, 20);

			myVListOptNull = new NECheckBox("nur > 0", null, null);
			myVListOptNull.setName("myVListOptNull");
			myVListOptNull.setBounds(15, 285, 80, 20);

			myVListSelekt = new NECheckBox("Selektion", this, "changeVSelectionMode");
			myVListSelekt.setName("myVListSelekt");
			myVListSelekt.setBounds(120, 245, 80, 20);
			
			myVListButton = new NEButton("Liste", this, "generateVList");
			myVListButton.setName("myVListButton");
			myVListButton.setBounds(120, 280, 80, 25);
			
// ======================================================================================

			myVBedarf = new NENumberTextField("", this, "changeVParameter");
			myVBedarf.setName("myVBedarf");
			myVBedarf.setBounds(365, 240, 80, 21);

			myVZBedarf = new NENumberTextField("", this, "changeVParameter");
			myVZBedarf.setName("myVZBedarf");
			myVZBedarf.setBounds(365, 264, 80, 21);

			myVAR = new NENumberTextField("", this, "changeVParameter");
			myVAR.setName("myVAR");
			myVAR.setBounds(365, 288, 80, 21);

// ======================================================================================

			VBrowser = new NETableBrowser(this, "browserClick", null);
			VBrowser.setName("VBrowser");
			VBrowser.setBounds(15, 15, 350, 150);

// ======================================================================================

			javax.swing.JSeparator VSeparator1 = new javax.swing.JSeparator();
			VSeparator1.setName("VSeparator1");
			VSeparator1.setBounds(15, 220, 430, 2);
			
			javax.swing.JSeparator VSeparator2 = new javax.swing.JSeparator();
			VSeparator2.setName("VSeparator2");
			VSeparator2.setBounds(230, 220, 2, 95);
			VSeparator2.setOrientation(javax.swing.SwingConstants.VERTICAL);
			
			javax.swing.JSeparator VSeparator3 = new javax.swing.JSeparator();
			VSeparator3.setName("VSeparator3");
			VSeparator3.setBounds(15, 315, 430, 2);

			myVOELBez = new javax.swing.JLabel();
			myVOELBez.setName("myVOELBez");
			myVOELBez.setFont(new java.awt.Font("dialog.bold", 0, 12));
			myVOELBez.setText("");
			myVOELBez.setBounds(100, 325, 250, 17);
			myVOELBez.setForeground(java.awt.Color.black);
			myVOELBez.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);

			NEPanel theDialogContentPane = new NEPanel();
			theDialogContentPane.setName("JDialogContentPane");
			theDialogContentPane.setLayout(null);
			theDialogContentPane.add(LIconLabel);
			theDialogContentPane.add(myVLabelList);
			theDialogContentPane.add(myVLabelAR);
			theDialogContentPane.add(myVLabelZB);
			theDialogContentPane.add(myVLabelOEL);
			theDialogContentPane.add(myVLabelPZA);
			theDialogContentPane.add(myVLabelBedarf);
			theDialogContentPane.add(myVOELBez);
			theDialogContentPane.add(VSeparator1);
			theDialogContentPane.add(VSeparator2);
			theDialogContentPane.add(VSeparator3);
			theDialogContentPane.add(VBrowser);
			theDialogContentPane.add(myVListOptAllMat);
			theDialogContentPane.add(myVListOptAllPZA);
			theDialogContentPane.add(myVListButton);			
			theDialogContentPane.add(myVListOptNull);
			theDialogContentPane.add(myVListSelekt);
			theDialogContentPane.add(myVMonate);
			theDialogContentPane.add(myVBedarf);
			theDialogContentPane.add(myVZBedarf);			
			theDialogContentPane.add(myVAR);
			theDialogContentPane.add(myVPZABez);
			theDialogContentPane.add(myVPZASlider);
			theDialogContentPane.add(myVrPZA);
			theDialogContentPane.add(myVWochen);

			myOEVPanel = new javax.swing.JFrame();
			myOEVPanel.setName("myOEVPanel");
			myOEVPanel.setDefaultCloseOperation(javax.swing.WindowConstants.HIDE_ON_CLOSE);
			myOEVPanel.setResizable(false);
			myOEVPanel.setBounds(525, 40, 460+wp, 355+hp);
			myOEVPanel.setTitle("Verkauf");
			myOEVPanel.setContentPane(theDialogContentPane.getComponent());
	
	return;	
}
/**
 * Insert the method's description here.
 * Creation date: (02.11.00 11:31:14)
 */
private void createPZAPanel() {

	javax.swing.JLabel IconLabel = new javax.swing.JLabel();
	IconLabel.setName("IconLabel");
	IconLabel.setIcon(new javax.swing.ImageIcon(getClass().getResource("/dia.gif")));
	IconLabel.setText("");
	IconLabel.setBounds(360, 10, 25, 35);
	
	myDate = new NEDateTextField("dd.MM.yyyy", null);
	myDate.setName("myDate");
	myDate.setBounds(15, 20, 80, 21);
	myDate.setEditable(false);

	javax.swing.JLabel myModDatLabel = new javax.swing.JLabel();
	myModDatLabel.setName("myModDatLabel");
	myModDatLabel.setFont(new java.awt.Font("dialog.bold", 1, 12));
	myModDatLabel.setText("Modell-Datum");
	myModDatLabel.setBounds(114, 23, 92, 17);
	myModDatLabel.setForeground(java.awt.Color.black);

	myrPZA = new NENumberTextField("0", this, "changeRPZA");
	myrPZA.setName("myrPZA");
	myrPZA.setBounds(15, 50, 25, 21);
	myrPZA.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
	myrPZA.setIntegerFormat(false);

	myPZASlider = new NEScrollBar(this, "changePZASlider");
	myPZASlider.setName("myPZASlider");	
	myPZASlider.setBounds(57, 52, 200, 17);
	myPZASlider.setOrientation(javax.swing.JScrollBar.HORIZONTAL);

	javax.swing.JLabel myRPZALabel = new javax.swing.JLabel();
	myRPZALabel.setName("myRPZALabel");
	myRPZALabel.setFont(new java.awt.Font("dialog", 0, 12));
	myRPZALabel.setText("relativer PZA");
	myRPZALabel.setBounds(271, 52, 78, 17);
	myRPZALabel.setForeground(java.awt.Color.black);

	myNat = new NENumberTextField("20", this, "changeNat");
	myNat.setName("myNat");
	myNat.setBounds(15, 80, 25, 21);
	myNat.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
	myNat.setIntegerFormat(false);

	javax.swing.JLabel myATLabel = new javax.swing.JLabel();
	myATLabel.setName("myATLabel");
	myATLabel.setFont(new java.awt.Font("dialog", 0, 12));
	myATLabel.setText("Arbeitstage im PZA");
	myATLabel.setBounds(57, 82, 117, 17);
	myATLabel.setForeground(java.awt.Color.black);

	PZABrowser = new NETableBrowser(this, "changePZABrowser", null);
	PZABrowser.setName("PZABrowser");
	PZABrowser.setBounds(15, 125, 370, 310);

	NEPanel theDialogContentPane = new NEPanel();
	theDialogContentPane.setName("JDialogContentPane");
	theDialogContentPane.setLayout(null);
	theDialogContentPane.add(IconLabel);
	theDialogContentPane.add(myDate);
	theDialogContentPane.add(myModDatLabel);
	theDialogContentPane.add(myrPZA);
	theDialogContentPane.add(myPZASlider);
	theDialogContentPane.add(myRPZALabel);
	theDialogContentPane.add(myNat);
	theDialogContentPane.add(myATLabel);
	theDialogContentPane.add(PZABrowser);

	myPZAPanel = new javax.swing.JFrame();
	myPZAPanel.setName("myPZAPanel");
	myPZAPanel.setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
	myPZAPanel.setResizable(false);
	myPZAPanel.setBounds(265, 276, 400+wp, 450+hp);
	myPZAPanel.setTitle("Planungszeitabschnitte (PZA)");
	myPZAPanel.setContentPane(theDialogContentPane.getComponent());
	
	return;	
}
public void generateAPList(NEDialogElement sender)
{
	if(myListContr == null) { 
		myListContr = (ListController) mainController.controllerWithKey(strings.getProperty("listcontroller")); 
	}
        if(myListContr != null) {
            Vector arg = new Vector();
            arg.addElement(currentPE);
            myListContr.generateList(1, 0, arg); 
        }

	return;
}
public void generateEList(NEDialogElement sender)
{
    int modus;
    if(myListContr == null) { 
	    myListContr = (ListController) mainController.controllerWithKey(strings.getProperty("listcontroller")); 
    }
    if(myListContr != null) {
        modus = 0;
        if(myEListOptAllPZA.isSelected()) {
            modus = modus | 1;
        }
        if(myEListOptAllMat.isSelected()) {
            modus = modus | 2;
        }
        if(myEListOptNull.isSelected()) {
            modus = modus | 4;
        }       
        if(myEListSelekt.isSelected()) {
            modus = modus | 8;
        }
        Vector arg = new Vector();
        // 1. Parameter currentEPZA
        Integer epza = new Integer(currentEPZA);
        arg.addElement(epza);
        // 2. Parameter currentEE
        arg.addElement(currentEE);
        // 3. Parameter selectedList
        arg.addElement(EBrowser);

        myListContr.generateList(2,modus,arg);
    }	

    return;
}
public void generateLList(NEDialogElement sender)
{
	if(myListContr == null) { 
		myListContr = (ListController) mainController.controllerWithKey(strings.getProperty("listcontroller")); 
	}	

	return;
}
public void generatePList(NEDialogElement sender)
{
	if(myListContr == null) { 
		myListContr = (ListController) mainController.controllerWithKey(strings.getProperty("listcontroller")); 
	}	

	return;
}
public void generateSLList(NEDialogElement sender)
{
	if(myListContr == null) { 
		myListContr = (ListController) mainController.controllerWithKey(strings.getProperty("listcontroller")); 
	}	

	return;
}
public void generateVList(NEDialogElement sender)
{
	if(myListContr == null) { 
		myListContr = (ListController) mainController.controllerWithKey(strings.getProperty("listcontroller")); 
	}	

	return;
}
public void handleEvent(NEDialogElement ctrl, java.util.EventObject ev) {

	JOptionPane.showMessageDialog(null, "Funktion ist noch nicht implementiert");


}
private void loadEBrowser(NETableBrowser browser)
{
	int a, row, offset, max;

	if(browser == EBrowser) {

		max = myOEE.eecount();
		
		if(!EBrowser.isDisplayed()) {
			
			EBrowser.setTable(max, 3, true, false);
			EBrowser.setColumnTitle("MatSchl", 0);
			EBrowser.setColumnTitle("Bezeichnung", 1);
			EBrowser.setColumnTitle("MESchl", 2);
			
		} else {

			EBrowser.updateTableModelRows(max);

		}

		EinkaufsElement ee;
		
		for(row = 0; row < max; row++) {
			ee = myOEE.einkaufselement(row);	
			EBrowser.setValueAt(ee.articleno(), row, 0);
			EBrowser.setValueAt(ee.articlename(), row, 1);			
			EBrowser.setValueAt(ee.unit(), row, 2);	
		}
		EBrowser.display();
		return;

	}

	return;
}
private void loadLBrowser(NETableBrowser browser)
{
	int a, row, offset, max;

	if(browser == OELBrowser) {

		OrganisationsEinheit oe;
		offset = anzahloeh;
		max = offset + anzahloel;
		
		if(!OELBrowser.isDisplayed()) {
			
			OELBrowser.setTable(anzahloel, 2, true, false);
			OELBrowser.setColumnTitle("OELSchl", 0);
			OELBrowser.setColumnTitle("Bezeichnung", 1);
			
		} else {

			OELBrowser.updateTableModelRows(max);

		}
			
		for(a = offset; a < max; a++) {
			row = a - offset;
			oe = myUModell.getOEByIndex(a);	
			OELBrowser.setValueAt(oe.oeschl(), row, 0);
			OELBrowser.setValueAt(oe.bezeichnung(), row, 1);		
		}
		OELBrowser.display();
		return;

	}

	if(browser == LMBrowser) {

		max = myOEL.lecount();
		
		if(!LMBrowser.isDisplayed()) {
			
			LMBrowser.setTable(max, 3, true, false);
			LMBrowser.setColumnTitle("MatSchl", 0);
			LMBrowser.setColumnTitle("Bezeichnung", 1);
			LMBrowser.setColumnTitle("MESchl", 2);
			
		} else {

			LMBrowser.updateTableModelRows(max);

		}

		LagerElement le;
		
		for(row = 0; row < max; row++) {
			le = myOEL.lagerelement(row);	
			LMBrowser.setValueAt(le.articleno(), row, 0);
			LMBrowser.setValueAt(le.articlename(), row, 1);			
			LMBrowser.setValueAt(le.unit(), row, 2);	
		}
		LMBrowser.display();
		return;

	}

	if(browser == QBrowser) {

		max = currentLMat.sourcecount();
		
		if(!QBrowser.isDisplayed()) {
			
			QBrowser.setTable(max, 2, true, false);
			QBrowser.setColumnTitle("QOESchl", 0);
			QBrowser.setColumnTitle("Bezeichnung", 1);
			
		} else {

			QBrowser.updateTableModelRows(max);

		}

		OrganisationsEinheit oe;
		
		for(row = 0; row < max; row++) {
			oe = currentLMat.quelle(row).getOE();	
			QBrowser.setValueAt(oe.oeschl(), row, 0);
			QBrowser.setValueAt(oe.bezeichnung(), row, 1);		
		}
		QBrowser.display();
		return;

	}

	return;
}
private void loadPBrowser(NETableBrowser browser)
{
	int a, row, offset, max;

	if(browser == OEPBrowser) {

		OrganisationsEinheit oe;
		max = anzahloeh;
		
		if(!OEPBrowser.isDisplayed()) {
			
			OEPBrowser.setTable(anzahloeh, 2, true, false);
			OEPBrowser.setColumnTitle("OEPSchl", 0);
			OEPBrowser.setColumnTitle("Bezeichnung", 1);
			
		} else {

			OEPBrowser.updateTableModelRows(max);

		}
			
		for(row = 0; row < max; row++) {
			oe = myUModell.getOEByIndex(row);	
			OEPBrowser.setValueAt(oe.oeschl(), row, 0);
			OEPBrowser.setValueAt(oe.bezeichnung(), row, 1);		
		}
		OEPBrowser.display();
		return;

	}

	if(browser == OMBrowser) {

		max = myOEP.pecount();
		
		if(!OMBrowser.isDisplayed()) {
			
			OMBrowser.setTable(max, 3, true, false);
			OMBrowser.setColumnTitle("OMatSchl", 0);
			OMBrowser.setColumnTitle("Bezeichnung", 1);
			OMBrowser.setColumnTitle("MESchl", 2);
			
		} else {

			OMBrowser.updateTableModelRows(max);

		}

		ProduktionsElement pe;
		
		for(row = 0; row < max; row++) {
			pe = myOEP.produktionselement(row);	
			OMBrowser.setValueAt(pe.articleno(), row, 0);
			OMBrowser.setValueAt(pe.articlename(), row, 1);			
			OMBrowser.setValueAt(pe.unit(), row, 2);	
		}
		if(max == 0) { currentOM = -1; }
		OMBrowser.display();
		return;

	}

	if(browser == UMBrowser) {

		max = currentPE.slecount();
		
		if(!UMBrowser.isDisplayed()) {
			
			UMBrowser.setTable(max, 3, true, false);
			UMBrowser.setColumnTitle("UMatSchl", 0);
			UMBrowser.setColumnTitle("Bezeichnung", 1);
			UMBrowser.setColumnTitle("MESchl", 2);
			
		} else {

			UMBrowser.updateTableModelRows(max);

		}

		SLElement sle;
		
		for(row = 0; row < max; row++) {
			sle = currentPE.stuecklistenelement(row);	
			UMBrowser.setValueAt(sle.articleno(), row, 0);
			UMBrowser.setValueAt(sle.articlename(), row, 1);			
			UMBrowser.setValueAt(sle.unit(), row, 2);
		}	
		if(max == 0) { currentUM = -1; }
		UMBrowser.display();
		return;

	}


	return;
}
private void loadPZABrowser(NETableBrowser browser)
{
	int a, row, offset, max;
	
	if(browser == PZABrowser) {
		
		if(!PZABrowser.isDisplayed()) {
			
			PZABrowser.setTable(maxPZA, 5, true, false);
			PZABrowser.setColumnTitle("rPZA", 0);
			PZABrowser.setColumnTitle("Bezeichnung", 1);
			PZABrowser.setColumnTitle("AT", 2);
			PZABrowser.setColumnTitle("Anfang", 3);
			PZABrowser.setColumnTitle("Ende", 4);
			
		} else {

			PZABrowser.updateTableModelRows(maxPZA);

		}
			
		for(a = 0; a != maxPZA; a++) {				
			PZABrowser.setValueAt(new Integer((a+1)), a, 0);
			PZABrowser.setValueAt(myKalender.bezeichnung(a), a, 1);
			PZABrowser.setValueAt(new Integer(myKalender.nat(a)), a, 2);
			PZABrowser.setValueAt(myKalender.beginn(a).getDateAsString(), a, 3);
			PZABrowser.setValueAt(myKalender.ende(a).getDateAsString(), a, 4);		
		}
		PZABrowser.display();
		return;

	}
}
private void loadVBrowser(NETableBrowser browser)
{
	int a, row, offset, max;

	if(browser == VBrowser) {

		max = myOEV.vecount();
		
		if(!VBrowser.isDisplayed()) {
			
			VBrowser.setTable(max, 3, true, false);
			VBrowser.setColumnTitle("MatSchl", 0);
			VBrowser.setColumnTitle("Bezeichnung", 1);
			VBrowser.setColumnTitle("MESchl", 2);
			
		} else {

			VBrowser.updateTableModelRows(max);

		}

		VerkaufsElement ve;
		
		for(row = 0; row < max; row++) {
			ve = myOEV.verkaufselement(row);	
			VBrowser.setValueAt(ve.articleno(), row, 0);
			VBrowser.setValueAt(ve.articlename(), row, 1);			
			VBrowser.setValueAt(ve.unit(), row, 2);	
		}
		VBrowser.display();
		return;

	}

	return;
}
public void openOEEPanel()
{
	int index;
	int a;

	if(myOEEPanel != null) {
		if(myOEEPanel.isVisible()) { return; }
	}

	if(myQAContr == null) { 
		myQAContr = (QAController) mainController.controllerWithKey(strings.getProperty("qacontroller")); 
	}

	if((myUModell != null)&&(myOEE != null)) {


		if(myOEEPanel == null) {
			
			this.createOEEPanel();
			myOEEPanel.setTitle(myOEE.oeschl() + " Einkauf");		
			
			this.changeEPZA();
			
			currentEM = 0;
			currentEE = null;
			
			this.loadEBrowser(EBrowser);
			EBrowser.selectRows(0, 0);
			
			this.changeEM();

		}
		
		myOEEPanel.setVisible(true);
		
	} else {
		JOptionPane.showMessageDialog(null, "Kein Modell aktiv!");
	}

	return;
}
public void openOELPanel()
{
	int index;
	int a;

	if(myOELPanel != null) {
		if(myOELPanel.isVisible()) { return; }
	}

	if(myQAContr == null) { 
		myQAContr = (QAController) mainController.controllerWithKey(strings.getProperty("qacontroller")); 
	}

	if((myUModell != null)&&(anzahloel != 0)) {


		if(myOELPanel == null) {
			
			this.createOELPanel(); 	
			
			this.changeLPZA();
                                                                       
			currentOEL = anzahloeh;
		
			this.loadLBrowser(OELBrowser);
			OELBrowser.selectRows(0, 0);

			myOEL = myUModell.getOEByIndex(currentOEL);

			currentLM = 0;
			currentLE = null;
			currentLMat = null;
			this.loadLBrowser(LMBrowser);
			LMBrowser.selectRows(currentLM, currentLM);
			this.changeLM();

			currentQ = 0;
			this.loadLBrowser(QBrowser);	
			this.changeQ();

		}
		
		myOELPanel.setVisible(true);
		
	} else {
		JOptionPane.showMessageDialog(null, "Kein Modell aktiv!");
	}

	return;
}
public void openOEPPanel()
{
	int index;
	int a;
        
	if(myOEPPanel != null) {
		if(myOEPPanel.isVisible()) { return; }
	}

	if(myQAContr == null) { 
		myQAContr = (QAController) mainController.controllerWithKey(strings.getProperty("qacontroller")); 
	}

	if((myUModell != null)&&(anzahloeh != 0)) {


		if(myOEPPanel == null) {
			
			this.createOEPPanel(); 
			
			this.changePPZA();
                                                                                      			
			currentOEP = 0;

			this.loadPBrowser(OEPBrowser);
			OEPBrowser.selectRows(0, 0);

			myOEP = myUModell.getOEByIndex(currentOEP);
			
			this.changeOEP();

	   	 	currentOM = 0;
			currentPE = null;
			
			this.loadPBrowser(OMBrowser);
			OMBrowser.selectRows(currentOM, currentOM);
			this.changeOM();

			currentUM = 0;		
			currentULE = null;
			
			this.loadPBrowser(UMBrowser);
			UMBrowser.selectRows(currentUM, currentUM);	
			this.changeUM();

		}
		
		myOEPPanel.setVisible(true);
		
	} else {
		JOptionPane.showMessageDialog(null, "Kein Modell aktiv!");
	}

	return;
}
public void openOEVPanel()
{
	int index;
	int a;

	if(myOEVPanel != null) {
		if(myOEVPanel.isVisible()) { return; }
	}

	if((myUModell != null)&&(myOEV != null)) {


		if(myOEVPanel == null) {
			
			this.createOEVPanel(); 
			myOEVPanel.setTitle(myOEV.oeschl() + " Verkauf");	
			
			this.changeVPZA();
			
			currentVM = 0;
			currentVE = null;
			
			this.loadVBrowser(VBrowser);
			VBrowser.selectRows(0, 0);
			
			this.changeVM();

		}
		
		myOEVPanel.setVisible(true);
		
	} else {
		JOptionPane.showMessageDialog(null, "Kein Modell aktiv!");
	}

	return;
}
public void openPZAPanel()
{
	int index;
	int a;
	
	if(myPZAPanel != null) {
		if(myPZAPanel.isVisible()) { return; }
	}

	if(myKalender != null) {

		if(myPZAPanel == null) { this.createPZAPanel(); }
		
		currentPZA = 0;	
		this.loadPZABrowser(PZABrowser);
		myDate.setDateValue(myKalender.calendar());
		myNat.setIntValue(myKalender.nat(currentPZA));
		myrPZA.setIntValue(currentPZA + 1);				
		myPZAPanel.setVisible(true);		
		myPZASlider.setMinMaxValue(1, maxPZA);		
		myPZASlider.setIntValue(currentPZA + 1);

	}
	else {
		JOptionPane.showMessageDialog(null, "Kein Modell aktiv!");
	}

	return;
}
public void openWindow()
{
	this.openPZAPanel();
	return;
}
public void update(boolean pzachanged)
{
	if(pzachanged) {
		super.update(pzachanged);
		if(myOEPPanel != null) { this.aktualisiereP(); }
		if(myOELPanel != null) { this.aktualisiereL(); }
		if(myOEEPanel != null) { this.aktualisiereE(); }
		if(myOEVPanel != null) { this.aktualisiereV(); }
	} else {
		if(myOEPPanel != null) { this.aktualisiereP(); }
		if(myOELPanel != null) { this.aktualisiereL(); }
		if(myOEEPanel != null) { this.aktualisiereE(); }
		if(myOEVPanel != null) { this.aktualisiereV(); }
	}
	return;
}
public void updateModell(UModell modell)
{
	super.updateModell(modell);
	
	anzahloeh = myUModell.getOEPcount();
	anzahloel = myUModell.getOELcount();
	myOEV = myUModell.getOEVerkauf();
	myOEE = myUModell.getOEEinkauf();
	
	if(myPZAPanel != null) {
		myPZAPanel.setVisible(false);
		myPZAPanel = null;
	}
	if(myOEEPanel != null) {
		myOEEPanel.setVisible(false);
		myOEEPanel = null;
	}
	if(myOELPanel != null) {
		myOELPanel.setVisible(false);
		myOELPanel = null;
	}
	if(myOEPPanel != null) {
		myOEPPanel.setVisible(false);
		myOEPPanel = null;
	}
	if(myOEVPanel != null) {
		myOEVPanel.setVisible(false);
		myOEVPanel = null;
	}

	// alle Fenster schlieen !!!!
}
}
