/*
 * Standard-Listen-Viewer NeRTHUS PPS
 *
 * Created on 8. Juni 2001, 13:59
 */

package com.nerthus.proisys.bundles;

import org.jdom.*;
import java.util.*;
import java.io.*;
import java.net.URL;
import java.awt.*;
import java.awt.event.*;
import java.awt.print.*; 
import javax.swing.*;
import javax.swing.text.rtf.*;
import javax.swing.text.html.*;
import javax.swing.filechooser.*;
import java.text.NumberFormat;
import java.text.SimpleDateFormat;

import com.nerthus.proisys.pps.kernel.*;
import com.nerthus.appkit.*;
import com.nerthus.proisys.pps.*;

/**
 *
 * @author  rbohlig
 * @version 
 */
public class PPSList extends com.nerthus.proisys.pps.NEController 
implements ListController, NEDialogDelegate {
    private PrintableEditorPane painter = null;
    private JFrame frame = null;
    
    public class NEFileFilter extends javax.swing.filechooser.FileFilter {

        public boolean accept(File f) {
	    if (f.isDirectory()) {
		return true;
	    }

	    String extension = this.getExtension(f);
	    if (extension != null) {
		if (extension.equals("html") ||
                        extension.equals("xml") ||
			extension.equals("htm") ||
			extension.equals("rtf") ||
                        extension.equals("txt") ||
                        extension.equals("lst")){
			return true;
		} else {
			return false;
		}
	    }

	    return false;
        }
        // The description of this filter
        public String getDescription() {
	    return "XML, HTML, HTM, RTF, TXT, LST";
        }
	public String getExtension(File f) {
		String ext = null;
		String s = f.getName();
		int i = s.lastIndexOf('.');

		if (i > 0 &&  i < s.length() - 1) {
			ext = s.substring(i+1).toLowerCase();
		}
		return ext;
	}
    }
    
    
    private NEFileFilter ff = new NEFileFilter();
    private PrintWriter fd;

    /** Creates new NeList */
    public PPSList(String resfile) {
	super(resfile);
}

    /**
     * Standard-Methode des Listengenerators.
     *
     * @param type int
     * @param mode int
     * @param array Object[]
 */
    public void generateList(int type, int mode, Vector arglist) {
        int style;
        int size;
        String fontstyle = strings.getProperty("font.style");
        frame = new JFrame("NeRTHUS PPS - Listenausgabe");
        frame.setSize(600, 450);
        this.createMenu();
        painter = new PrintableEditorPane();
        size = new Integer(strings.getProperty("font.size")).intValue();
        style = Font.PLAIN;
        if(fontstyle.equals("bold")) {
            style |= Font.BOLD;
        } else if(fontstyle.equals("italic")) {
            style |= Font.ITALIC;
        }
        Font fnt = new Font(strings.getProperty("font.name"), Font.PLAIN, 10);
        painter.setFont(fnt);
        painter.repaint();
   /*     switch(mode) {
            case 1: // RTF
                RTFEditorKit rtfKit = new RTFEditorKit();
                painter.setEditorKit(rtfKit);                 
                break;
                
            case 2: // HTML
                HTMLEditorKit htmlKit = new HTMLEditorKit();
                painter.setEditorKit(htmlKit);
                painter.setSCALE(true);
                break;
        }
    */
        painter.setEditable(false);
        JScrollPane ps = new JScrollPane(painter);
	frame.getContentPane().add(ps, BorderLayout.CENTER);
        frame.setVisible(true);
        
        switch(type) {
            case 1:
                this.generateArbeitsplan(arglist);               
                break;
            case 2:
                this.generateEinkaufsliste(mode, arglist);               
                break;
        }
    }

    // ############# OEP-Dialog ##############
    private int generateArbeitsplan(Vector arglist) {
        int a, e;
        String text;
        painter.println(strings.getProperty("firma"));
        ProduktionsElement pe = (ProduktionsElement) arglist.elementAt(0);      
        if(pe != null) {
            NumberFormat numFormatter = NumberFormat.getNumberInstance();
	    numFormatter.setMinimumFractionDigits(4);
	    numFormatter.setMaximumFractionDigits(4);
            Material mat = pe.getMat();
            OrganisationsEinheit oe = pe.getOE();
            text = "\nArbeitsplan\n\nOE:\t\t" + oe.oeschl() + "\t" + oe.bezeichnung();
            text = text + "\nMaterial:\t" + mat.matschl() + "\t" + mat.matbez() + "\t"
                    + mat.meschl() + "\n\n";

            text = text + "\t\tZB\tLST\tMasch\tMaenner\tFrauen\n";

            a = pe.apcount();
            for(e = 0; e < a; e++) {
                Arbeitsplan ap = pe.arbeitsplan(e);
                text = text + "\t\t" + ap.zeitbasis() + "\t"
                + ap.lst_id() + "\t";
                text = text + numFormatter.format(ap.masch_te()) + "\t";
                text = text + numFormatter.format(ap.mae_te()) + "\t";
                text = text + numFormatter.format(ap.fra_te()) + "\n";

            }
            painter.println(text);
        } else {
            System.out.println("NeRTHUS PPS: AP-Liste: kein gltiges PE");
        }
        return 0;
    }
    private int generateStueckliste() {
        return 0;
    }
    private int generateProdplan() {
        return 0;
    }
    // ############# OEL-Dialog ##############
    private int generateLagerliste() {
        return 0;
    }
    // ############# OEE-Dialog ##############
    private int generateEinkaufsliste(int mode, Vector arglist) {
        // Beispiel HTML direkt
        int currentEPZA, min, max, a, b, ematcount;
        double y = 0;
        double x = 0;
        EinkaufsElement ee;
        OrganisationsEinheit oe;
        NETableBrowser theEBrowser = (NETableBrowser) arglist.elementAt(2);
        SimpleDateFormat dateFormatter = new SimpleDateFormat("dd.MM.yyyy");
        NumberFormat numFormatter = NumberFormat.getNumberInstance();
        numFormatter.setMinimumFractionDigits(2);
        numFormatter.setMaximumFractionDigits(2);
        HTMLEditorKit htmlKit = new HTMLEditorKit();
        painter.setEditorKit(htmlKit);
        painter.setSCALE(true);
        Integer tmp = (Integer) arglist.elementAt(0);
        currentEPZA = tmp.intValue();
        try {
            fd = new PrintWriter(new BufferedOutputStream(new FileOutputStream("eklist.htm")), true);
        }
        catch(FileNotFoundException exc) {
            System.err.println("FileNotFoundException in PPSList (EK)");
        } 
        // String htmltext;       
        fd.print("<HTML>\n");
        fd.print("<HEAD>\n");
        fd.print("<META HTTP-EQUIV=\"Content-Type\" CONTENT=\"text/html; charset=iso-8859-1\">\n");
        fd.print("<META NAME=\"Generator\" CONTENT=\"NeRTHUS\">\n");
        fd.print("<TITLE>NeRTHUS PPS - Einkaufsliste</TITLE>\n");
        fd.print("</HEAD>\n");
        fd.print("<BODY>\n");
        fd.print("<P>\n");
        fd.print("<table border=\"0\" cellpadding=\"2\" cellspacing=\"0\" width=\"100%%\" ");
        fd.print("<tr>");
        fd.print("<td>NeRTHUS PPS</td>");
        fd.print("<td>" + dateFormatter.format(myKalender.calendar().getAsDate()) + "</td>");
        fd.print("</tr>");
        fd.print("</table>");
        fd.print("<p align=\"center\"><font color=\"#000080\"><strong>Einkaufsliste</strong></font></p>\n");

        if((mode & 1) == 1) {
            if(currentEPZA < maxWeek) { min = 0; max = currentMaxWeek; }
            else { min = maxWeek; max = currentMaxPZA; }
        } else { min = currentEPZA; max = min + 1; }
    
       // Tabellenueberschrift
        
        fd.print("<table align=\"center\" border=\"3\" cellpadding=\"2\" cellspacing=\"0\"\n");
        fd.print("<tr>\n");
        fd.print("<td align=\"center\"><strong>MatSchl</strong></td>\n");
        fd.print("<td align=\"center\"><strong>Mat.-Bezeichnung</strong></td>\n");
        fd.print("<td align=\"center\"><strong>MESchl</strong></td>\n");
        for(b = min; b != max; b++) {
            fd.print("<td align=\"center\"><strong>");
            fd.print(myKalender.pzabez(b) + "</strong></td>\n");
        } 
        if((mode & 1) == 1) {
            fd.print("<td align=\"center\"><strong>Summe</strong></td>\n");
        }
        fd.print("</tr>\n");

        oe = myUModell.getOEEinkauf();
        
        if((mode & 2) == 2) {
            ematcount = oe.eecount();
            for(a = 0; a < ematcount; a++) {
                ee = oe.einkaufselement(a);
                    
                if((mode & 8) == 8) {
                    // Selektion prfen
                    if(!theEBrowser.isRowSelected(a)) {
			continue;
		    }
                }
                // > 0 pruefen
                if((mode & 4) == 4) {
                    y = 0;
                    for(b = min; b != max; b++) {
                        y += ee.output(b);	
                    }
                    if(y == 0) { continue; }
                }
                fd.print("<tr>\n");
                fd.print("<td align=\"left\">" + ee.articleno() + "</td>\n");
                fd.print("<td align=\"left\">" + ee.articlename() + "</td>\n");
                fd.print("<td align=\"left\">" + ee.unit() + "</td>\n");

                y = 0;
                for(b = min; b != max; b++) {
                    x = ee.output(b);
                    y += x; 
                    fd.print("<td align=\"right\">" +
                        numFormatter.format(x) + "</td>\n");
                }
                if((mode & 1) == 1) { 
                    fd.print("<td align=\"right\">" +
                        numFormatter.format(y) + "</td>\n");
                }
                fd.print("</tr>\n");
            }
        } else {
            // einzelnes Material
            ee = (EinkaufsElement) arglist.elementAt(1);

            fd.print("<tr>\n");
            fd.print("<td align=\"left\">" + ee.articleno() + "</td>\n");
            fd.print("<td align=\"left\">" + ee.articlename() + "</td>\n");
            fd.print("<td align=\"left\">" + ee.unit() + "</td>\n");

            y = 0;
            for(b = min; b != max; b++) {
                x = ee.output(b);
                y += x; 
                fd.print("<td align=\"right\">" +
                        numFormatter.format(x) + "</td>\n");
            }
            if((mode & 1) == 1) { 
                fd.print("<td align=\"right\">" +
                        numFormatter.format(y) + "</td>\n"); 
            }
            fd.print("</tr>\n");           
        }
        
        fd.print("</table>\n");
        fd.print("</P></BODY>\n");
        fd.print("</HTML>");
        fd.flush();
        fd.close();
        File file = new File("eklist.htm");
        this.openFile(file);
        // painter.println(htmltext);
        return 0;
    }
    // ############# OEV-Dialog ##############
    private int generateVerkaufsliste() {
        return 0;
    }
    
    private void createMenu() {
	
	// add a menu bar
	JMenuBar mb = new JMenuBar();
        NEMenuItem tmp;
        
        NEMenu modell = new NEMenu("Liste", null);
	tmp = new NEMenuItem(modell, "Liste ffnen...", this, "open");
        tmp.setName("openList");
	tmp.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_N, ActionEvent.ALT_MASK));
	tmp = new NEMenuItem(modell, "Liste sichern...", this, "save");
        tmp.setName("saveList");
	tmp.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_W, ActionEvent.ALT_MASK));
	mb.add((JMenu) modell.getComponent());
/*	
	NEMenu edit = new NEMenu("Bearbeiten", null);
	tmp = new NEMenuItem(edit, "Ausschneiden", this);
	tmp.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_X, ActionEvent.ALT_MASK));
	tmp = new NEMenuItem(edit, "Kopieren", this);
	tmp.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_C, ActionEvent.ALT_MASK));
	tmp = new NEMenuItem(edit, "Einsetzen", this);
	tmp.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_V, ActionEvent.ALT_MASK));
	tmp = new NEMenuItem(edit, "alles auswhlen",this);
	tmp.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_A, ActionEvent.ALT_MASK));
	mb.add((JMenu) edit.getComponent());
*/
	NEMenu druck = new NEMenu("Drucken", null);
	tmp = new NEMenuItem(druck, "Drucken...", this, "print");
        tmp.setName("printList");
	mb.add((JMenu) druck.getComponent());
		
	frame.setJMenuBar(mb);
	
	return;	
}
    
/**
 * Die Default-Delegate-Methode fr
 * alle NEDialogElemente, fuer die keine
 * explizite Action-Method+Target vereinbart ist
 *
 * Creation date: (31.10.00 23:21:25)
 * @param ctr com.nerthus.appkit.NEDialogElement
 * @param ev java.util.EventObject
 */
public void handleEvent(NEDialogElement ctr, java.util.EventObject ev) {
}

public void print(NEDialogElement sender) {
    
   JobAttributes jobAttributes = new JobAttributes(); 
   PageAttributes pageAttributes = new PageAttributes(); 
   PrinterJob prnJob = PrinterJob.getPrinterJob();
   jobAttributes.setDialog(JobAttributes.DialogType.COMMON);
   //jobAttributes.setDialog(JobAttributes.DialogType.NONE);
   pageAttributes.setOrigin(PageAttributes.OriginType.PRINTABLE); 
   pageAttributes.setPrintQuality(PageAttributes.PrintQualityType.HIGH); 
   PrintJob printJob = Toolkit.getDefaultToolkit().getPrintJob(null, "NeRTHUS PPS", jobAttributes, pageAttributes); 
    PageFormat pf = new PageFormat();
   try {
        prnJob.setJobName(("NeRTHUS"));
        prnJob.setPrintable(painter, pf);
        prnJob.print();
    } catch (Exception e) { 
        System.out.println("NeRTHUS print list: Exception occurred: " + e); 
    } 
    
}

public void open(NEDialogElement sender) {
    JFileChooser fc = new JFileChooser();
    fc.setFileFilter(ff);
	//	fc.setAccessory(new PrintPreview(fc));

    int returnVal = fc.showDialog(frame,"open file");

    if (returnVal == JFileChooser.APPROVE_OPTION) {
        File file = fc.getSelectedFile();
        this.openFile(file);
    } else {
    //    System.out.println("Attachment cancelled by user." );
    }
    return;
}

public void save(NEDialogElement sender) {
    // Code hier implementieren
    JOptionPane.showMessageDialog(null, "Demo!");
}

private void openFile(File file) {
	// System.out.println("open file: " + file.getName());
	URL fileURL = null;
        String ext;
	String prefix = "file:" 
			+ file.getPath()
			+ System.getProperty("file.separator");

	try {
	//	fileURL = new URL(prefix + file.getName());
		fileURL = new URL(prefix);
	} catch (java.net.MalformedURLException exc) {
		System.err.println("Attempted to create a path "
								   + "with a bad URL: " + fileURL);
	}
	try {
            ext = ff.getExtension(file);
            if((ext.equals("html")) || (ext.equals("htm"))) {
                HTMLEditorKit htmlKit = new HTMLEditorKit();
                painter.setEditorKit(htmlKit);
                painter.setSCALE(true);             
            } else if(ext.equals("rtf")) {
                RTFEditorKit rtfKit = new RTFEditorKit();
                painter.setEditorKit(rtfKit);                 
            } else {
                painter.setEditorKit(null); 
            }
                
	    painter.setPage(fileURL);
	} catch (IOException e) {
		System.err.println("Attempted to read a bad URL: " + fileURL);
	}

}

}