package com.nerthus.proisys.bundles;

import java.util.*;
import javax.swing.*;
import com.nerthus.proisys.pps.kernel.*;
import com.nerthus.appkit.*;
import com.nerthus.proisys.pps.*;
/**
 * Manipulation von Parametern des NeRTHUS PPS.
 * 
 * @author: R.Bohlig
 */
public class ParaManipulation extends com.nerthus.proisys.pps.NEController 
implements NEDialogDelegate {

	private JDialog myPanel;

	private int beginnWeek;
	private int endeWeek;
	private int beginnMonth;
	private int endeMonth;

	private NETableBrowser matBrowser;
	private Vector Elemente;
	private	NECheckBox mySelektion;

	private NEButton myOKButton;
	private NEButton myAbbrButton;

	private NENumberTextField beginnMonat;
	private NENumberTextField endeMonat;
	private NENumberTextField beginnWoche;
	private NENumberTextField endeWoche;
	
	private NERadioButton myLRWSet;
	private	NERadioButton myLRWAdd;
	private NERadioButton mySLRWSet;
	private	NERadioButton mySLRWAdd;

	private NECheckBox myWPZA;
	private	NECheckBox myMPZA;

	private NECheckBox myLAB;
	private NECheckBox myLHB;
	private	NECheckBox myLMB;
	private NECheckBox myLVP;
	private NECheckBox myLRW;
	private	NECheckBox myLHRW;
	private	NECheckBox myLMRW;

	private NENumberTextField myLABWert;
	private NENumberTextField myLHBWert;
	private	NENumberTextField myLMBWert;
	private NENumberTextField myLVPWert;
	private NENumberTextField myLRWWert;
	private	NENumberTextField myLHRWWert;
	private	NENumberTextField myLMRWWert;

	private NECheckBox mySLAB;
	private NECheckBox mySLHB;
	private	NECheckBox mySLMB;
	private NECheckBox mySLVP;
	private NECheckBox mySLRW;
	private	NECheckBox mySLHRW;
	private	NECheckBox mySLMRW;

	private NENumberTextField mySLABWert;
	private NENumberTextField mySLHBWert;
	private	NENumberTextField mySLMBWert;
	private NENumberTextField mySLVPWert;
	private NENumberTextField mySLRWWert;
	private	NENumberTextField mySLHRWWert;
	private	NENumberTextField mySLMRWWert;

	private NECheckBox myEMM;
	private NECheckBox myPMM;

	private NENumberTextField myEMMWert;
	private NENumberTextField myPMMWert;

	private double hbl, hbsl, hrwl, hrwsl, mrwl, mrwsl, mbl, mbsl, abl, absl, vpl, vpsl, pzl, pzsl, mme, mmh;
	private boolean HBL, HBSL, HRWL, HRWSL, MRWL, MRWSL, MBL, MBSL, ABL, ABSL, VPL, VPSL, PZL, PZSL, MME, MMH;
	private boolean ADDPZL, ADDPZSL, ALLMAT, MONAT, WOCHE;

	
	static int hp = 30;
	static int wp = 5;

/**
 * ParaManipulation constructor.
 *
 * @param resfile java.lang.String
 */
public ParaManipulation(String resfile) {
	super(resfile);
}
/**
 * ParaManipulation constructor.
 *
 * @param resfile java.lang.String
 * @param mc com.nerthus.proisys.pps.NEMainController
 */
public ParaManipulation(String resfile, com.nerthus.proisys.pps.NEMainController mc) {
	super(resfile, mc);
}
public void abbrechen(NEDialogElement sender)
{
 /*   [NSApp stopModal];
	[Quellen release];
	[myAuswahl setState:0];
	[myQAPanel close];
 //   [mainController update:NO];
 */
 	myPanel.setVisible(false);
}
public void browserClick(NEDialogElement sender)
{
	return;
}
public void changeSelektion(NEDialogElement sender)
{
/* ListSelectionModel.SINGLE_SELECTION
 * ListSelectionModel.SINGLE_INTERVAL_SELECTION
 * ListSelectionModel.MULTIPLE_INTERVAL_SELECTION
 */
	if(sender == mySelektion) {
		if(mySelektion.isSelected()) {
			matBrowser.setSelectionMode(ListSelectionModel.MULTIPLE_INTERVAL_SELECTION);
		} else {
			matBrowser.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		}
	}
	return;
}
public void changeWert(NEDialogElement sender)
{
	if(sender == myPMMWert) {
		mmh = myPMMWert.doubleValue();
		if(mmh < 0) { mmh = 0; }
		myPMMWert.setDoubleValue(mmh);
		return;
	}
	if(sender == myEMMWert) {
		mme = myEMMWert.doubleValue();
		if(mme < 0) { mmh = 0; }
		myEMMWert.setDoubleValue(mme);
		return;
	}
	if(sender == beginnMonat) {
		beginnMonth = beginnMonat.intValue() - 1;
		if((beginnMonth < maxWeek)||(beginnMonth >= endeMonth)) { beginnMonth = maxWeek; }
		beginnMonat.setIntValue(beginnMonth+1);
		return;
	}
	if(sender == beginnWoche) {
		beginnWeek = beginnWoche.intValue() - 1;
		if((beginnWeek < 0)||(beginnWeek>=endeWeek)) { beginnWeek = 0; }
		beginnWoche.setIntValue(beginnWeek+1);
		return;
	}
	if(sender == endeMonat) {
		endeMonth = endeMonat.intValue();
		if((endeMonth > currentMaxPZA)||(endeMonth <= beginnMonth)) { endeMonth = currentMaxPZA; }
		endeMonat.setIntValue(endeMonth);
		return;
	}
	if(sender == endeWoche) {
		endeWeek = endeWoche.intValue();
		if((endeWeek <= 1)||(endeWeek<=beginnWeek)) { endeWeek = currentMaxWeek; }
		endeWoche.setIntValue(endeWeek);
		return;
	}
	if(sender == myLHBWert) {
		hbl = myLHBWert.doubleValue();
		if(hbl <0) { hbl = -1; myLHBWert.setStringValue("unendl."); }
		else { myLHBWert.setDoubleValue(hbl); }
		return;
	}
	if(sender == mySLHBWert) {
		hbsl = mySLHBWert.doubleValue();
		if(hbsl < 0) { hbsl = -1; mySLHBWert.setStringValue("unendl."); }
		else { mySLHBWert.setDoubleValue(hbsl); }
		return;
	}	
	if(sender == myLHRWWert) {
		hrwl = myLHRWWert.doubleValue();
		if(hrwl <0) { hrwl = -1; myLHRWWert.setStringValue("unendl."); }
		else { myLHRWWert.setDoubleValue(hrwl); }
		return;
	}	
	if(sender == mySLHRWWert) {
		hrwsl = mySLHRWWert.doubleValue();
		if(hrwsl <0) { hrwsl = -1; mySLHRWWert.setStringValue("unendl."); }
		else { mySLHRWWert.setDoubleValue(hrwsl); }
		return;
	}	
	if(sender == myLMBWert) {
		mbl = myLMBWert.doubleValue();
		if(mbl < 0) { mbl = 0; }
		myLMBWert.setDoubleValue(mbl);
		return;
	}	
	if(sender == mySLMBWert) {
		mbsl = mySLMBWert.doubleValue();
		if(mbsl < 0) { mbsl = 0; }
		mySLMBWert.setDoubleValue(mbsl);
		return;
	}	
	if(sender == myLMRWWert) {
		mrwl = myLMRWWert.doubleValue();
		if(mrwl < 0) { mrwl = 0; }
		myLMRWWert.setDoubleValue(mrwl);
		return;
	}
	if(sender == mySLMRWWert) {
		mrwsl = mySLMRWWert.doubleValue();
		if(mrwsl < 0) { mrwsl = 0; }
		mySLMRWWert.setDoubleValue(mrwsl);
		return;
	}
	if(sender == myLABWert) {
		abl = myLABWert.doubleValue();
		if(abl < 0) { abl = 0; }
		myLABWert.setDoubleValue(abl);
		return;
	}
	if(sender == myLVPWert) {
		vpl = myLVPWert.doubleValue();
		if(vpl < 0) { vpl = 0; }
		myLVPWert.setDoubleValue(vpl);
		return;
	}
	if(sender == myLRWWert) {
		pzl = myLRWWert.doubleValue();
		if(pzl < 0) { pzl = 0; }
		myLRWWert.setDoubleValue(pzl);
		return;
	}
	if(sender == mySLABWert) {
		absl = mySLABWert.doubleValue();
		if(absl < 0) { absl = 0; }
		mySLABWert.setDoubleValue(absl);
		return;
	}
	if(sender == mySLVPWert) {
		vpsl = mySLVPWert.doubleValue();
		if(vpsl < 0) { vpsl = 0; }
		mySLVPWert.setDoubleValue(vpsl);
		return;
	}
	if(sender == mySLRWWert) {
		pzsl = mySLRWWert.doubleValue();
		if(pzsl < 0) { pzsl = 0; }
		mySLRWWert.setDoubleValue(pzsl);
		return;
	}
	return;
}
private void createPanel() {

			javax.swing.JLabel LIconLabel = new javax.swing.JLabel();
			LIconLabel.setName("LIconLabel");
			LIconLabel.setIcon(new javax.swing.ImageIcon(getClass().getResource("/dia.gif")));
			LIconLabel.setText("");
			LIconLabel.setBounds(430, 20, 25, 35);

			javax.swing.JLabel myBMLabel = new javax.swing.JLabel();
			myBMLabel.setName("myBMLabel");
			myBMLabel.setFont(new java.awt.Font("dialog.bold", 1, 12));
			myBMLabel.setText("Vernderungen von Monats-PZA:");
			myBMLabel.setBounds(35, 256, 200, 17);
			myBMLabel.setForeground(java.awt.Color.black);
			myBMLabel.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);

			javax.swing.JLabel myBWLabel = new javax.swing.JLabel();
			myBWLabel.setName("myBWLabel");
			myBWLabel.setFont(new java.awt.Font("dialog.bold", 1, 12));
			myBWLabel.setText("Vernderungen von Wochen-PZA:");
			myBWLabel.setBounds(35, 232, 200, 17);
			myBWLabel.setForeground(java.awt.Color.black);
			myBWLabel.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);

			javax.swing.JLabel myEMLabel = new javax.swing.JLabel();
			myEMLabel.setName("myEMLabel");
			myEMLabel.setFont(new java.awt.Font("dialog.bold", 1, 12));
			myEMLabel.setText("bis Monats-PZA:");
			myEMLabel.setBounds(305, 256, 100, 17);
			myEMLabel.setForeground(java.awt.Color.black);
			myEMLabel.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
			
			javax.swing.JLabel myEWLabel = new javax.swing.JLabel();
			myEWLabel.setName("myEWLabel");
			myEWLabel.setFont(new java.awt.Font("dialog.bold", 1, 12));
			myEWLabel.setText("bis Wochen-PZA:");
			myEWLabel.setBounds(305, 232, 100, 17);
			myEWLabel.setForeground(java.awt.Color.black);
			myEWLabel.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);

			javax.swing.JLabel myCommentLabel = new javax.swing.JLabel();
			myCommentLabel.setName("myCommentLabel");
			myCommentLabel.setText("Die Parameter werden verndert und das Modell wird neu berechnet!");
			myCommentLabel.setForeground(java.awt.Color.black);
			myCommentLabel.setVerticalTextPosition(javax.swing.SwingConstants.CENTER);
			myCommentLabel.setFont(new java.awt.Font("dialog.bold", 1, 12));
			myCommentLabel.setVerticalAlignment(javax.swing.SwingConstants.TOP);
			myCommentLabel.setBounds(35, 587, 400, 20);
			myCommentLabel.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);

// ======================================================================================

			beginnMonat = new NENumberTextField("", this, "changeWert");
			beginnMonat.setName("beginnMonat");
			beginnMonat.setBounds(240, 254, 25, 21);
			beginnMonat.setIntegerFormat(false);

			beginnWoche = new NENumberTextField("", this, "changeWert");
			beginnWoche.setName("beginnWoche");
			beginnWoche.setBounds(240, 230, 25, 21);
			beginnWoche.setIntegerFormat(false);

			endeMonat = new NENumberTextField("", this, "changeWert");
			endeMonat.setName("endeMonat");
			endeMonat.setBounds(410, 254, 25, 21);
			endeMonat.setIntegerFormat(false);

			endeWoche = new NENumberTextField("", this, "changeWert");
			endeWoche.setName("endeWoche");
			endeWoche.setBounds(410, 230, 25, 21);
			endeWoche.setIntegerFormat(false);

			myMPZA = new NECheckBox("", null);
			myMPZA.setName("myMPZA");
			myMPZA.setBounds(15, 254, 20, 20);

			myWPZA = new NECheckBox("", null);
			myWPZA.setName("myWPZA");
			myWPZA.setBounds(15, 230, 20, 20);
			
// ======================================================================================

			myEMM = new NECheckBox("Mindestmenge:", null);
			myEMM.setName("myEMM");
			myEMM.setHorizontalTextPosition(javax.swing.SwingConstants.LEFT);
			myEMM.setFont(new java.awt.Font("dialog", 0, 12));
			myEMM.setBounds(10, 15, 110, 20);
			myEMM.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);

			myEMMWert = new NENumberTextField("", this, "changeWert");
			myEMMWert.setName("myEMMWert");
			myEMMWert.setBounds(125, 15, 80, 21);
	//		myEMMWert.setDoubleValue(0);

			NEPanel myEPane = new NEPanel("Einkauf");
			myEPane.setName("myEPane");
			myEPane.setLayout(null);
			myEPane.setBounds(15, 529, 220, 50);
			myEPane.add(myEMM);
			myEPane.add(myEMMWert);

// ======================================================================================

			myPMM = new NECheckBox("Mindestmenge:", null);
			myPMM.setName("myPMM");
			myPMM.setActionCommand("");
			myPMM.setHorizontalTextPosition(javax.swing.SwingConstants.LEFT);
			myPMM.setFont(new java.awt.Font("dialog", 0, 12));
			myPMM.setBounds(10, 15, 110, 20);
			myPMM.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);

			myPMMWert = new NENumberTextField("", this, "changeWert");
			myPMMWert.setName("myPMMWert");
			myPMMWert.setBounds(125, 15, 80, 21);
	//		myPMMWert.setDoubleValue(0);

			NEPanel myPPane = new NEPanel("Produktion");
			myPPane.setName("myPPane");
			myPPane.setLayout(null);
			myPPane.setBounds(235, 529, 220, 50);
			myPPane.add(myPMM);
			myPPane.add(myPMMWert);

// ======================================================================================


			myLAB = new NECheckBox("Anfangsbestand:", null);
			myLAB.setName("myLAB");
			myLAB.setHorizontalTextPosition(javax.swing.SwingConstants.LEFT);
			myLAB.setFont(new java.awt.Font("dialog", 0, 12));
			myLAB.setBounds(10, 15, 110, 20);
			myLAB.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);

			myLABWert = new NENumberTextField("", this, "changeWert");
			myLABWert.setName("myLABWert");
			myLABWert.setBounds(125, 15, 80, 21);

			myLHB = new NECheckBox("Hchstbestand:", null);
			myLHB.setName("myLHB");
			myLHB.setHorizontalTextPosition(javax.swing.SwingConstants.LEFT);
			myLHB.setFont(new java.awt.Font("dialog", 0, 12));
			myLHB.setBounds(10, 39, 110, 20);
			myLHB.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);

			myLHBWert = new NENumberTextField("", this, "changeWert");
			myLHBWert.setName("myLHBWert");
			myLHBWert.setBounds(125, 39, 80, 21);

			myLHRW = new NECheckBox("Hchstreichw.:", null);
			myLHRW.setName("myLHRW");
			myLHRW.setHorizontalTextPosition(javax.swing.SwingConstants.LEFT);
			myLHRW.setFont(new java.awt.Font("dialog", 0, 12));
			myLHRW.setBounds(10, 135, 110, 20);
			myLHRW.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);

			myLHRWWert = new NENumberTextField("", this, "changeWert");
			myLHRWWert.setName("myLHRWWert");
			myLHRWWert.setBounds(125, 135, 80, 21);

			myLMB = new NECheckBox("Mindestbestand:", null);
			myLMB.setName("myLMB");
			myLMB.setHorizontalTextPosition(javax.swing.SwingConstants.LEFT);
			myLMB.setFont(new java.awt.Font("dialog", 0, 12));
			myLMB.setBounds(10, 63, 110, 20);
			myLMB.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);

			myLMBWert = new NENumberTextField("", this, "changeWert");
			myLMBWert.setName("myLMBWert");
			myLMBWert.setBounds(125, 63, 80, 21);

			myLMRW = new NECheckBox("Mindestreichw.:", null);
			myLMRW.setName("myLMRW");
			myLMRW.setHorizontalTextPosition(javax.swing.SwingConstants.LEFT);
			myLMRW.setFont(new java.awt.Font("dialog", 0, 12));
			myLMRW.setBounds(10, 159, 110, 20);
			myLMRW.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);

			myLMRWWert = new NENumberTextField("", this, "changeWert");
			myLMRWWert.setName("myLMRWWert");
			myLMRWWert.setBounds(125, 159, 80, 21);

			myLRW = new NECheckBox("Reichweite:", null);
			myLRW.setName("myLRW");
			myLRW.setHorizontalTextPosition(javax.swing.SwingConstants.LEFT);
			myLRW.setFont(new java.awt.Font("dialog", 0, 12));
			myLRW.setBounds(10, 111, 110, 20);
			myLRW.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);

			myLRWWert = new NENumberTextField("", this, "changeWert");
			myLRWWert.setName("myLRWWert");
			myLRWWert.setBounds(125, 111, 80, 21);

			myLVP = new NECheckBox("Vorproduktion:", null);
			myLVP.setName("myLVP");
			myLVP.setHorizontalTextPosition(javax.swing.SwingConstants.LEFT);
			myLVP.setFont(new java.awt.Font("dialog", 0, 12));
			myLVP.setBounds(10, 87, 110, 20);
			myLVP.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);

			myLVPWert = new NENumberTextField("", this, "changeWert");
			myLVPWert.setName("myLVPWert");
			myLVPWert.setBounds(125, 87, 80, 21);

			myLRWSet = new NERadioButton("Reichweiten auf Wert setzen", this, null);
			myLRWSet.setName("myLRWSet");
			myLRWSet.setSelected(true);
			myLRWSet.setFont(new java.awt.Font("dialog", 0, 12));
			myLRWSet.setBounds(10, 190, 200, 20);

			myLRWAdd = new NERadioButton("Reichweiten um Wert verndern", this, null);
			myLRWAdd.setName("myLRWAdd");
			myLRWAdd.setFont(new java.awt.Font("dialog", 0, 12));
			myLRWAdd.setBounds(10, 210, 200, 20);

			ButtonGroup group = new ButtonGroup();
			group.add((JRadioButton)myLRWSet.getComponent());
			group.add((JRadioButton)myLRWAdd.getComponent());
			
			NEPanel myLPane = new NEPanel("Lager");
			myLPane.setName("myLPane");
			myLPane.setLayout(null);
			myLPane.setBounds(15, 290, 220, 240);
			myLPane.add(myLAB);
			myLPane.add(myLABWert);
			myLPane.add(myLHB);
			myLPane.add(myLHBWert);
			myLPane.add(myLMB);
			myLPane.add(myLMBWert);
			myLPane.add(myLVP);
			myLPane.add(myLVPWert);
			myLPane.add(myLRW);
			myLPane.add(myLRWWert);
			myLPane.add(myLHRWWert);
			myLPane.add(myLHRW);
			myLPane.add(myLMRWWert);
			myLPane.add(myLMRW);
			myLPane.add(myLRWSet);
			myLPane.add(myLRWAdd);

// ======================================================================================

			mySLAB = new NECheckBox("Anfangsbestand:", null);
			mySLAB.setName("mySLAB");
			mySLAB.setHorizontalTextPosition(javax.swing.SwingConstants.LEFT);
			mySLAB.setFont(new java.awt.Font("dialog", 0, 12));
			mySLAB.setBounds(10, 15, 110, 20);
			mySLAB.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);

			mySLABWert = new NENumberTextField("", this, "changeWert");
			mySLABWert.setName("mySLABWert");
			mySLABWert.setBounds(125, 15, 80, 21);

			mySLHB = new NECheckBox("Hchstbestand:", null);
			mySLHB.setName("mySLHB");
			mySLHB.setHorizontalTextPosition(javax.swing.SwingConstants.LEFT);
			mySLHB.setFont(new java.awt.Font("dialog", 0, 12));
			mySLHB.setBounds(10, 39, 110, 20);
			mySLHB.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);

			mySLHBWert = new NENumberTextField("", this, "changeWert");
			mySLHBWert.setName("mySLHBWert");
			mySLHBWert.setBounds(125, 39, 80, 21);

			mySLHRW = new NECheckBox("Hchstreichw.:", null);
			mySLHRW.setName("mySLHRW");
			mySLHRW.setHorizontalTextPosition(javax.swing.SwingConstants.LEFT);
			mySLHRW.setFont(new java.awt.Font("dialog", 0, 12));
			mySLHRW.setBounds(10, 135, 110, 20);
			mySLHRW.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);

			mySLHRWWert = new NENumberTextField("", this, "changeWert");
			mySLHRWWert.setName("mySLHRWWert");
			mySLHRWWert.setBounds(125, 135, 80, 21);
			
			mySLMB = new NECheckBox("Mindestbestand:", null);
			mySLMB.setName("mySLMB");
			mySLMB.setHorizontalTextPosition(javax.swing.SwingConstants.LEFT);
			mySLMB.setFont(new java.awt.Font("dialog", 0, 12));
			mySLMB.setBounds(10, 63, 110, 20);
			mySLMB.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);

			mySLMBWert = new NENumberTextField("", this, "changeWert");
			mySLMBWert.setName("mySLMBWert");
			mySLMBWert.setBounds(125, 63, 80, 21);

			mySLMRW = new NECheckBox("Mindestreichw.:", null);
			mySLMRW.setName("mySLMRW");
			mySLMRW.setHorizontalTextPosition(javax.swing.SwingConstants.LEFT);
			mySLMRW.setFont(new java.awt.Font("dialog", 0, 12));
			mySLMRW.setBounds(10, 159, 110, 20);
			mySLMRW.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);

			mySLMRWWert = new NENumberTextField("", this, "changeWert");
			mySLMRWWert.setName("mySLMRWWert");
			mySLMRWWert.setBounds(125, 159, 80, 21);

			mySLRW = new NECheckBox("Reichweite:", null);
			mySLRW.setName("mySLRW");
			mySLRW.setHorizontalTextPosition(javax.swing.SwingConstants.LEFT);
			mySLRW.setFont(new java.awt.Font("dialog", 0, 12));
			mySLRW.setBounds(10, 111, 110, 20);
			mySLRW.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);

			mySLRWWert = new NENumberTextField("", this, "changeWert");
			mySLRWWert.setName("mySLRWWert");
			mySLRWWert.setBounds(125, 111, 80, 21);

			mySLVP = new NECheckBox("Vorproduktion:", null);
			mySLVP.setName("mySLVP");
			mySLVP.setHorizontalTextPosition(javax.swing.SwingConstants.LEFT);
			mySLVP.setFont(new java.awt.Font("dialog", 0, 12));
			mySLVP.setBounds(10, 87, 110, 20);
			mySLVP.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);

			mySLVPWert = new NENumberTextField("", this, "changeWert");
			mySLVPWert.setName("mySLVPWert");
			mySLVPWert.setBounds(125, 87, 80, 21);

			mySLRWSet = new NERadioButton("Reichweiten auf Wert setzen", this, null);
			mySLRWSet.setName("mySLRWSet");
			mySLRWSet.setSelected(true);
			mySLRWSet.setFont(new java.awt.Font("dialog", 0, 12));
			mySLRWSet.setBounds(10, 190, 200, 20);

			mySLRWAdd = new NERadioButton("Reichweiten um Wert verndern", this, null);
			mySLRWAdd.setName("mySLRWAdd");
			mySLRWAdd.setFont(new java.awt.Font("dialog", 0, 12));
			mySLRWAdd.setBounds(10, 210, 200, 20);

			ButtonGroup group2 = new ButtonGroup();
			group2.add((JRadioButton)mySLRWSet.getComponent());
			group2.add((JRadioButton)mySLRWAdd.getComponent());

			NEPanel mySLPane = new NEPanel("Senkenlager (OEP)");
			mySLPane.setName("mySLPane");
			mySLPane.setLayout(null);
			mySLPane.setBounds(235, 290, 220, 240);
			mySLPane.add(mySLAB);
			mySLPane.add(mySLABWert);
			mySLPane.add(mySLHB);
			mySLPane.add(mySLHBWert);
			mySLPane.add(mySLMB);
			mySLPane.add(mySLMBWert);
			mySLPane.add(mySLVP);
			mySLPane.add(mySLVPWert);
			mySLPane.add(mySLRW);
			mySLPane.add(mySLRWWert);
			mySLPane.add(mySLHRWWert);
			mySLPane.add(mySLHRW);
			mySLPane.add(mySLMRWWert);
			mySLPane.add(mySLMRW);
			mySLPane.add(mySLRWSet);
			mySLPane.add(mySLRWAdd);

// ======================================================================================

			matBrowser = new NETableBrowser(null);
			matBrowser.setName("matBrowser");
			matBrowser.setBounds(15, 15, 350, 200);

			myOKButton = new NEButton("OK", this, "pariManipulation");
			myOKButton.setName("myOKButton");
			myOKButton.setBounds(355, 620, 100, 25);

			myAbbrButton = new NEButton("Abbrechen", this, "abbrechen");
			myAbbrButton.setName("myAbbrButton");
			myAbbrButton.setBounds(250, 620, 100, 25);

			mySelektion = new NECheckBox("alle Mat.!!", null);
			mySelektion.setName("mySelektion");
			mySelektion.setBounds(370, 149, 80, 20);

// ======================================================================================

			NEPanel JDialogContentPane = new NEPanel();
			JDialogContentPane.setName("JDialogContentPane");
			JDialogContentPane.setLayout(null);
			JDialogContentPane.add(LIconLabel);
			JDialogContentPane.add(beginnWoche);
			JDialogContentPane.add(matBrowser);
			JDialogContentPane.add(myWPZA);
			JDialogContentPane.add(myMPZA);
			JDialogContentPane.add(myOKButton);
			JDialogContentPane.add(myCommentLabel);
			JDialogContentPane.add(mySelektion);
			JDialogContentPane.add(myLPane);
			JDialogContentPane.add(mySLPane);
			JDialogContentPane.add(beginnMonat);
			JDialogContentPane.add(endeMonat);
			JDialogContentPane.add(endeWoche);
			JDialogContentPane.add(myBWLabel);
			JDialogContentPane.add(myBMLabel);
			JDialogContentPane.add(myEWLabel);
			JDialogContentPane.add(myEMLabel);
			JDialogContentPane.add(myEPane);
			JDialogContentPane.add(myPPane);
			JDialogContentPane.add(myAbbrButton);

			myPanel = new javax.swing.JDialog((JFrame)null, true);
			myPanel.setName("myPanel");
			myPanel.setDefaultCloseOperation(javax.swing.JDialog.DO_NOTHING_ON_CLOSE);
			myPanel.setBounds(250, 10, 470+wp, 670+hp);
			myPanel.setTitle("Parametermanipulation Materialfluss");
			myPanel.setContentPane(JDialogContentPane.getComponent());
	
	return;	
}
public void handleEvent(NEDialogElement ctrl, java.util.EventObject ev) {

	JOptionPane.showMessageDialog(null, "Funktion ist noch nicht implementiert");


}
private void init()
{  
	beginnWeek = 0;
	endeWeek = currentMaxWeek;
	beginnMonth = maxWeek;
	endeMonth = currentMaxPZA;
	beginnWoche.setIntValue(beginnWeek+1);
	endeWoche.setIntValue(endeWeek);
	beginnMonat.setIntValue(beginnMonth+1);
	endeMonat.setIntValue(endeMonth);

	hbl = hbsl = hrwl = hrwsl = -1;
	myLHBWert.setStringValue("unendl.");
	mySLHBWert.setStringValue("unendl.");
	myLHRWWert.setStringValue("unendl.");
	mySLHRWWert.setStringValue("unendl.");
	
	
	mrwl = mrwsl = mbl = mbsl = abl = absl = vpl = vpsl = pzl = pzsl = mme = mmh = 0.0;

	myLABWert.setDoubleValue(abl);
	myLMBWert.setDoubleValue(mbl);
	myLVPWert.setDoubleValue(vpl);
	myLRWWert.setDoubleValue(pzl);
	myLMRWWert.setDoubleValue(mrwl);

	mySLABWert.setDoubleValue(absl);
	mySLMBWert.setDoubleValue(mbsl);
	mySLVPWert.setDoubleValue(vpsl);
	mySLRWWert.setDoubleValue(pzsl);
	mySLMRWWert.setDoubleValue(mrwsl);

	myEMMWert.setDoubleValue(mme);
	myPMMWert.setDoubleValue(mmh);
	return;
}
public void loadBrowser()
{
	int row;
	int max = myUModell.matcount();
		
	if(!matBrowser.isDisplayed()) {
			
		matBrowser.setTable(max, 3, true, false);
		matBrowser.setColumnTitle("MatSchl", 0);
		matBrowser.setColumnTitle("Bezeichnung", 1);
		matBrowser.setColumnTitle("Typ", 2);
			
	} else {

		matBrowser.updateTableModelRows(max);

	}

	Material mat;
	String smattyp;
	int mattyp;
		
	for(row = 0; row < max; row++) {
		mat = myUModell.getMatByIndex(row);
		smattyp = "";
		mattyp = mat.typ();
		if((mattyp & 8) > 0) { smattyp = smattyp + "V"; }
		if((mattyp & 4) > 0) { smattyp = smattyp + "L"; }
		if((mattyp & 2) > 0) { smattyp = smattyp + "P"; }
		if((mattyp & 1) > 0) { smattyp = smattyp + "E"; }
		
		matBrowser.setValueAt(mat.matschl(), row, 0);
		matBrowser.setValueAt(mat.matbez(), row, 1);
		matBrowser.setValueAt(smattyp, row, 2);
	
	}
	matBrowser.setSelectionMode(ListSelectionModel.MULTIPLE_INTERVAL_SELECTION);
	matBrowser.display();
	return;
}
public void openWindow(NEDialogElement sender)
{
	int index;
	int a;

	if(myPanel != null) {
		if(myPanel.isVisible()) { return; }
	}

	if(myUModell != null) {
		
		if(myPanel == null) {	
			this.createPanel();
		
			this.loadBrowser();
			this.init();
		}
		
		myPanel.setVisible(true);
		
	} else {
		JOptionPane.showMessageDialog(null, "Kein Modell aktiv!");
	}

	return;
}
/**
 * Action-Methode fr die Parametermanipulation.
 *
 * Das ist ein Programmierbeispiel fuer den
 * nicht-interaktiven Dialog mit dem UModell!
 * Die Werte werden ueber NEParameter gesetzt und
 * zum Abschluss myUModell.computeMod(); aufgerufen.
 * 
 *
 * @param sender NEDialogElement
 */
public void pariManipulation(NEDialogElement sender)
{
	int a, b, f, matcount, ecount;
	Material mat;
	ProduktionsElement pe;
	PParameter pp;
	EinkaufsElement ee;
	EParameter ep;
	LagerElement le;
	LParameter lp;
	
	HBL = myLHB.isSelected();
	HBSL = mySLHB.isSelected();
	MBL = myLMB.isSelected();
	MBSL = mySLMB.isSelected();
	ABL = myLAB.isSelected();
	ABSL = mySLAB.isSelected();
	VPL = myLVP.isSelected();
	VPSL = mySLVP.isSelected();
	PZL = myLRW.isSelected();
	ADDPZL = myLRWAdd.isSelected(); 
	PZSL = mySLRW.isSelected();
	ADDPZSL = mySLRWAdd.isSelected();
	HRWL = myLHRW.isSelected();
	HRWSL = mySLHRW.isSelected();
	MRWL = myLMRW.isSelected();
	MRWSL = mySLMRW.isSelected();
	
	WOCHE = myWPZA.isSelected();
	MONAT = myMPZA.isSelected();
	MMH = myPMM.isSelected();
	MME = myEMM.isSelected();
	ALLMAT = mySelektion.isSelected();

	if(WOCHE || MONAT) {
		if(WOCHE && MONAT) {
			System.out.println(" ==> Parametermanipulation Woche:" + beginnWeek + " bis "
			+ (endeWeek-1) + " und Monat:" + beginnMonth + " bis " + (endeMonth-1));
		} else {
			if(MONAT) {
				System.out.println(" ==> Parametermanipulation Monat:" + beginnMonth + " bis " + (endeMonth-1));
			}
			if(WOCHE) {
				System.out.println(" ==> Parametermanipulation Woche:" + beginnWeek + " bis " + (endeWeek-1));
			}
		}
	} else {
		myPanel.setVisible(false);
	}
	if(ALLMAT) { System.out.println("\t=> Alle Materialien!"); }
	else { System.out.println("\t=> Ausgewaehlte Materialien!"); }
	if(MMH) { System.out.println("\t\t=> PE MM = " + mmh); }
	if(MME) { System.out.println("\t\t=> EE MM = " + mme); }
	if(MBL) { System.out.println("\t\t=> LE MB = " + mbl); }
	if(HBL) { System.out.println("\t\t=> LE HB = " + hbl); }
	if(VPL) { System.out.println("\t\t=> LE VP = " + vpl); }
	if(ADDPZL) {
		if(HRWL) { System.out.println("\t\t=> LE HR + " + hrwl); }
		if(MRWL) { System.out.println("\t\t=> LE MR + " + mrwl); }
		if(PZL) { System.out.println("\t\t=> LE RW + " + pzl); }
	} else {
		if(HRWL) { System.out.println("\t\t=> LE HR = " + hrwl); }
		if(MRWL) { System.out.println("\t\t=> LE MR = " + mrwl); }
		if(PZL) { System.out.println("\t\t=> LE RW = " + pzl); }
	}
	if(ABL) { System.out.println("\t\t=> LE AB = " + abl); }
	if(MBSL) { System.out.println("\t\t=> SE MB = " + mbsl); }
	if(HBSL) { System.out.println("\t\t=> SE HB = " + hbsl); }
	if(VPSL) { System.out.println("\t\t=> SE VP = " + vpsl); }
	if(ADDPZSL) {
		if(HRWSL) { System.out.println("\t\t=> SE HR + " + hrwsl); }
		if(MRWSL) { System.out.println("\t\t=> SE MR + " + mrwsl); }
		if(PZSL) { System.out.println("\t\t=> SE RW + " + pzsl); }
	} else {
		if(HRWSL) { System.out.println("\t\t=> SE HR = " + hrwsl); }
		if(MRWSL) { System.out.println("\t\t=> SE MR = " + mrwsl); }
		if(PZSL) { System.out.println("\t\t=> SE RW = " + pzsl); }
	}
	if(ABSL) { System.out.println("\t\t=> SE AB = " + absl); }
/*
	Object[] opt = {"Ja", "Nein"};
	int n = JOptionPane.showOptionDialog(null, 
			"Werte zur Parametermanipulation in Ordnung?", "Frage??", JOptionPane.YES_NO_OPTION,
	JOptionPane.QUESTION_MESSAGE, null, opt, opt[1]);
	if(n != 0) {
		myPanel.setVisible(false);
		return;
	}
*/
	matcount = myUModell.matcount(); 

	for(a = 0; a < matcount; a++) {
		if(!ALLMAT) {
			if(!matBrowser.isRowSelected(a)) {
				continue;
			}
		}
		mat = myUModell.getMatByIndex(a);
		if(!ALLMAT) { System.out.println("\t=> Mat: " + mat.matschl()); }
		if(MME && (mat.eecount() > 0)) {
			ee = mat.einkaufselement(0);
			if(WOCHE) {
				for(b = beginnWeek; b < endeWeek; b++) {
					ep = (EParameter) ee.parameter(b);
					ep.setMinmeng(mme);
				}
			}
			if(MONAT) {
				for(b = beginnMonth; b < endeMonth; b++) {
					ep = (EParameter) ee.parameter(b);
					ep.setMinmeng(mme);
				}
			}
		}
		ecount = mat.pecount();
		if(MMH && (ecount > 0)) {
			for(f = 0; f < ecount; f++) {
				pe = mat.produktionselement(f);
				if(WOCHE) {
					for(b = beginnWeek; b < endeWeek; b++) {
						pp = (PParameter) pe.parameter(b);
						pp.setMinmeng(mmh);
					}
				}
				if(MONAT) {
					for(b = beginnMonth; b < endeMonth; b++) {
						pp = (PParameter) pe.parameter(b);
						pp.setMinmeng(mmh);
					}
				}
			}
		}
		ecount = mat.lecount();
		if((PZSL || VPSL || MBSL || HBSL || MRWSL || HRWSL) && (ecount > 0)) {
			for(f = 0; f < ecount; f++) {
				le = mat.lagerelement(f);
				if(le.getOE().oetyp() != 2) { continue; }
				if(WOCHE) {
					for(b = beginnWeek; b < endeWeek; b++) {
						lp = (LParameter) le.parameter(b);
						if(ADDPZSL) {
							if(PZSL) {
								lp.setReichw(le.reichw(b)+pzsl);
							}
							if(MRWSL) {
								lp.setMreichw(le.mreichw(b)+mrwsl);
							}
							if(HRWSL) {
								if((hrwsl >= 0) && (le.hreichw(b) >= 0)) {
									lp.setHreichw(le.hreichw(b)+hrwsl);
								} else {
									lp.setHreichw(-1);
								}
							}
						} else {
							if(PZSL) {
								lp.setReichw(pzsl);
							}
							if(MRWSL) {
								lp.setMreichw(mrwsl);
							}
							if(HRWSL) { 
								if(hrwsl >= 0) {
									lp.setHreichw(hrwsl);
								} else {
									lp.setHreichw(-1);
								}
							}
						}
						if(HBSL) {
							if(hbsl >= 0) {
								lp.setMaxbest(hbsl);
							} else {
								lp.setMaxbest(-1);
							}
						}
						if(MBSL) {
							lp.setMinbest(mbsl);
						}
						if(VPSL) {
							lp.setVorprod(vpsl);
						}
						if(ABSL && (b == 0)) {
							lp.setAnfbest(absl);
						}
					}
				}
				if(MONAT) {
					for(b = beginnMonth; b < endeMonth; b++) {	
						lp = (LParameter) le.parameter(b);
						if(ADDPZSL) {
							if(PZSL) {
								lp.setReichw(le.reichw(b)+pzsl);
							}
							if(MRWSL) {
								lp.setMreichw(le.mreichw(b)+mrwsl);
							}
							if(HRWSL) {
								if((hrwsl >= 0) && (le.hreichw(b) >= 0)) {
									lp.setHreichw(le.hreichw(b)+hrwsl);
								} else {
									lp.setHreichw(-1);
								}
							}
						} else {
							if(PZSL) {
								lp.setReichw(pzsl);
							}
							if(MRWSL) {
								lp.setMreichw(mrwsl);
							}
							if(HRWSL) { 
								if(hrwsl >= 0) {
									lp.setHreichw(hrwsl);
								} else {
									lp.setHreichw(-1);
								}
							}
						}
						if(HBSL) {
							if(hbsl >= 0) {
								lp.setMaxbest(hbsl);
							} else {
								lp.setMaxbest(-1);
							}
						}
						if(MBSL) {
							lp.setMinbest(mbsl);
						}
						if(VPSL) {
							lp.setVorprod(vpsl);
						}
						if(ABSL && (b == maxWeek)) {
							lp.setAnfbest(absl);
						}
					}
				}
			}
		}
		ecount = mat.lecount();
		if((PZL || VPL || MBL || HBL || MRWL || HRWL) && (ecount > 0)) {
			for(f = 0; f < ecount; f++) {
				le = mat.lagerelement(f);
				if(le.getOE().oetyp() != 1) { continue; }
				if(WOCHE) {
					for(b = beginnWeek; b < endeWeek; b++) {
						lp = (LParameter) le.parameter(b);
						if(ADDPZL) {
							if(PZL) {
								lp.setReichw(le.reichw(b)+pzl);
							}
							if(MRWL) {
								lp.setMreichw(le.mreichw(b)+mrwl);
							}
							if(HRWL) {
								if((hrwl >= 0) && (le.hreichw(b) >= 0)) {
									lp.setHreichw(le.hreichw(b)+hrwl);
								} else {
									lp.setHreichw(-1);
								}
							}
						} else {
							if(PZL) {
								lp.setReichw(pzl);
							}
							if(MRWL) {
								lp.setMreichw(mrwl);
							}
							if(HRWL) { 
								if(hrwl >= 0) {
									lp.setHreichw(hrwl);
								} else {
									lp.setHreichw(-1);
								}
							}
						}
						if(HBL) {
							if(hbl >= 0) {
								lp.setMaxbest(hbl);
							} else {
								lp.setMaxbest(-1);
							}
						}
						if(MBL) {
							lp.setMinbest(mbl);
						}
						if(VPL) {
							lp.setVorprod(vpl);
						}
						if(ABL && (b == 0)) {
							lp.setAnfbest(abl);
						}
					}
				}
				if(MONAT) {
					for(b = beginnMonth; b < endeMonth; b++) {
						lp = (LParameter) le.parameter(b);
						if(ADDPZL) {
							if(PZL) {
								lp.setReichw(le.reichw(b)+pzl);
							}
							if(MRWL) {
								lp.setMreichw(le.mreichw(b)+mrwl);
							}
							if(HRWL) {
								if((hrwl >= 0) && (le.hreichw(b) >= 0)) {
									lp.setHreichw(le.hreichw(b)+hrwl);
								} else {
									lp.setHreichw(-1);
								}
							}
						} else {
							if(PZL) {
								lp.setReichw(pzl);
							}
							if(MRWL) {
								lp.setMreichw(mrwl);
							}
							if(HRWL) { 
								if(hrwl >= 0) {
									lp.setHreichw(hrwl);
								} else {
									lp.setHreichw(-1);
								}
							}
						}
						if(HBL) {
							if(hbl >= 0) {
								lp.setMaxbest(hbl);
							} else {
								lp.setMaxbest(-1);
							}
						}
						if(MBL) {
							lp.setMinbest(mbl);
						}
						if(VPL) {
							lp.setVorprod(vpl);
						}
						if(ABL && (b == maxWeek)) {
							lp.setAnfbest(abl);
						}
					}
				}
			}
		}
	}
	myUModell.computeMod();
	mainController.update(false);
	myPanel.setVisible(false);
	
	return;
}
}
