package com.nerthus.proisys.bundles;

import java.util.*;
import javax.swing.*;
import java.text.NumberFormat;
import java.text.ParseException;
import com.nerthus.proisys.pps.kernel.*;
import com.nerthus.appkit.*;
import com.nerthus.proisys.pps.*;
/**
 * Quellenanteil-Dialog (QA).
 * 
 * @author: R.Bohlig
 */
public class QADialog extends com.nerthus.proisys.pps.NEController 
implements NEDialogDelegate, QAController {
	
	static int hp = 30;
	static int wp = 5;
	
	private Material myMat;

	private JDialog myQAPanel;
	private NETableBrowser myQBrowser;
	private NEScrollBar myQPZASlider;
	private NENumberTextField myQrPZA;
	private NETextField myQPZABez;
	private NENumberTextField myQA;
	private NENumberTextField mySummeQA;
	private NEButton myOKButton;
	private NEButton myAbbrButton;

	private NECheckBox myOptAllPZA;

	private JLabel myQMatBez;

	/* ========= current objects and parameters ============== */

	private NEElement currentQuelle;
	private int matidx;
	private int currentQ;
	private int currentQPZA;
	private double SummeQA;
	private double[] QA = new double[100];
	private Vector Quellen;	
	private boolean QAChanged;

	private int zcount;

	private NumberFormat numFormatter = NumberFormat.getNumberInstance();

/**
 * QAController constructor.
 *
 * @param resfile java.lang.String
 */
public QADialog(String resfile) {
	super(resfile);
}
/**
 * QAController constructor.
 *
 * @param resfile java.lang.String
 * @param mc com.nerthus.proisys.pps.NEMainController
 */
public QADialog(String resfile, com.nerthus.proisys.pps.NEMainController mc) {
	super(resfile, mc);
}
public void abbrechen(NEDialogElement sender)
{
 /*   [NSApp stopModal];
	[Quellen release];
	[myAuswahl setState:0];
	[myQAPanel close];
 //   [mainController update:NO];
 */
}
public void aktualisiereQ()
{
	if(currentQPZA >= maxWeek) {
		myQPZASlider.setMinMaxValue(maxWeek, currentMaxPZA);
	} else {
		myQPZASlider.setMinMaxValue(1, currentMaxWeek);
	}
	myQPZASlider.setIntValue(currentQPZA + 1);
	myQrPZA.setIntValue(currentQPZA + 1);
	myQPZABez.setStringValue(myKalender.pzabez(currentQPZA));
}
public void browserClick(NEDialogElement sender)
{
	int index = myQBrowser.selectedRow();

	if (index == currentQ) return;
	currentQ = index;
	myQA.setDoubleValue(QA[currentQ]*100);
}
public void changePZASlider(NEDialogElement sender)
{
	int b;
//    id theMatrix = [QBrowser matrixInColumn:0];
	if(SummeQA != 100) {
		myQrPZA.setIntValue(currentQPZA + 1);
		myQPZABez.setStringValue(myKalender.pzabez(currentQPZA));
		myQPZASlider.setIntValue(currentQPZA + 1);
		return;
	}
	if(QAChanged) {
		this.updateQA();
	}
	currentQPZA = myQPZASlider.intValue() - 1;
	myQPZABez.setStringValue(myKalender.pzabez(currentQPZA));
	myQrPZA.setIntValue(currentQPZA + 1);
	SummeQA = 0;
	this.computeSumme();
	QAChanged = NO;
	myQA.setDoubleValue(QA[currentQ]*100);
	this.loadBrowser();
	myQBrowser.selectRows(currentQ, currentQ);
}
public void changerPZA(NEDialogElement sender)
{
	int a, b;
//    id theMatrix = [QBrowser matrixInColumn:0];
	a = myQrPZA.intValue() - 1;
	if(a == currentQPZA) {
		return;
	}
	if(SummeQA != 1) {
		myQrPZA.setIntValue(currentQPZA + 1);
		return;
	}
	if(QAChanged) {
		this.updateQA();
	}
	if(currentQPZA >= maxWeek) {
		if((a >= currentMaxPZA)||(a<maxWeek)) {
			myQrPZA.setIntValue(currentQPZA + 1);
			return;
		}
	}
	else {
		if((a >= maxWeek)||(a<0)) {
			myQrPZA.setIntValue(currentQPZA + 1);
			return;
		}
	}
	myQPZABez.setStringValue(myKalender.pzabez(currentQPZA));
	myQPZASlider.setIntValue(currentQPZA + 1);
	SummeQA = 0;
	this.computeSumme();
	QAChanged = NO;
	myQA.setDoubleValue(QA[currentQ]*100);
	this.loadBrowser();
	myQBrowser.selectRows(currentQ, currentQ);
}
/**
 * Insert the method's description here.
 * Creation date: (28.12.00 00:32:27)
 */
private void computeSumme() {
	int b;
	NEElement tmp;
	ProduktionsElement pe;
	EinkaufsElement ee;
	for(b = 0; b < zcount; b++) {
		tmp = myMat.quelle(b);
		if(tmp instanceof ProduktionsElement) {
			pe = (ProduktionsElement) tmp;
			QA[b] = pe.quantl(currentQPZA);
		} else {
			ee = (EinkaufsElement) tmp;
			QA[b] = ee.quantl(currentQPZA);
		}
		SummeQA += QA[b];
	}	
	mySummeQA.setDoubleValue((SummeQA*100));	
}
private void createQAPanel() {

			javax.swing.JLabel LIconLabel = new javax.swing.JLabel();
			LIconLabel.setName("LIconLabel");
			LIconLabel.setIcon(new javax.swing.ImageIcon(getClass().getResource("/dia.gif")));
			LIconLabel.setText("");
			LIconLabel.setBounds(420, 20, 25, 35);

			javax.swing.JLabel myLabelQMat = new javax.swing.JLabel();
			myLabelQMat.setName("myLabelQMat");
			myLabelQMat.setFont(new java.awt.Font("dialog.bold", 1, 12));
			myLabelQMat.setText("Quellenmaterial:");
			myLabelQMat.setBounds(15, 15, 95, 17);
			myLabelQMat.setForeground(java.awt.Color.black);
			myLabelQMat.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
			
			javax.swing.JLabel myLabelQA = new javax.swing.JLabel();
			myLabelQA.setName("myLabelQA");
			myLabelQA.setFont(new java.awt.Font("dialog", 0, 12));
			myLabelQA.setText("Quellenanteil:");
			myLabelQA.setBounds(15, 231, 135, 17);
			myLabelQA.setForeground(java.awt.Color.black);
			myLabelQA.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);

			javax.swing.JLabel myLabelSumQA = new javax.swing.JLabel();
			myLabelSumQA.setName("myLabelSumQA");
			myLabelSumQA.setFont(new java.awt.Font("dialog", 0, 12));
			myLabelSumQA.setText("Summe Quellenanteile:");
			myLabelSumQA.setBounds(15, 255, 135, 17);
			myLabelSumQA.setForeground(java.awt.Color.black);
			myLabelSumQA.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);

			javax.swing.JLabel myVLabelPZA = new javax.swing.JLabel();
			myVLabelPZA.setName("myVLabelPZA");
			myVLabelPZA.setFont(new java.awt.Font("dialog.bold", 1, 12));
			myVLabelPZA.setText("Planungszeitabschnitt");
			myVLabelPZA.setBounds(85, 170, 178, 17);
			myVLabelPZA.setForeground(java.awt.Color.black);
			myVLabelPZA.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);

// ======================================================================================
					
			myQPZABez = new NETextField("", null);
			myQPZABez.setName("myQPZABez");
			myQPZABez.setBounds(15, 190, 80, 21);
			myQPZABez.setEditable(false);

			myQrPZA = new NENumberTextField("", this, "changerPZA");
			myQrPZA.setName("myVrPZA");
			myQrPZA.setBounds(100, 190, 25, 21);
			myQrPZA.setIntegerFormat(false);

			myQPZASlider = new NEScrollBar(this, "changePZASlider");
			myQPZASlider.setName("myVPZASlider");	
			myQPZASlider.setBounds(135, 192, 215, 17);
			myQPZASlider.setOrientation(javax.swing.JScrollBar.HORIZONTAL);

// ======================================================================================

			myQMatBez = new javax.swing.JLabel();
			myQMatBez.setName("myQMatBez");
			myQMatBez.setFont(new java.awt.Font("dialog.bold", 1, 12));
			myQMatBez.setText("");
			myQMatBez.setBounds(115, 15, 250, 17);
			myQMatBez.setForeground(java.awt.Color.black);
			myQMatBez.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);

			myOptAllPZA = new NECheckBox("alle PZA", null, null);
			myOptAllPZA.setName("myOptAllPZA");
			myOptAllPZA.setBounds(380, 105, 70, 20);
			myOptAllPZA.setSelected(false);
			
// ======================================================================================

			mySummeQA = new NENumberTextField("", null, null);
			mySummeQA.setName("mySummeQA");
			mySummeQA.setBounds(155, 254, 60, 21);
			mySummeQA.setEditable(false);

			myQA = new NENumberTextField("", this, "setQA");
			myQA.setName("myQA");
			myQA.setBounds(155, 230, 60, 21);

// ======================================================================================

			myQBrowser = new NETableBrowser(this, "browserClick", null);
			myQBrowser.setName("myQBrowser");
			myQBrowser.setBounds(15, 35, 350, 130);	

			myOKButton = new NEButton("OK", this, "uebernahme");
			myOKButton.setName("myOKButton");
			myOKButton.setBounds(345, 245, 100, 25);

			myAbbrButton = new NEButton("Abbrechen", this, "uebernahme");
			myAbbrButton.setName("myAbbrButton");
			myAbbrButton.setBounds(245, 245, 100, 25);

// ======================================================================================

			javax.swing.JSeparator QSeparator1 = new javax.swing.JSeparator();
			QSeparator1.setName("QSeparator1");
			QSeparator1.setBounds(15, 220, 430, 2);
			
			javax.swing.JSeparator QSeparator2 = new javax.swing.JSeparator();
			QSeparator2.setName("QSeparator2");
			QSeparator2.setBounds(230, 220, 2, 65);
			QSeparator2.setOrientation(javax.swing.SwingConstants.VERTICAL);
			
			javax.swing.JSeparator QSeparator3 = new javax.swing.JSeparator();
			QSeparator3.setName("QSeparator3");
			QSeparator3.setBounds(15, 285, 430, 2);


			NEPanel JDialogContentPane = new NEPanel();
			JDialogContentPane.setName("QAContentPane");
			JDialogContentPane.setLayout(null);
			JDialogContentPane.add(myQPZABez);
			JDialogContentPane.add(myQPZASlider);
			JDialogContentPane.add(LIconLabel);
			JDialogContentPane.add(myQrPZA);
			JDialogContentPane.add(myQBrowser);
			JDialogContentPane.add(myOptAllPZA);
			JDialogContentPane.add(myAbbrButton);
			JDialogContentPane.add(myQA);
			JDialogContentPane.add(mySummeQA);
			JDialogContentPane.add(QSeparator1);
			JDialogContentPane.add(myVLabelPZA);
			JDialogContentPane.add(myLabelSumQA);
			JDialogContentPane.add(myLabelQA);
			JDialogContentPane.add(myLabelQMat);
			JDialogContentPane.add(myQMatBez);
			JDialogContentPane.add(QSeparator3);
			JDialogContentPane.add(QSeparator2);
			JDialogContentPane.add(myOKButton);

			myQAPanel = new javax.swing.JDialog((JFrame)null, true);
			myQAPanel.setName("myQAPanel");
			myQAPanel.setDefaultCloseOperation(javax.swing.JDialog.DO_NOTHING_ON_CLOSE);
			myQAPanel.setBounds(525, 10, 460+wp, 300+hp);
			myQAPanel.setTitle("Dialog Quellenanteile");
			myQAPanel.setContentPane(JDialogContentPane.getComponent());
	
	return;	
}
public int getEidx(int qidx)
{
	//	return zeiger[qidx].Eidx;
	return 0;
}
public double getQA(int qidx)
{
	return QA[qidx];
}
public int getQcounter()
{
	return zcount;
}
public NEElement getQid(int qidx)
{
	return (NEElement) Quellen.elementAt(qidx);
}
public void handleEvent(NEDialogElement ctrl, java.util.EventObject ev) {

	JOptionPane.showMessageDialog(null, "Funktion ist noch nicht implementiert");


}
public void loadBrowser()
{
	int row;

	int max = myMat.sourcecount();
		
	if(!myQBrowser.isDisplayed()) {
			
		myQBrowser.setTable(max, 3, true, false);
		myQBrowser.setColumnTitle("QOESchl", 0);
		myQBrowser.setColumnTitle("Bezeichnung", 1);
		myQBrowser.setColumnTitle("QA (%)", 2);
			
	} else {

		myQBrowser.updateTableModelRows(max);

	}

	OrganisationsEinheit oe;
	NEElement tmp;
	ProduktionsElement pe;
	EinkaufsElement ee;
		
	for(row = 0; row < max; row++) {
		tmp = (NEElement) myMat.quelle(row);
		oe = tmp.getOE();	
		myQBrowser.setValueAt(oe.oeschl(), row, 0);
		myQBrowser.setValueAt(oe.bezeichnung(), row, 1);

		myQBrowser.setValueAt(new Integer((int)(QA[row] * 100)), row, 2);
	
	}
	myQBrowser.display();
	return;
}
public void openQAPanel(double qavalue, int rPZA, NEElement sender)
{
	int b;
	
	ProduktionsElement pe = null;
	EinkaufsElement ee = null;
	NEElement tmp;
	currentQuelle = sender;
	myMat = sender.getMat();
	zcount = myMat.sourcecount();
	currentQPZA = rPZA;
	QAChanged = YES;
	SummeQA = 0;
	Quellen = myMat.Quellen();

	if(myMat == null) {
		System.out.println("QAController - Kein Material!\n\n");
	}
	if(Quellen == null) {
		System.out.println("QAController - Keine Quellen!\n\n");
	}
	if(myUModell == null) {
		System.out.println("QAController - Kein Modell!\n\n");
	}
	if(myKalender == null) {
		System.out.println("QAController - Kein Kalender!\n\n");
	}
	for(b = 0; b < zcount; b++) {
		tmp = myMat.quelle(b);
		if(tmp instanceof ProduktionsElement) {
			pe = (ProduktionsElement) tmp;
		} else {
			ee = (EinkaufsElement) tmp;
		}
		if(tmp == sender) {
			currentQ = b;
			QA[b] = qavalue;
		} else {
			if(tmp instanceof ProduktionsElement) {
				QA[b] = pe.quantl(currentQPZA);
			} else {
				QA[b] = ee.quantl(currentQPZA);
			}
		}
		SummeQA += QA[b];
	}
	if(myQAPanel == null) {
		this.createQAPanel();
	}
	
	this.aktualisiereQ();
	myQMatBez.setText(myMat.matschl() + " " + myMat.matbez());
	myQA.setDoubleValue(qavalue*100);		
	mySummeQA.setDoubleValue((SummeQA*100));
	this.loadBrowser();
	myQBrowser.selectRows(currentQ, currentQ);
	
	myQAPanel.setVisible(true);
	
	return;
}
public void setQA(NEDialogElement sender)
{
	double x = myQA.doubleValue() / 100;
	if((x == QA[currentQ]) || (x < 0) || (x > 1)) {
		myQA.setDoubleValue(QA[currentQ]*100);
		return;
	}
	QAChanged = YES;
	SummeQA += (x-QA[currentQ]);
	QA[currentQ] = x;
	mySummeQA.setDoubleValue(SummeQA*100);
	this.loadBrowser();
	myQBrowser.selectRows(currentQ, currentQ);

}
public void uebernahme(NEDialogElement sender)
{	
	int a, b;

	NEElement tmp;
	ProduktionsElement pe;
	EinkaufsElement ee;
	
	if(sender == myOKButton) {
		if(SummeQA != 1) { return; }
		if(!myOptAllPZA.isSelected()) {
			this.updateQA();
		} else {
			for(a = 0; a < zcount; a++) {
				tmp = myMat.quelle(a);		
				if(currentQPZA >= maxWeek) {
					if(tmp instanceof ProduktionsElement) {
						pe = (ProduktionsElement) tmp;	
						for(b = maxWeek; b < currentMaxPZA; b++) {
							pe.setQuantl(QA[a], b);
						}
					} else {
						ee = (EinkaufsElement) tmp;
						for(b = maxWeek; b < currentMaxPZA; b++) {
							ee.setQuantl(QA[a], b);
						}
					}
				} else {
					if(tmp instanceof ProduktionsElement) {
						pe = (ProduktionsElement) tmp;	
						for(b = 0; b < currentMaxWeek; b++) {
							pe.setQuantl(QA[a], b);
						}
					} else {
						ee = (EinkaufsElement) tmp;
						for(b = 0; b < currentMaxWeek; b++) {
							ee.setQuantl(QA[a], b);
						}
					}
				}
			}
			currentQuelle.activateCustomers();
		}
		mainController.update(false);
	}
//	[NSApp stopModal];
	
	myOptAllPZA.setSelected(false);
	myQAPanel.setVisible(false);

}
public void updateQA()
{
	NEElement tmp;
	ProduktionsElement pe;
	EinkaufsElement ee;	
	int e;
	for(e = 0; e < zcount; e++) {
		tmp = myMat.quelle(e);
		if(tmp instanceof ProduktionsElement) {
			pe = (ProduktionsElement) tmp;	
			pe.setQuantl(QA[e], currentQPZA);
		} else {
			ee = (EinkaufsElement) tmp;
			ee.setQuantl(QA[e], currentQPZA);
		}
	}
	currentQuelle.activateCustomers();

	return;
}
public void wechselPZABasis(NEDialogElement sender)
{	
	this.aktualisiereQ();
}
}
