/*
 * XMLExport.java
 *
 * Created on 9. Juni 2001, 13:05
 */

package com.nerthus.proisys.bundles;

import java.io.*;
import javax.swing.*;
import java.text.NumberFormat;

import org.jdom.*;
import org.jdom.output.XMLOutputter;

import com.nerthus.proisys.pps.kernel.*;
import com.nerthus.proisys.pps.*;
import com.nerthus.appkit.*;

/**
 *
 * @author  rbohlig
 * @version 
 */
public class XMLExport extends com.nerthus.proisys.pps.NEController  {
    
    /** Default DOM Adapter class to use */
    private static final String DEFAULT_DOM_ADAPTER_CLASS =
        "org.jdom.adapters.XercesDOMAdapter";

    /** DOM Adapter Class to use */
    private String domAdapterClass;

    /** <code>{@link DOMBuilder}</code> instance to use */
   // private DOMBuilder builder;

    public XMLExport(String resfile) {
	super(resfile);

    }
    public XMLExport(String resfile, NEMainController mc) {
	super(resfile, mc);

    }
    public void openWindow(NEDialogElement sender) {
        
        if(myUModell == null) {
            JOptionPane.showMessageDialog(null, "Kein Modell aktiv!");
	}
        
        int a, b, d, e, i, oecount, pecount, lecount, eecount, vecount, apcount, slecount;
        int matcount;
        OrganisationsEinheit oe;
        Material mat;
        EinkaufsElement ee;
        ProduktionsElement pe;
        LagerElement le;
        VerkaufsElement ve;
        SLElement sle;
        com.nerthus.proisys.pps.kernel.Arbeitsplan ap;
        String str;
        
        NumberFormat numFormatter = NumberFormat.getNumberInstance();
        
        Element xmloe, xmlmat, xmlpe, xmlee, xmlle, xmlve, xmlap, xmlsl;
        Element xmlsle, xmlsort, xmlprod, xmlpza, xmlvbk, xmlsch, xmlmat1, alo;
        
        Element root = new Element(strings.getProperty("document"));
        Document doc = new Document(root);
        Element abo = new Element("Aubauorganisation");
        root.addContent(abo);
        oecount = myUModell.oecount();
        for(a = 0; a < oecount; a++) {
            oe = myUModell.getOEByIndex(a);
        //    xmloe = new Element(oe.oeschl().trim());
            xmloe = new Element("Organisationseinheit");
            xmloe.addAttribute("oeschl", oe.oeschl());
            xmloe.addAttribute("oebez", oe.bezeichnung());
            switch(oe.oetyp()) {
                case 0:
                    xmloe.addAttribute("type", "Einkauf");
                    break;
                case 1:
                    xmloe.addAttribute("type", "Lager");
                    break;
                case 2:
                    xmloe.addAttribute("type", "Produktion");
                    break;
                case 3:
                    xmloe.addAttribute("type", "Verkauf");
                    break;
            }        
            str = "" + oe.oe_id();
            xmloe.addAttribute("db_id", str);
            str = "" + a;
            xmloe.addAttribute("index", str);
                      
            numFormatter.setMinimumFractionDigits(4);
            numFormatter.setMaximumFractionDigits(4);
            
            switch(oe.oetyp()) {
                case 2:
            
                    xmlsort = new Element("Sortiment");
                    pecount = oe.pecount();
                    for(e = 0; e < pecount; e++) {
                        pe = oe.produktionselement(e);
                        // xmlpe = new Element(pe.articleno().trim());
                        xmlpe = new Element("Erzeugnis");
                        xmlpe.addAttribute("matschl", pe.articleno());
                        xmlpe.addAttribute("matbez", pe.articlename());
                        xmlpe.addAttribute("meschl", pe.unit());
                        str = "" + pe.article_id();
                        xmlpe.addAttribute("db_id", str);
                        str = "" + pe.matidx();
                        xmlpe.addAttribute("index", str);
                
                        apcount = pe.apcount();
                        for(i = 0; i < apcount; i++) {
                            ap = pe.arbeitsplan(i);
                            xmlap = new Element("Arbeitsplan");
                            str = "" + ap.zeitbasis();
                            xmlap.addAttribute("zeitbasis", str);
                            str = "" + ap.lst_id();
                            xmlap.addAttribute("lst_id", str);
                            xmlap.addAttribute("masch_te", numFormatter.format(ap.masch_te()));
                            xmlap.addAttribute("mae_te", numFormatter.format(ap.mae_te()));
                            xmlap.addAttribute("fra_te", numFormatter.format(ap.fra_te()));
                    
                            xmlpe.addContent(xmlap);
                        }
                
                        xmlsl = new Element("Stueckliste");
                
                        slecount = pe.slecount();
                
                        for(i = 0; i < slecount; i++) {
                            sle = pe.stuecklistenelement(i);
                            xmlsle = new Element("Untermaterial");
                            xmlsle.addAttribute("matschl", sle.articleno());
                            xmlsle.addAttribute("matbez", sle.articlename());
                            xmlsle.addAttribute("meschl", pe.unit());
                            str = "" + sle.article_id();
                            xmlsle.addAttribute("db_id", str);
                            str = "" + sle.matidx();
                            xmlsle.addAttribute("index", str);
                    
                            xmlsl.addContent(xmlsle);
                        }             
                        xmlpe.addContent(xmlsl);
                
                        numFormatter.setMinimumFractionDigits(2);
                        numFormatter.setMaximumFractionDigits(2);
                        for(b = 0; b < currentMaxWeek; b++) {
                            str = "" + myKalender.getPZAID(b);
                            xmlpza = new Element("PZA");
                            xmlpza.addAttribute("pza", str); 
                            xmlpza.addAttribute("pzabez", myKalender.pzabez(b)); 
                            xmlpza.addAttribute("output", numFormatter.format(pe.output(b)));
                            xmlpza.addAttribute("minmeng", numFormatter.format(pe.minmeng(b)));
                            xmlpza.addAttribute("quantl", numFormatter.format((pe.quantl(b)*100)));
                            xmlpe.addContent(xmlpza);
                        }
                        for(b = maxWeek; b < currentMaxPZA; b++) {
                            str = "" + myKalender.getPZAID(b);
                            xmlpza = new Element("PZA");                  
                            xmlpza.addAttribute("pza", str);
                            xmlpza.addAttribute("pzabez", myKalender.pzabez(b)); 
                            xmlpza.addAttribute("output", numFormatter.format(pe.output(b)));
                            xmlpza.addAttribute("minmeng", numFormatter.format(pe.minmeng(b)));
                            xmlpza.addAttribute("oquantl", numFormatter.format((pe.quantl(b)*100)));
                            xmlpe.addContent(xmlpza);
                        } 
                        xmlsort.addContent(xmlpe);
                    }
                    xmloe.addContent(xmlsort);
                    
                    // Ressourcen
                    xmlsort = new Element("Ressourcen");
                    numFormatter.setMinimumFractionDigits(2);
                    numFormatter.setMaximumFractionDigits(2);
                    for(b = 0; b < currentMaxWeek; b++) {
                        str = "" + myKalender.getPZAID(b);
                        xmlpza = new Element("PZA");
                        xmlpza.addAttribute("pza", str); 
                        xmlpza.addAttribute("pzabez", myKalender.pzabez(b)); 
                        xmlpza.addAttribute("schicht", numFormatter.format(oe.schicht(b)));
                        xmlpza.addAttribute("anzmasch", numFormatter.format(oe.anzmasch(b)));
                        xmlpza.addAttribute("anzmae", numFormatter.format(oe.anzmae(b)));
                        xmlpza.addAttribute("anzfra", numFormatter.format(oe.anzfra(b)));
                        xmlpza.addAttribute("auslmasch", numFormatter.format(oe.auslmasch(b)));
                        xmlpza.addAttribute("auslmae", numFormatter.format(oe.auslmae(b)));
                        xmlpza.addAttribute("auslfra", numFormatter.format(oe.auslfra(b)));
                        xmlvbk = new Element("Verfuegbarkeit");
                        for(d = 1; d < 4; d++) {
                            xmlsch = new Element("Schichtigkeit");
                            str = "" + d;
                            xmlsch.addAttribute("schichtig", str);
                            xmlsch.addAttribute("vbkmasch", numFormatter.format((oe.vbkMasch(b, d)*100)));
                            xmlsch.addAttribute("vbkmae", numFormatter.format((oe.vbkMae(b, d)*100)));
                            xmlsch.addAttribute("vbkfra", numFormatter.format((oe.vbkFra(b, d)*100))); 
                            xmlvbk.addContent(xmlsch);
                        }
                        xmlpza.addContent(xmlvbk);
                        xmlsort.addContent(xmlpza);       
                    }
                    for(b = maxWeek; b < currentMaxPZA; b++) {
                        str = "" + myKalender.getPZAID(b);
                        xmlpza = new Element("PZA");
                        xmlpza.addAttribute("pza", str); 
                        xmlpza.addAttribute("pzabez", myKalender.pzabez(b)); 
                        xmlpza.addAttribute("schicht", numFormatter.format(oe.schicht(b)));
                        xmlpza.addAttribute("anzmasch", numFormatter.format(oe.anzmasch(b)));
                        xmlpza.addAttribute("anzmae", numFormatter.format(oe.anzmae(b)));
                        xmlpza.addAttribute("anzfra", numFormatter.format(oe.anzfra(b)));
                        xmlpza.addAttribute("auslmasch", numFormatter.format(oe.auslmasch(b)));
                        xmlpza.addAttribute("auslmae", numFormatter.format(oe.auslmae(b)));
                        xmlpza.addAttribute("auslfra", numFormatter.format(oe.auslfra(b)));
                        xmlvbk = new Element("Verfuegbarkeit");
                        for(d = 1; d < 4; d++) {
                            xmlsch = new Element("Schichtigkeit");
                            str = "" + d;
                            xmlsch.addAttribute("schichtig", str);
                            xmlsch.addAttribute("vbkmasch", numFormatter.format((oe.vbkMasch(b, d)*100)));
                            xmlsch.addAttribute("vbkmae", numFormatter.format((oe.vbkMae(b, d)*100)));
                            xmlsch.addAttribute("vbkfra", numFormatter.format((oe.vbkFra(b, d)*100))); 
                            xmlvbk.addContent(xmlsch);
                        }
                        xmlpza.addContent(xmlvbk); 
                        xmlsort.addContent(xmlpza);
                    } 
                    xmloe.addContent(xmlsort);
                    
                    break;
                case 1:
                    // nur Lagersortiment bei echtem Lager
 
                    xmlsort = new Element("Sortiment");
                    lecount = oe.lecount();
                    for(e = 0; e < lecount; e++) {
                        le = oe.lagerelement(e);
                    // xmlpe = new Element(pe.articleno().trim());
                        xmlle = new Element("Material");
                        xmlle.addAttribute("matschl", le.articleno());
                        xmlle.addAttribute("matbez", le.articlename());
                        xmlle.addAttribute("meschl", le.unit());
                        str = "" + le.article_id();
                        xmlle.addAttribute("db_id", str);
                        str = "" + le.matidx();
                        xmlle.addAttribute("index", str);

                        numFormatter.setMinimumFractionDigits(2);
                        numFormatter.setMaximumFractionDigits(2);
                        for(b = 0; b < currentMaxWeek; b++) {
                            str = "" + myKalender.getPZAID(b);
                            xmlpza = new Element("PZA");
                            xmlpza.addAttribute("pza", str); 
                            xmlpza.addAttribute("pzabez", myKalender.pzabez(b)); 
                            xmlpza.addAttribute("output", numFormatter.format(le.output(b)));
                            xmlpza.addAttribute("input", numFormatter.format(le.input(b)));                        
                            xmlpza.addAttribute("anfbest", numFormatter.format(le.anfbest(b)));
                            xmlpza.addAttribute("endbest", numFormatter.format(le.endbest(b)));
                            xmlpza.addAttribute("reichw", numFormatter.format(le.reichw(b)));
                            xmlpza.addAttribute("ist_reichw", numFormatter.format(le.ist_reichw(b)));
                            xmlpza.addAttribute("minreichw", numFormatter.format(le.mreichw(b)));
                            xmlpza.addAttribute("maxreichw", numFormatter.format(le.hreichw(b)));
                            xmlpza.addAttribute("vorprod", numFormatter.format(le.vorprod(b)));
                            xmlpza.addAttribute("sollbest", numFormatter.format(le.sollbest(b)));
                            xmlpza.addAttribute("minbest", numFormatter.format(le.minbest(b)));
                            xmlpza.addAttribute("maxbest", numFormatter.format(le.maxbest(b)));
                            xmlle.addContent(xmlpza);
                        }
                        for(b = maxWeek; b < currentMaxPZA; b++) {
                            str = "" + myKalender.getPZAID(b);
                            xmlpza = new Element("PZA");
                            xmlpza.addAttribute("pza", str); 
                            xmlpza.addAttribute("pzabez", myKalender.pzabez(b)); 
                            xmlpza.addAttribute("output", numFormatter.format(le.output(b)));
                            xmlpza.addAttribute("input", numFormatter.format(le.input(b)));                        
                            xmlpza.addAttribute("anfbest", numFormatter.format(le.anfbest(b)));
                            xmlpza.addAttribute("endbest", numFormatter.format(le.endbest(b)));
                            xmlpza.addAttribute("reichw", numFormatter.format(le.reichw(b)));
                            xmlpza.addAttribute("ist_reichw", numFormatter.format(le.ist_reichw(b)));
                            xmlpza.addAttribute("minreichw", numFormatter.format(le.mreichw(b)));
                            xmlpza.addAttribute("maxreichw", numFormatter.format(le.hreichw(b)));
                            xmlpza.addAttribute("vorprod", numFormatter.format(le.vorprod(b)));
                            xmlpza.addAttribute("sollbest", numFormatter.format(le.sollbest(b)));
                            xmlpza.addAttribute("minbest", numFormatter.format(le.minbest(b)));
                            xmlpza.addAttribute("maxbest", numFormatter.format(le.maxbest(b)));
                            xmlle.addContent(xmlpza);
                        }
                        xmlsort.addContent(xmlle);
                    } 
                    xmloe.addContent(xmlsort);
                    break;
                case 0:
                // Einkauf
                    xmlsort = new Element("Sortiment");
                    eecount = oe.eecount();
                    for(e = 0; e < eecount; e++) {
                        ee = oe.einkaufselement(e);
                        // xmlpe = new Element(pe.articleno().trim());
                        xmlee = new Element("Einkaufsmaterial");
                        xmlee.addAttribute("matschl", ee.articleno());
                        xmlee.addAttribute("matbez", ee.articlename());
                        xmlee.addAttribute("meschl", ee.unit());
                        str = "" + ee.article_id();
                        xmlee.addAttribute("db_id", str);
                        str = "" + ee.matidx();
                        xmlee.addAttribute("index", str);

                        numFormatter.setMinimumFractionDigits(2);
                        numFormatter.setMaximumFractionDigits(2);
                        for(b = 0; b < currentMaxWeek; b++) {
                            str = "" + myKalender.getPZAID(b);
                            xmlpza = new Element("PZA");
                            xmlpza.addAttribute("pza", str); 
                            xmlpza.addAttribute("pzabez", myKalender.pzabez(b)); 
                            xmlpza.addAttribute("output", numFormatter.format(ee.output(b)));
                            xmlpza.addAttribute("minmeng", numFormatter.format(ee.minmeng(b)));
                            xmlpza.addAttribute("quantl", numFormatter.format((ee.quantl(b)*100)));
                            xmlee.addContent(xmlpza);
                        }
                        for(b = maxWeek; b < currentMaxPZA; b++) {
                            str = "" + myKalender.getPZAID(b);
                            xmlpza = new Element("PZA");
                            xmlpza.addAttribute("pza", str); 
                            xmlpza.addAttribute("pzabez", myKalender.pzabez(b)); 
                            xmlpza.addAttribute("output", numFormatter.format(ee.output(b)));
                            xmlpza.addAttribute("minmeng", numFormatter.format(ee.minmeng(b)));
                            xmlpza.addAttribute("quantl", numFormatter.format((ee.quantl(b)*100)));
                            xmlee.addContent(xmlpza);
                        } 
                        xmlsort.addContent(xmlee);
                    }
                    xmloe.addContent(xmlsort);
                    break;
                case 3:
                    xmlsort = new Element("Sortiment");
                    vecount = oe.vecount();
                    for(e = 0; e < vecount; e++) {
                        ve = oe.verkaufselement(e);
                        // xmlpe = new Element(pe.articleno().trim());
                        xmlve = new Element("Verkaufsmaterial");
                        xmlve.addAttribute("matschl", ve.articleno());
                        xmlve.addAttribute("matbez", ve.articlename());
                        xmlve.addAttribute("meschl", ve.unit());
                        str = "" + ve.article_id();
                        xmlve.addAttribute("db_id", str);
                        str = "" + ve.matidx();
                        xmlve.addAttribute("index", str);

                        numFormatter.setMinimumFractionDigits(2);
                        numFormatter.setMaximumFractionDigits(2);
                        for(b = 0; b < currentMaxWeek; b++) {
                            str = "" + myKalender.getPZAID(b);
                            xmlpza = new Element("PZA");
                            xmlpza.addAttribute("pza", str); 
                            xmlpza.addAttribute("pzabez", myKalender.pzabez(b)); 
                            xmlpza.addAttribute("bedarf", numFormatter.format(ve.amount(b)));
                            xmlpza.addAttribute("extra", numFormatter.format(ve.extraamount(b)));
                            xmlpza.addAttribute("rueck", numFormatter.format(ve.rueck(b)));
                            xmlve.addContent(xmlpza);
                        }
                        for(b = maxWeek; b < currentMaxPZA; b++) {
                            str = "" + myKalender.getPZAID(b);
                            xmlpza = new Element("PZA");
                            xmlpza.addAttribute("pza", str); 
                            xmlpza.addAttribute("pzabez", myKalender.pzabez(b)); 
                            xmlpza.addAttribute("bedarf", numFormatter.format(ve.amount(b)));
                            xmlpza.addAttribute("extra", numFormatter.format(ve.extraamount(b)));
                            xmlpza.addAttribute("rueck", numFormatter.format(ve.rueck(b)));
                            xmlve.addContent(xmlpza);
                        } 
                        xmlsort.addContent(xmlve);
                    }
                    xmloe.addContent(xmlsort);
                    break;
            }
            abo.addContent(xmloe);
        } 
        alo = new Element("Ablauforganisation");
        root.addContent(alo);
        matcount = myUModell.matcount();
        for(a = 0; a < matcount; a++) {
            mat = myUModell.getMatByIndex(a);
            xmlmat1 = new Element("Material");
            xmlmat1.setText("Hier erfolgt mit XPath zukuenftig der Verweis zur den OEs");
            xmlmat1.addAttribute("matschl", mat.matschl());
            xmlmat1.addAttribute("matbez", mat.matbez());
            xmlmat1.addAttribute("meschl", mat.meschl());
            str = "" + mat.article_id();
            xmlmat1.addAttribute("db_id", str);
            str = "" + a;
            xmlmat1.addAttribute("index", str);
            str = "" + mat.typ();
            xmlmat1.addAttribute("type", str);
            alo.addContent(xmlmat1);
        }    
        try {
            FileOutputStream out = new FileOutputStream("ppsexport.xml");
            XMLOutputter ser = new XMLOutputter();
            ser.output(doc, out);
            out.flush();
            out.close();          
        } catch(IOException exc) {
            System.err.println("NeRTHUS PPS: XMLExport: " + exc);
        }
        
        return;
    }

}
